Package: nleqslv
Version: 3.3.7
Title: Solve Systems of Nonlinear Equations
Authors@R: 
    c(person(given = "Berend",
           family = "Hasselman",
           role = c("aut"),
           email = "bhh@xs4all.nl",
           comment = "Original Author"),
      person(given = "Rob",
             family = "Carnell",
             role = c("aut", "cre"),
             email = "bertcarnell@gmail.com",
             comment = c(ORCID = "0009-0009-0465-7564")))
Description: Solve a system of nonlinear equations using a Broyden or a Newton method
             with a choice of global strategies such as line search and trust region.
             There are options for using a numerical or user supplied Jacobian,
             for specifying a banded numerical Jacobian and for allowing
             a singular or ill-conditioned Jacobian.
License: GPL (>= 2)
Encoding: UTF-8
URL: https://bertcarnell.github.io/nleqslv/,
        https://github.com/bertcarnell/nleqslv/
BugReports: https://github.com/bertcarnell/nleqslv/issues/
RoxygenNote: 7.3.3
NeedsCompilation: yes
Packaged: 2026-04-10 01:02:32 UTC; bertc
Author: Berend Hasselman [aut] (Original Author),
  Rob Carnell [aut, cre] (ORCID: <https://orcid.org/0009-0009-0465-7564>)
Maintainer: Rob Carnell <bertcarnell@gmail.com>
Repository: CRAN
Date/Publication: 2026-04-10 05:20:02 UTC
Suggests: testthat (>= 3.0.0)
Config/testthat/edition: 3
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-25 15:43:15 UTC; unix
Archs: nleqslv.so.dSYM

Package: nleqslv
Version: 3.3.7
Title: Solve Systems of Nonlinear Equations
Authors@R: 
    c(person(given = "Berend",
           family = "Hasselman",
           role = c("aut"),
           email = "bhh@xs4all.nl",
           comment = "Original Author"),
      person(given = "Rob",
             family = "Carnell",
             role = c("aut", "cre"),
             email = "bertcarnell@gmail.com",
             comment = c(ORCID = "0009-0009-0465-7564")))
Description: Solve a system of nonlinear equations using a Broyden or a Newton method
             with a choice of global strategies such as line search and trust region.
             There are options for using a numerical or user supplied Jacobian,
             for specifying a banded numerical Jacobian and for allowing
             a singular or ill-conditioned Jacobian.
License: GPL (>= 2)
Encoding: UTF-8
URL: https://bertcarnell.github.io/nleqslv/,
        https://github.com/bertcarnell/nleqslv/
BugReports: https://github.com/bertcarnell/nleqslv/issues/
RoxygenNote: 7.3.3
NeedsCompilation: yes
Packaged: 2026-04-10 01:02:32 UTC; bertc
Author: Berend Hasselman [aut] (Original Author),
  Rob Carnell [aut, cre] (ORCID: <https://orcid.org/0009-0009-0465-7564>)
Maintainer: Rob Carnell <bertcarnell@gmail.com>
Repository: CRAN
Date/Publication: 2026-04-10 05:20:02 UTC
Suggests: testthat (>= 3.0.0)
Config/testthat/edition: 3

# Copyright (c) 2026 Rob Carnell

#' The \pkg{nleqslv} package provides two algorithms for solving (dense)
#' nonlinear systems of equations.
#'
#' The methods provided are \itemize{ \item a
#' Broyden Secant method where the matrix of derivatives is updated after each
#' major iteration using the Broyden rank 1 update.  \item a full Newton method
#' where the Jacobian matrix of derivatives is recalculated at each iteration }
#' Both methods utilize global strategies such as line search or trust region
#' methods whenever the standard Newton/Broyden step does not lead to a point
#' closer to a root of the equation system. Both methods can also be used
#' without a norm reducing global strategy. Line search may be either cubic,
#' quadratic or geometric. The trust region methods are either the double
#' dogleg method, the Powell single dogleg method or a Levenberg-Marquardt type
#' method.
#'
#' There is a facility for specifying that the Jacobian is banded; this can
#' significantly speedup the calculation of a numerical Jacobian when the
#' number of sub- and super diagonals is small compared to the size of the
#' system of equations. For example the Jacobian of a tridiagonal system can be
#' calculated with only three evaluations of the function.
#'
#' The package provides an option to attempt to solve the system of equations
#' when the Jacobian is singular or ill-conditioned using an approximation to
#' the Moore-Penrose pseudoinverse of the Jacobian.
#'
#' The algorithms provided in this package are derived from Dennis and Schnabel
#' (1996). The code is written in Fortran 77 and Fortran 95 and uses Lapack and
#' BLAS routines as provided by the R system.
#'
#' @aliases nleqslv-package nleqslv.Intro
#' @references Dennis, J.E. Jr and Schnabel, R.B. (1996), \emph{Numerical
#' Methods for Unconstrained Optimization and Nonlinear Equations}, Siam.
#' @keywords internal
"_PACKAGE"

      subroutine nwmhlm(n,rjac,ldr,dn,g,xc,fcnorm,stepmx,xtol,
     *                  delta,qtf,scalex,fvec,d,xprev,
     *                  ssd,v,wa,fprev,xp,fp,fpnorm,retcd,gcnt,
     *                  priter,iter)

      integer ldr, n, retcd, gcnt, priter, iter
      double precision  fcnorm, stepmx, xtol, fpnorm, delta
      double precision  rjac(ldr,*), dn(*), g(*), xc(*), qtf(*)
      double precision  scalex(*), d(*)
      double precision  xprev(*), xp(*), fp(*)
      double precision  ssd(*), v(*), wa(*), fprev(*)
      external fvec

c-------------------------------------------------------------------------
c
c     Find a next iterate xp by the More-Hebden-Levenberg-Marquardt method
c
c     Arguments
c
c     In       n       Integer         size of problem: dimension x, f
c     In       Rjac    Real(ldr,*)     R of QR-factored jacobian
c     In       ldr     Integer         leading dimension of Rjac
c     Inout    dn      Real(*)         newton direction
c     Inout    g       Real(*)         gradient at current point
c                                      trans(jac)*f()
c     In       xc      Real(*)         current iterate
c     In       fcnorm  Real            .5*||f(xc)||**2
c     In       stepmx  Real            maximum stepsize
c     In       xtol    Real            x-tolerance (stepsize)
c     Inout    delta   Real            on input: initial trust region radius
c                                                if -1 then set to something
c                                                reasonable
c                                      on output: final value
c                                      ! Do not modify between calls while
c                                        still iterating
c     In       qtf     Real(*)         trans(Q)*f(xc)
c     In       scalex  Real(*)         scaling factors for x()
c     In       fvec    Name            name of subroutine to evaluate f(x)
c                                      ! must be declared external in caller
c     Wk       d       Real(*)         work vector
c     Wk       xprev   Real(*)         work vector
c     Wk       ssd     Real(*)         work vector
c     Wk       v       Real(*)         work vector
c     Wk       wa      Real(*)         work vector
c     Wk       fprev   Real(*)         work vector
c     Out      xp      Real(*)         new x()
c     Out      fp      Real(*)         new f(xp)
c     Out      fpnorm  Real            new .5*||f(xp)||**2
c     Out      retcd   Integer         return code
c                                       0  new satisfactory x() found
c                                       1  no  satisfactory x() found
c     Out      gcnt    Integer         number of steps taken
c     In       priter  Integer         print flag
c                                       -1 no intermediate printing
c                                       >0 yes for print of intermediate results
c     In       iter    Integer         current iteration (only used for above)
c
c     All vectors at least size n
c
c-------------------------------------------------------------------------

      integer i
      double precision  dnlen,glen,ssdlen,alpha,beta,mu,fpred
      double precision  fpnsav,oarg(6)
      double precision  dnrm2
      logical nwtstep
      integer dtype

      integer idamax

      double precision Rone, Rtwo, Rhalf
      parameter(Rhalf=0.5d0)
      parameter(Rone=1.0d0, Rtwo=2.0d0)

c     length newton direction

      dnlen = dnrm2(n, dn, 1)

c     gradient length and steepest descent direction and length

      glen  = dnrm2(n,g,1)
      alpha = glen**2

      call dcopy(n, g, 1, d, 1)
      call dtrmv('U','N','N',n,rjac,ldr,d,1)
      beta = dnrm2(n,d,1)**2

      call dcopy(n, g, 1, ssd, 1)
      call dscal(n, -(alpha/beta), ssd, 1)

      ssdlen = alpha*glen/beta

c     set trust radius to ssdlen or dnlen if required

      if( delta .eq. -Rone ) then
         delta = min(ssdlen, stepmx)
      elseif( delta .eq. -Rtwo ) then
         delta = min(dnlen, stepmx)
      endif

      retcd = 4
      gcnt  = 0

      do while( retcd .gt. 1 )
c        find new step by More Hebden LM  algorithm
c        reuse ssd as sdiag

         call nwmhstep(Rjac,ldr,n,ssd,qtf,dn,dnlen,glen,delta,mu,
     *                 d, v, dtype)
         nwtstep = dtype .eq. 2
c        compute the model prediction 0.5*||F + J*d||**2 (L2-norm)

         call dcopy(n,d,1,wa,1)
         call dtrmv('U','N','N',n,rjac,ldr,wa,1)
         call daxpy(n, Rone, qtf,1,wa,1)
         fpred = Rhalf * dnrm2(n,wa,1)**2

c        evaluate function at xp = xc + d

         do i=1,n
            xp(i) = xc(i) + d(i)
         enddo

         call nwfvec(xp,n,scalex,fvec,fp,fpnorm,wa)
         gcnt = gcnt + 1

c        check whether the global step is acceptable

         oarg(2) = delta
         call nwtrup(n,fcnorm,g,d,nwtstep,stepmx,xtol,delta,
     *               fpred,retcd,xprev,fpnsav,fprev,xp,fp,fpnorm)

         if( priter .gt. 0 ) then
            oarg(1) = mu
            oarg(3) = delta
            oarg(4) = dnrm2(n, d, 1)
            oarg(5) = fpnorm
            oarg(6) = abs(fp(idamax(n,fp,1)))
            call nwmhot(iter,dtype,retcd,oarg)
         endif

      enddo

      return
      end

c-----------------------------------------------------------------------

      subroutine nwmhstep(R,ldr,n,sdiag,qtf,dn,dnlen,glen,delta,mu,
     *                  d, work, dtype)
      integer ldr, n
      double precision R(ldr,*)
      double precision sdiag(*), qtf(*), dn(*), d(*), work(*)
      double precision  dnlen, glen, delta, mu
      integer dtype

c-------------------------------------------------------------------------
c
c     Find a new step by the More Hebden Levemberg Marquardt algorithm
c     Internal routine for nwmhlm
c
c     Arguments
c
c     In       R       Real(ldr,*)     R of QR-factored jacobian
c     In       ldr     Integer         leading dimension of R
c     In       n       Integer         size of problem
c     Out      sdiag   Real(*)         diagonal of LM lower triangular modified R
c     In       qtf     Real(*)         trans(Q)*f(xc)
c     In       dn      Real(*)         current newton step
c     Out      dnlen   Real            length dn()
c     In       glen    Real            length gradient
c     In       delta   Real            current trust region radius
c     Inout    mu      Real            Levenberg-Marquardt parameter
c     Out      d       Real(*)         new step for x()
c     Work     work    Real(*)         work vector for limhpar
c     Out      dtype   Integer         steptype
c                                       1 LM step
c                                       2 full newton direction
c
c-----------------------------------------------------------------------

      double precision Rone
      parameter(Rone=1.0D0)

      if(dnlen .le. delta) then

c        Newton step smaller than trust radius ==> take it

         call dcopy(n, dn, 1, d, 1)
         delta = dnlen
         dtype = 2

      else

c        calculate LM step
         call limhpar(R, ldr, n, sdiag, qtf, dn, dnlen, glen, delta,
     *                mu, d, work)
c        change sign of step d (limhpar solves for trans(R)*R+mu*I)=qtf instead of -qtf)
         call dscal(n,-Rone,d,1)
         dtype = 1
      endif

      return
      end

c-----------------------------------------------------------------------

      subroutine lirslv(R,ldr,n,cndtol, stepadj,
     *                  qtf,dn,ierr,rcond, rcdwrk,icdwrk)

      integer ldr,n,ierr
      double precision  cndtol,R(ldr,*)
      double precision  dn(*),qtf(*)
      double precision  rcdwrk(*)
      integer           icdwrk(*)
      double precision  rcond
      logical           stepadj

c-----------------------------------------------------------------------
c
c     Solve R * dn = -qtf safely with quard against ill-conditioning
c
c     Arguments
c
c     Inout    R       Real(ldr,*)     upper triangular matrix from QR
c                                      if ill conditioned result from liqrev
c                                      Levenberg-Marquardt correction
c                                      Warning: lower triangular part of R destroyed
c     In       ldr     Integer         leading dimension of R
c     In       n       Integer         dimension of problem
c     In       cndtol  Real            tolerance of test for ill conditioning
c     In       stepadj Logical         allow adjusting step for singular/illconditioned jacobian
c     In       qtf     Real(*)         trans(Q)*f()
c     Out      dn      Real(*)         Newton direction
c     Out      ierr    Integer         0 indicating Jacobian not ill-conditioned or singular
c                                      1 indicating Jacobian ill-conditioned
c                                      2 indicating Jacobian completely singular
c                                      3 indicating almost zero LM correction
c     Out      rcond   Real            inverse condition of upper triangular R of QR
c     Wk       rcdwrk  Real(*)         workspace
c     Wk       icdwrk  Integer(*)      workspace
c
c-----------------------------------------------------------------------

      integer k

      double precision Rone
      parameter(Rone=1.0d0)
      double precision mu

c     check for singularity or ill conditioning

      call cndjac(n,R,ldr,cndtol,rcond,rcdwrk,icdwrk,ierr)

      if( ierr .eq. 0 ) then
c         Normal Newton step
c         solve Jacobian*dn  =  -fn
c         ==> R*dn = - qtf

          call dcopy(n,qtf,1,dn,1)
          call dtrsv('U','N','N',n,r,ldr,dn,1)
          call dscal(n, -Rone, dn, 1)

      elseif( stepadj ) then
c         Adjusted Newton step
c         approximately from pseudoinverse(Jac+)
c         use mu to solve (trans(R)*R + mu*I*mu*I) * x = - trans(R) * fn
c         directly from the QR decomposition of R stacked with mu*I
c         a la Levenberg-Marquardt
          call compmu(R,ldr,n,mu,rcdwrk,ierr)
          if( ierr .eq. 0 ) then
             call liqrev(n,R,ldr,mu,qtf,dn,
     *                   rcdwrk(1+n),rcdwrk(2*n+1))
             call dscal(n, -Rone, dn, 1)

c            copy lower triangular R to upper triangular
             do k=1,n
                call dcopy (n-k+1,R(k,k),1,R(k,k),ldr)
                R(k,k) = rcdwrk(1+n+k-1)
             enddo
          endif
      endif

      return
      end

c-----------------------------------------------------------------------------

      subroutine liqrev(n,r,ldr,diag,b,x,sdiag,wrk)
      integer n,ldr
      double precision  r(ldr,*),b(*),x(*),sdiag(*),wrk(*)
      double precision diag

c-----------------------------------------------------------------------------
c
c     Arguments
c
c       In     n      Integer         order of R.
c       Inout  R      Real(ldr,*)     upper triangular matrix R from QR
c                                     unaltered
c                                     strict lower triangle contains
c                                        transposed strict upper triangle of the upper
c                                        triangular matrix S.
c
c       In     diag   Real            scalar for matrix D
c
c       In     ldr    Integer         leading dimension of the array R.
c       In     b      Real(*)         vector of size n
c
c       Out    x      Real(*)         vector of size n
c                                     on output contains least squares solution
c                                     of the system R*x = b, D*x = 0.
c
c       Out    sdiag  Real(*)         vector of size n, containing the
c                                     diagonal elements of the upper
c                                     triangular matrix S.
c
c       Out    wrk    Real(*)         workspace of size n.
c
c     Description
c
c     Given an n by n upper triangular matrix R, a diagonal matrix D with positive entries
c     and an n-vector b, determine an x which solves the system
c
c         |R*x| = |b|
c         |D*x| = |0|
c
c     in the least squares sense where D=diag*I.
c     This routine can be used for two different purposes.
c     The first is to provide a method of slightly modifying a singular or ill-conditioned matrix.
c     The second is for calculating a least squares solution to the above problem within
c     the context of e.g. a Levenberg-Marquardt algorithm combined with a More-Hebden algorithm
c     to determine a value of D (diagonal mu) such that x has a predetermined 2-norm.
c
c     The routine could also be used when the matrix R from the QR decomposition of a Jacobian
c     is ill-conditioned (or singular). Then it is difficult to calculate a Newton step
c     accurately (Dennis and Schnabel). D&S advise perturbing trans(J)*J with a positive
c     diagonal matrix.
c
c     The idea is  to solve (J^T * J + mu*I)x=b where mu is a small positive number.
c     Calculation of mu must be done in the calling routine.
c     Using a QR decomposition of J solving this system
c     is equivalent solving (R^T*R + mu*I)x=b, where R comes from the QR decomposition.
c     Solving this system is equivalent to solving the above least squares problem with the
c     elements of the matrix D set to sqrt(mu) which should be done in the calling routine.
c
c     On output the routine also provides an upper triangular matrix S such that
c     (see description of arguments above for the details)
c
c         (trans(R)*R + D*D) = trans(S)*S .
c
c     Method used here is described in
c     Nocedal and Wright, 2006, Numerical Optimization, Springer, ISBN 978-0-387-30303-1
c     page 258--261 (second edition)
c-----------------------------------------------------------------------------

      integer j,k
      double precision  bj,c,s,sum,temp
      double precision  ddot
      double precision Rzero
      parameter(Rzero=0.0d0)

c     copy R and b to preserve input and initialise S.
c     Save the diagonal elements of R in wrk.
c     Beware: the algorithm operates on an upper triangular matrix,
c     which is stored in lower triangle of R.
c
      do j=1,n
         call dcopy(n-j+1,r(j,j),ldr,r(j,j),1)
         wrk(j) = r(j,j)
      enddo
      call dcopy(n,b,1,x,1)

c     eliminate the diagonal matrix D using givens rotations.
c     Nocedal method: start at the bottom right
c     at end of loop R contains diagonal of S
c     save in sdiag and restore original diagonal of R

      do j=n,1,-1

c        initialise the row of D to be eliminated

         call nuzero(n-j+1,sdiag(j))
         sdiag(j) = diag

c        the transformations to eliminate the row of D

         bj = Rzero
         do k=j,n

c           determine a givens rotation which eliminates the
c           appropriate element in the current row of D.
c           accumulate the transformation in the row of S.

c           eliminate the diagonal element in row j of D
c           this generates fill-in in columns [j+1 .. n] of row j of D
c           successively eliminate the fill-in with givens rotations
c           for R[j+1,j+1] and D[j,j+1].
c           rows of R have been copied into the columns of R initially (see above)
c           perform all operations on those columns to preserve the original R

            if (sdiag(k) .ne. Rzero) then

               call nuvgiv(r(k,k),sdiag(k),c,s)
               if( k .lt. n ) then
                   call drot(n-k,r(k+1,k),1,sdiag(k+1),1,c,s)
               endif

c              compute the modified element of (b,0).

               temp =  c*x(k) + s*bj
               bj   = -s*x(k) + c*bj
               x(k) = temp

            endif

         enddo

      enddo

c     retrieve diagonal of S from diagonal of R
c     restore original diagonal of R

      do k=1,n
         sdiag(k) = r(k,k)
         r(k,k) = wrk(k)
      enddo

c     x now contains modified b
c     solve trans(S)*x = x
c     still to be done: guard against division by 0 to be absolutely safe
c     call dblepr('liqrev sdiag', 12, sdiag, n)
      x(n) = x(n) / sdiag(n)
      do j=n-1,1,-1
         sum  = ddot(n-j,r(j+1,j),1,x(j+1),1)
         x(j) = (x(j) - sum)/sdiag(j)
      enddo

      return
      end

c ----------------------------------------------------------------------

      subroutine dtrstt(S,ldr,n,sdiag,x)
      integer ldr, n
      double precision S(ldr,*), sdiag(*), x(*)
      integer j
      double precision sum, ddot

c     solve S*x = x where x is the result from subroutine liqrev
c     S is a lower triangular matrix with diagonal entries in sdiag()
c     and here it is in the lower triangular part of R as returned by liqrev

      x(1) = x(1) / sdiag(1)
      do j=2,n
         sum  = ddot(j-1,S(j,1),n,x,1)
         x(j) = (x(j) - sum)/sdiag(j)
      enddo

      return
      end

      subroutine nwqlsh(n,xc,fcnorm,d,g,stepmx,xtol,scalex,fvec,
     *                  xp,fp,fpnorm,xw,retcd,gcnt,priter,iter)

      integer n,retcd,gcnt
      double precision  stepmx,xtol,fcnorm,fpnorm
      double precision  xc(*)
      double precision  d(*),g(*),xp(*),fp(*),xw(*)
      double precision  scalex(*)
      external fvec

      integer priter,iter

c-------------------------------------------------------------------------
c
c     Find a next acceptable iterate using a safeguarded quadratic line search
c     along the newton direction
c
c     Arguments
c
c     In       n       Integer          dimension of problem
c     In       xc      Real(*)          current iterate
c     In       fcnorm  Real             0.5 * || f(xc) ||**2
c     In       d       Real(*)          newton direction
c     In       g       Real(*)          gradient at current iterate
c     In       stepmx  Real             maximum stepsize
c     In       xtol    Real             relative step size at which
c                                       successive iterates are considered
c                                       close enough to terminate algorithm
c     In       scalex  Real(*)          diagonal scaling matrix for x()
c     In       fvec    Name             name of routine to calculate f()
c     In       xp      Real(*)          new x()
c     In       fp      Real(*)          new f(x)
c     In       fpnorm  Real             .5*||fp||**2
c     Out      xw      Real(*)           workspace for unscaling x(*)
c
c     Out      retcd   Integer          return code
c                                         0 new satisfactory x() found
c                                         1 no  satisfactory x() found
c                                           sufficiently distinct from xc()
c
c     Out      gcnt    Integer          number of steps taken
c     In       priter  Integer           >0 unit if intermediate steps to be printed
c                                        -1 if no printing
c
c-------------------------------------------------------------------------

      integer i
      double precision  alpha,slope,rsclen,oarg(4)
      double precision  lambda,lamhi,lamlo,t
      double precision  ddot,dnrm2, nudnrm, ftarg
      double precision  dlen

      integer idamax

      parameter (alpha = 1.0d-4)

      double precision Rone, Rtwo, Rten
      parameter(Rone=1.0d0, Rtwo=2.0d0, Rten=10.0d0)

c     safeguard initial step size

      dlen = dnrm2(n,d,1)
      if( dlen .gt. stepmx ) then
          lamhi  = stepmx / dlen
      else
          lamhi  = Rone
      endif

c     compute slope  =  g-trans * d

      slope = ddot(n,g,1,d,1)

c     compute the smallest value allowable for the damping
c     parameter lambda ==> lamlo

      rsclen = nudnrm(n,d,xc)
      lamlo  = xtol / rsclen

c     initialization of retcd and lambda (linesearch length)

      retcd  = 2
      lambda = lamhi
      gcnt   = 0

      do while( retcd .eq. 2 )

c        compute next x

         do i=1,n
            xp(i) = xc(i) + lambda*d(i)
         enddo

c        evaluate functions and the objective function at xp

         call nwfvec(xp,n,scalex,fvec,fp,fpnorm,xw)
         gcnt = gcnt + 1
         ftarg = fcnorm + alpha * lambda * slope

         if( priter .gt. 0) then
            oarg(1) = lambda
            oarg(2) = ftarg
            oarg(3) = fpnorm
            oarg(4) = abs(fp(idamax(n,fp,1)))
            call nwlsot(iter,1,oarg)
         endif

c        test whether the standard step produces enough decrease
c        of the objective function.
c        If not update lambda and compute a new next iterate

         if( fpnorm .le. ftarg ) then
            retcd = 0
         else
            t = ((-lambda**2)*slope/Rtwo)/(fpnorm-fcnorm-lambda*slope)
            lambda  = max(lambda / Rten , t)
            if(lambda .lt. lamlo) then
               retcd = 1
            endif
         endif

      enddo

      return
      end

      subroutine liqrup(Q,ldq,n,R,ldr,u,v,wk)
      integer ldq,n,ldr
      double precision Q(ldq,*),R(ldr,*),u(*),v(*),wk(*)

c-----------------------------------------------------------------------------
c
c     Arguments
c
c     Inout  Q       Real(ldq,n)      orthogonal matrix from QR
c     In     ldq     Integer          leading dimension of Q
c     In     n       Integer          order of Q and R
c     Inout  R       Real(ldr,n)      upper triangular matrix R from QR
c     In     ldr     Integer          leading dimension of R
c     In     u       Real(*)          vector u of size n
c     In     v       Real(*)          vector v of size n
c     Out    wk      Real(*)          workspace of size n
c
c     on return
c
c        Q       Q is the matrix with orthonormal columns in a QR
c                decomposition of the matrix B = A + u*v'
c
c        R       R is the upper triangular matrix in a QR
c                decomposition of the matrix B = A + u*v'
c
c     Description
c
c     The matrices Q and R are a QR decomposition of a square matrix
c     A = Q*R.
c     Given Q and R, qrupdt computes a QR decomposition of the rank one
c     modification B = A + u*trans(v) of A. Here u and v are vectors.
c
c     Code based on Reichel and Cragg and simplified and modernized
c           Reichel, L. and W.B. Gragg (1990), Algorithm 686: FORTRAN subroutines for updating the QR decomposition,
c           ACM Trans. Math. Softw., 16, 4, pp. 369--377.
c
c-----------------------------------------------------------------------------

c     Local variables and functions

      integer k,i
      double precision  ddot, c, s

c     calculate wk = trans(Q)*u

      do i=1,n
         wk(i) = ddot(n,Q(1,i),1,u,1)
      enddo

c     nuvgiv uses Lapack dlartg and
c     sets its first argument x to value of the last argument returned by dlartg.

c     zero components wk(n),wk(n-1)...wk(2)
c     and apply rotators to R and Q.

      do k=n-1,1,-1
         call nuvgiv(wk(k),wk(k+1),c,s)
         call drot(n-k+1,R(k,k),ldr,R(k+1,k),ldr,c,s)
         call drot(n    ,Q(1,k),1  ,Q(1,k+1),1  ,c,s)
      enddo

c     r(1,1:n) += wk(1)*v(1:n)
      call daxpy(n,wk(1),v,1,R(1,1),ldr)

c     R is of upper hessenberg form. Triangularize R.

      do k=1,n-1
         call nuvgiv(R(k,k),R(k+1,k),c,s)
         call drot(n-k,R(k,k+1),ldr,R(k+1,k+1),ldr,c,s)
         call drot(n  ,Q(1,k)  ,1  ,Q(1,k+1)  ,1  ,c,s)
      enddo

      return
      end

c-----------------------------------------------------------------------------

      subroutine liqrfa(a, lda, n, tau, work, wsiz, info)
      integer  lda, n, wsiz, info
      double precision  a(lda,*), tau(*), work(*)

c-------------------------------------------------------------
c
c     QR decomposition of A(n,n)
c
c     Arguments
c
c      Inout A        Real(Lda,n)    Matrix to transform.
c      In    lda      Integer        Leading dimension of A
c      In    n        Integer        number of rows/cols A
c      Out   tau      Real(n)        Information for recovering
c      Out   work     Real(*)        workspace
c      In    wsiz     Integer        size of work()

c     Lapack blocked QR (much faster for larger n)
c
c-------------------------------------------------------------

      call dgeqrf(n,n,A,lda,tau,work,wsiz,info)

      return
      end

c=============================================================

      subroutine liqsiz(n,wrksiz)
      integer n, wrksiz

c-------------------------------------------------------------------------
c     Query the size of the double precision work array required
c     for optimal operation of the Lapack QR routines
c-------------------------------------------------------------------------

      double precision A(1), work(1)
      integer lwork, info

      lwork = -1
      call dgeqrf(n,n,A,n,work,work,lwork,info)
      if( info .ne. 0 ) then
          wrksiz = -1
      else
          wrksiz = int(work(1))
      endif

      return
      end

c=============================================================

      subroutine liqrqt(a, lda, n, tau, qty, work, wsiz, info)
      integer lda, n, wsiz, info
      double precision a(lda,*), tau(*), qty(*), work(*)

c-------------------------------------------------------------
c      Arguments
c
c      In    A     Real(Lda, n)    QR decomposition
c      In    Lda   Integer         Leading dimension A
c      In    n     Integer         Number of rows/columns in A
c      In    tau   Integer         Householder constants from QR
c      Inout qty   Real(n)         On input, vector y
c                                  On output, trans(Q)*y
c      Out   work  Real(*)         workspace
c      In    wsiz  Integer         size of work()
c
c     Liqrqt calculates trans(Q)*y from the QR decomposition
c
c     Lapack blocked
c-------------------------------------------------------------

      call dormqr('L','T',n,1,n,A,lda,tau,qty,n,work,wsiz,info)

      return
      end

c=============================================================

      subroutine liqrqq(q,ldq,tau,n,work,wsiz,info)
      integer n, ldq, wsiz, info
      double precision  q(ldq,*),tau(*),work(*)

c     Arguments
c
c     Inout  Q     Real(ldq,*)     On input, QR decomposition
c                                    On output, the full Q
c     In     ldq   Integer         leading dimension of Q
c     In     tau   Real(n)         Householder constants of
c                                     the QR decomposition
c     In     n     Integer         number of rows/columns in Q
c     Out    work  Real(n)         workspace of length n
c     In     wsiz  Integer         size of work()
c
c     Generate Q from QR decomposition Liqrfa (dgeqr2)
c
c     Lapack blocked
c-------------------------------------------------------------

      call dorgqr(n,n,n,q,ldq,tau,work,wsiz,info)

      return
      end

c-----------------------------------------------------------------------------

      subroutine nuzero(n,x)
      integer n
      double precision x(*)

c     Parameters:
c
c     In    n        Integer           Number of elements.
c     In    x        Real(*)           Vector of reals.
c
c     Description:
c
c     Nuzero sets all elements of x to 0.
c     Does nothing when n <= 0

      double precision Rzero
      parameter(Rzero=0.0d0)

      integer i

      do i=1,n
         x(i) = Rzero
      enddo

      return
      end

c ----------------------------------------------------------------------

      subroutine nuvgiv(x,y,c,s)
      double precision x,y,c,s

c     Parameters
c
c     Inout   x     Real       x input / c*x+s*y on output
c     Inout   y     Real       y input / 0       on output
c     Out     c     Real       c of tranformation (cosine)
c     Out     s     Real       s of tranformation (  sine)
c
c     Description
c
c     Nuvgiv calculates the givens rotator
c
c             |  c   s |
c         G = |        |
c             | -s   c |
c
c     with  c*c+s*s=1
c
c     for which G * | x | = | t |
c                   | y |   | 0 |
c
c     resulting in
c
c            c * x + s * y = t
c           -s * x + c * y = 0   ==>  s/c = y/x or c/s = x/y
c
c     Use Lapack dlartg routine
c     return c and s and the modified x and y
c     This differs from dlartg which does not modify input arguments.
c     See http://www.netlib.org/lapack/explore-html/dd/d24/dlartg_8f_source.html
c     c * x + s * y may differ from t with machine precision

      double precision t

      double precision Rzero
      parameter(Rzero=0.0d0)

      call dlartg(x,y,c,s,t)
      x = t
      y = Rzero
      return
      end

      subroutine nwsolv(ldr,xc,n,scalex,maxit,
     *                  jacflg,xtol,ftol,btol,cndtol,global,xscalm,
     *                  stepmx,delta,sigma,
     *                  rjac,wrk1,wrk2,wrk3,wrk4,fc,fq,dn,d,qtf,
     *                  rcdwrk,icdwrk,qrwork,qrwsiz,epsm,
     *                  fjac,fvec,outopt,xp,fp,gp,njcnt,nfcnt,iter,
     *                  termcd)

      integer ldr,n,termcd,njcnt,nfcnt,iter
      integer maxit,jacflg(*),global,xscalm,qrwsiz
      integer outopt(*)
      double precision  xtol,ftol,btol,cndtol
      double precision  stepmx,delta,sigma,fpnorm,epsm
      double precision  rjac(ldr,*)
      double precision  xc(*),fc(*),xp(*),fp(*),dn(*),d(*)
      double precision  wrk1(*),wrk2(*),wrk3(*),wrk4(*)
      double precision  qtf(*),gp(*),fq(*)
      double precision  scalex(*)
      double precision  rcdwrk(*),qrwork(*)
      integer           icdwrk(*)
      external fjac,fvec

c-----------------------------------------------------------------------
c
c     Solve system of nonlinear equations with Newton and global strategy
c
c
c     Arguments
c
c     In       ldr     Integer         leading dimension of rjac
c     In       xc      Real(*)         initial estimate of solution
c     In       n       Integer         dimensions of problem
c     Inout    scalex  Real(*)         scaling factors x(*)
c     In       maxit   Integer         maximum number of allowable iterations
c     In       jacflg  Integer(*)      jacobian flag array
c                                      jacflg[1]:  0 numeric; 1 user supplied; 2 numerical banded
c                                                  3: user supplied banded
c                                      jacflg[2]: number of sub diagonals or -1 if not banded
c                                      jacflg[3]: number of super diagonals or -1 if not banded
c                                      jacflg[4]: 1 if adjusting step allowed when
c                                                   singular or illconditioned
c     In       xtol    Real            tolerance at which successive iterates x()
c                                      are considered close enough to
c                                      terminate algorithm
c     In       ftol    Real            tolerance at which function values f()
c                                      are considered close enough to zero
c     Inout    btol    Real            x tolerance for backtracking
c     Inout    cndtol  Real            tolerance of test for ill conditioning
c     In       global  Integer         global strategy to use
c                                        1 cubic linesearch
c                                        2 quadratic linesearch
c                                        3 geometric linesearch
c                                        4 double dogleg
c                                        5 powell dogleg
c                                        6 hookstep (More-Hebden Levenberg-Marquardt)
c     In       xscalm  Integer         x scaling method
c                                        1 from column norms of first jacobian
c                                          increased if needed after first iteration
c                                        0 scaling user supplied
c     In       stepmx  Real            maximum allowable step size
c     In       delta   Real            trust region radius
c     In       sigma   Real            reduction factor geometric linesearch
c     Inout    rjac    Real(ldr,*)     jacobian (n columns)
c     Wk       wrk1    Real(*)         workspace
c     Wk       wrk2    Real(*)         workspace
c     Wk       wrk3    Real(*)         workspace
c     Wk       wrk4    Real(*)         workspace
c     Inout    fc      Real(*)         function values f(xc)
c     Wk       fq      Real(*)         workspace
c     Wk       dn      Real(*)         workspace
c     Wk       d       Real(*)         workspace
c     Wk       qtf     Real(*)         workspace
c     Wk       rcdwrk  Real(*)         workspace
c     Wk       icdwrk  Integer(*)      workspace
c     In       qrwork  Real(*)         workspace for Lapack QR routines (call liqsiz)
c     In       qrwsiz  Integer         size of qrwork
c     In       epsm    Real            machine precision
c     In       fjac    Name            name of routine to calculate jacobian
c                                      (optional)
c     In       fvec    Name            name of routine to calculate f()
c     In       outopt  Integer(*)      output options
c     Out      xp      Real(*)         final x()
c     Out      fp      Real(*)         final f(xp)
c     Out      gp      Real(*)         gradient at xp()
c     Out      njcnt   Integer         number of jacobian evaluations
c     Out      nfcnt   Integer         number of function evaluations
c     Out      iter    Integer         number of (outer) iterations
c     Out      termcd  Integer         termination code
c
c-----------------------------------------------------------------------

      integer gcnt,retcd,ierr
      double precision  dum(2),fcnorm,rcond
      logical fstjac
      integer priter

      integer idamax

c     initialization

      retcd = 0
      iter  = 0
      njcnt = 0
      nfcnt = 0
      ierr  = 0

      dum(1) = 0

      if( outopt(1) .eq. 1 ) then
         priter = 1
      else
         priter = -1
      endif

c     evaluate function

      call vscal(n,xc,scalex)
      call nwfvec(xc,n,scalex,fvec,fc,fcnorm,wrk1)

c     evaluate user supplied or finite difference jacobian and check user supplied
c     jacobian, if requested

      fstjac = .false.
      if(mod(jacflg(1),2) .eq. 1) then

        if( outopt(2) .eq. 1 ) then
           fstjac = .true.
           njcnt = njcnt + 1
           call nwfjac(xc,scalex,fc,fq,n,epsm,jacflg,fvec,fjac,rjac,
     *                 ldr,wrk1,wrk2,wrk3)
           call chkjac(rjac,ldr,xc,fc,n,epsm,jacflg,scalex,
     *                 fq,wrk1,wrk2,fvec,termcd)
           if(termcd .lt. 0) then
c              copy initial values
               call dcopy(n,xc,1,xp,1)
               call dcopy(n,fc,1,fp,1)
               call vunsc(n,xp,scalex)
               fpnorm = fcnorm
               return
           endif
        endif

      endif

c     check stopping criteria for input xc

      call nwtcvg(xc,fc,xc,xtol,retcd,ftol,iter,maxit,n,ierr,termcd)

      if(termcd .gt. 0) then
          call dcopy(n,xc,1,xp,1)
          call dcopy(n,fc,1,fp,1)
          fpnorm = fcnorm
          if( outopt(3) .eq. 1 .and. .not. fstjac ) then
             njcnt = njcnt + 1
             call nwfjac(xp,scalex,fp,fq,n,epsm,jacflg,fvec,fjac,rjac,
     *                   ldr,wrk1,wrk2,wrk3)
          endif
          return
      endif

      if( priter .gt. 0 ) then

         dum(1) = fcnorm
         dum(2) = abs(fc(idamax(n,fc,1)))

         if( global .eq. 0 ) then
            call nwprot(iter, -1, dum)
         elseif( global .le. 3 ) then
            call nwlsot(iter,-1,dum)
         elseif( global .eq. 4 ) then
            call nwdgot(iter,-1,0,dum)
         elseif( global .eq. 5 ) then
            call nwpwot(iter,-1,0,dum)
         elseif( global .eq. 6 ) then
            call nwmhot(iter,-1,0,dum)
         endif

      endif

      do while( termcd .eq. 0 )
         iter = iter + 1

         call nwnjac(rjac,ldr,n,xc,fc,fq,fvec,fjac,epsm,jacflg,wrk1,
     *               wrk2,wrk3,
     *               xscalm,scalex,gp,cndtol,rcdwrk,icdwrk,dn,
     *               qtf,rcond,qrwork,qrwsiz,njcnt,iter,fstjac,ierr)
c        - choose the next iterate xp by a global strategy

         if( ierr .gt. 0 ) then
c           jacobian singular or too ill-conditioned
            call nweset(n,xc,fc,fcnorm,xp,fp,fpnorm,gcnt,priter,iter)
         elseif(global .eq. 0) then
            call nwpure(n,xc,dn,stepmx,scalex,
     *                  fvec,xp,fp,fpnorm,wrk1,retcd,gcnt,
     *                  priter,iter)
         elseif(global .eq. 1) then
            call nwclsh(n,xc,fcnorm,dn,gp,stepmx,btol,scalex,
     *                  fvec,xp,fp,fpnorm,wrk1,retcd,gcnt,
     *                  priter,iter)
         elseif(global .eq. 2) then
            call nwqlsh(n,xc,fcnorm,dn,gp,stepmx,btol,scalex,
     *                  fvec,xp,fp,fpnorm,wrk1,retcd,gcnt,
     *                  priter,iter)
         elseif(global .eq. 3) then
            call nwglsh(n,xc,fcnorm,dn,gp,sigma,stepmx,btol,scalex,
     *                  fvec,xp,fp,fpnorm,wrk1,retcd,gcnt,
     *                  priter,iter)
         elseif(global .eq. 4) then
            call nwddlg(n,rjac,ldr,dn,gp,xc,fcnorm,stepmx,
     *                  btol,delta,qtf,scalex,
     *                  fvec,d,fq,wrk1,wrk2,wrk3,wrk4,
     *                  xp,fp,fpnorm,retcd,gcnt,priter,iter)
         elseif(global .eq. 5) then
            call nwpdlg(n,rjac,ldr,dn,gp,xc,fcnorm,stepmx,
     *                  btol,delta,qtf,scalex,
     *                  fvec,d,fq,wrk1,wrk2,wrk3,wrk4,
     *                  xp,fp,fpnorm,retcd,gcnt,priter,iter)
         elseif(global .eq. 6) then
            call nwmhlm(n,rjac,ldr,dn,gp,xc,fcnorm,stepmx,
     *                  btol,delta,qtf,scalex,
     *                  fvec,d,fq,wrk1,wrk2,wrk3,wrk4,
     *                  xp,fp,fpnorm,retcd,gcnt,priter,iter)
         endif

         nfcnt = nfcnt + gcnt

c        - check stopping criteria for the new iterate xp

         call nwtcvg(xp,fp,xc,xtol,retcd,ftol,iter,maxit,n,ierr,termcd)

         if(termcd .eq. 0) then
c           update xc, fc, and fcnorm
            call dcopy(n,xp,1,xc,1)
            call dcopy(n,fp,1,fc,1)
            fcnorm = fpnorm
         endif

      enddo

      if( outopt(3) .eq. 1 ) then
         call nwfjac(xp,scalex,fp,fq,n,epsm,jacflg,fvec,fjac,rjac,
     *               ldr,wrk1,wrk2,wrk3)
      endif

      call vunsc(n,xp,scalex)

      return
      end

library("nleqslv")

# Dennis & Schnabel,1996,"Numerical methods for unconstrained optimization and nonlinear equations", SIAM
# example 6.5.1 page 149

dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1]-1) + x[2]^3 - 2
    y
}

jacdsln <- function(x) {
    n <- length(x)
    Df <- matrix(numeric(n*n),n,n)
    Df[1,1] <- 2*x[1]
    Df[1,2] <- 2*x[2]
    Df[2,1] <- exp(x[1]-1)
    Df[2,2] <- 3*x[2]^2

    Df
}

xstart <- c(2,0.5)
fstart <- dslnex(xstart)
xstart
fstart

# a solution is c(1,1)

do.print.xf <- FALSE

print.result <- function(z) {
    if( do.print.xf ) {
        print(z$x)
        print(z$fvec)
    }
    print(z$message)
    print(all(abs(z$fvec)<=1e-8))
}

# Broyden numerical Jacobian
for( z in c("cline", "qline", "gline") ) {  # cubic, quadratic, geometric linesearch
    znlq <- nleqslv(xstart, dslnex, global=z,control=list(btol=.01))
    print.result(znlq)
}

# Broyden numerical Jacobian
for( z in c("dbldog","pwldog") ) {  # double dogleg, Powell (single) dogleg
    for( delta in c(-1.0, -2.0) ) { # Cauchy step , Newton step
        znlq <- nleqslv(xstart, dslnex, global=z, control=list(btol=.01,delta=delta))
        print.result(znlq)
    }
}

# Broyden analytical jacobian
for( z in c("dbldog","pwldog") ) {  # double dogleg, Powell (single) dogleg
    for( delta in c(-1.0, -2.0) ) { # Cauchy step , Newton step
        znlq <- nleqslv(xstart, dslnex, jacdsln, global=z, control=list(btol=.01,delta=delta))
        print.result(znlq)
    }
}

# Newton analytical jacobian
for( z in c("dbldog","pwldog") ) {  # double dogleg, Powell (single) dogleg
    for( delta in c(-1.0, -2.0) ) { # Cauchy step , Newton step
        znlq <- nleqslv(xstart, dslnex, jacdsln, method="Newton", global=z, control=list(btol=.01,delta=delta))
        print.result(znlq)
    }
}

# Copyright (c) Rob Carnell 2026

test_that("Jacobian handling in nleqslv matches analytic Jacobian for dslnex", {
  skip_if_not_installed("nleqslv")
  library(nleqslv)

  # Dennis & Schnabel example 6.5.1
  dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1] - 1) + x[2]^3 - 2
    y
  }

  jacdsln <- function(x) {
    n <- length(x)
    Df <- matrix(0, n, n)
    Df[1, 1] <- 2 * x[1]
    Df[1, 2] <- 2 * x[2]
    Df[2, 1] <- exp(x[1] - 1)
    Df[2, 2] <- 3 * x[2]^2
    Df
  }

  converged <- function(z) all(abs(z$fvec) <= 1e-8)

  xstart <- c(2, 0.5)

  # 1. Internal Jacobian
  z1 <- nleqslv(xstart, dslnex, jacobian = TRUE, control = list(trace = 0))
  expect_true(converged(z1))
  expect_equal(z1$jac, jacdsln(z1$x), tolerance = 0.05)

  # 2. User-supplied Jacobian
  z2 <- nleqslv(xstart, dslnex, jacdsln, jacobian = TRUE, control = list(trace = 0))
  expect_true(converged(z2))
  expect_equal(z2$jac, jacdsln(z2$x), tolerance = 0.05)

  # 3. Newton method, internal Jacobian
  z3 <- nleqslv(xstart, dslnex, method = "Newton", jacobian = TRUE,
                control = list(trace = 0))
  expect_true(converged(z3))
  expect_equal(
    z3$jac,
    jacdsln(z3$x),
    tolerance = 1e3 * sqrt(.Machine$double.eps)
  )

  # 4. Newton method, user-supplied Jacobian
  z4 <- nleqslv(xstart, dslnex, jacdsln, method = "Newton", jacobian = TRUE,
                control = list(trace = 0))
  expect_true(converged(z4))
  expect_identical(z4$jac, jacdsln(z4$x))
})

# Copyright (c) Rob Carnell 2026

test_that("multiple functions with nleqslv", {
  func_list <- list(brown, brown, dcbval, dciequ, helval, pwlsng, rosbrk,
                    vardim, watson, watson, wood, pwlbsc, dslnex,
                    f_nocedal, sinexp, sinexp, troesch, kearfott,
                    hdp, twoip, broyden_f1, broyden_f1,
                    broyden_f2, broyden_f2, broyden_f2, broyden_f2,
                    broyden_f7, boggs, octxmpl)
  start_list <- list(brown_xstart(10), brown_xstart(20), dcbval_xstart(10),
                     dciequ_xstart(10), helval_xstart, pwlsng_xstart,
                     rosbrk_xstart, vardiminit(10), watson_xstart(6),
                     watson_xstart(9), wood_xstart, pwlbsc_xstart,
                     dslnex_xstart, nocedal_xstart,
                     sinexp_xstart(0.25), sinexp_xstart(0.75),
                     troesch_xstart(50), kearfott_xstart,
                     hdp_xstart, twoip_xstart, c(0, 0), c(1, 1),
                     c(1, 1, 0), c(-1, 1, 0), c(1, -1, 0), c(-1, -1, 0),
                     broyden_f7_xstart, boggs_xstart, octxmpl_xstart)

  expect_equal(length(func_list), length(start_list))

  for (i in seq_along(func_list)) {
    soln <- nleqslv(start_list[[i]], func_list[[i]], control = list(maxit=300))
    expect_true(soln$termcd %in% c(1, 4))
    expect_equal(soln$message, expectedMessage1)
    expect_true(all(abs(soln$fvec) <= 1e-6))
  }
})

test_that("multiple functions with testnslv", {
  func_list <- list(brown, dcbval, dciequ, helval, pwlsng, rosbrk,
                    vardim, watson, watson, wood, pwlbsc)
  start_list <- list(brown_xstart(20), dcbval_xstart(10), dciequ_xstart(10),
                     helval_xstart, pwlsng_xstart, rosbrk_xstart, vardiminit(10),
                     watson_xstart(6), watson_xstart(9), wood_xstart, pwlbsc_xstart)

  expect_equal(length(func_list), length(start_list))

  for (i in seq_along(func_list)) {
    soln <- testnslv(start_list[[i]], func_list[[i]])
    expect_true(inherits(soln, "test.nleqslv"))
    expect_true(is.data.frame(soln$out))
    expect_true(all(soln$out$termcd %in% c(1,4,5,6)))
    # expect_true(all(soln$out$Iter < 92)) # macos latest fails this test on 3/22/2026
  }
})

test_that("vardim", {
  soln <- nleqslv(vardiminit(10), vardim)
  expect_equal(vardimsol(10), soln$x)

  soln <- nleqslv(vardiminit(5), vardim)
  expect_equal(vardimsol(5), soln$x)
})

test_that("with jacobian", {
  func_list <- list(pwlbsc, chandraH, chandraH, broyden_f7, bkrust, li5,
                    neum1, pcex)
  start_list <- list(pwlbsc_xstart, chandra_xstart(50), chandra_xstart(100),
                     broyden_f7_xstart, bkrust_xstart, li5_xstart,
                     neum1_xstart, pcex_xstart)
  jac_list <- list(pwlbscjac, chandraH.jac, chandraH.jac, broyden_f7jac,
                   bkrjac, li5jac, neum1jac, pcexjac)

  expect_equal(length(func_list), length(start_list))
  expect_equal(length(func_list), length(jac_list))

  for (i in seq_along(func_list)) {
    if (identical(func_list[[i]], li5)) {
      soln <- nleqslv(start_list[[i]], func_list[[i]], jac_list[[i]], global = "gline")
    } else {
      soln <- nleqslv(start_list[[i]], func_list[[i]], jac_list[[i]])
    }
    expect_true(soln$termcd %in% c(1,3))
    expect_true(all(abs(soln$fvec) <= 1e-4))
  }
})

test_that("dslnex solutions", {
  z <- nleqslv(dslnex_xstart, dslnex, jacobian=TRUE)
  expect_equal(jacdsln(z$x), z$jac, tolerance = 0.1, ignore_attr = TRUE)

  z <- nleqslv(dslnex_xstart, dslnex, global="none", jacobian=TRUE)
  expect_equal(jacdsln(z$x), z$jac, tolerance = 0.1, ignore_attr = TRUE)

  z <- nleqslv(dslnex_xstart, dslnex, method="Newton", jacobian=TRUE)
  expect_equal(jacdsln(z$x), z$jac, tolerance = 0.1, ignore_attr = TRUE)

  z <- nleqslv(dslnex_xstart, dslnex, method="Newton", jacobian=TRUE, global="none")
  expect_equal(jacdsln(z$x), z$jac, tolerance = 0.1, ignore_attr = TRUE)

  dslnex_xstart <- c(2, .5)

  z <- nleqslv(dslnex_xstart, dslnex, jacobian=TRUE)
  expect_equal(jacdsln(z$x), z$jac, tolerance = 0.1, ignore_attr = TRUE)

  z <- nleqslv(dslnex_xstart, dslnex, method="Newton", jacobian=TRUE)
  expect_equal(jacdsln(z$x), z$jac, tolerance = 0.1, ignore_attr = TRUE)

  set.seed(11)

  dslnex_xstart <- matrix(runif(50, -3, 3), ncol=2)
  temp <- searchZeros(dslnex_xstart, dslnex)
  # two solutions of two values
  expect_equal(nrow(temp$x), 2)
  expect_equal(ncol(temp$x), 2)
  expect_true(all(apply(temp$x, 1, dslnex) < 1E-9))

})

test_that("nocedal", {
  z <- nleqslv(nocedal_xstart, f_nocedal, global="none")
  expect_equal(z$fvec, c(0, 0), tolerance = 1E-9)
  z <- nleqslv(nocedal_xstart, f_nocedal, method="Newton")
  expect_equal(z$fvec, c(0, 0), tolerance = 1E-9)
  z <- nleqslv(nocedal_xstart, f_nocedal, jac_nocedal, method="Newton")
  expect_equal(z$fvec, c(0, 0), tolerance = 1E-9)
  expect_equal(jac_nocedal(c(0,1)), jac_nocedal(z$x), tolerance = 1E-9)
})

test_that("sinexp searchZeros", {
  N <- 5
  set.seed(11)
  xstart <- cbind(runif(N, min=0.25, max=1), runif(N, min=1.5, max=2*pi))

  temp <- searchZeros(xstart, sinexp, method="Broyden", global="dbldog")

  expect_equal(nrow(temp$x), 2)
  expect_equal(ncol(temp$x), 2)
  expect_true(all(abs(apply(temp$x, 1, sinexp)) < 1E-8))
})

test_that("circle", {
  act <- circle.intersect(xc1,xc2,r0,r1)
  temp1 <- nleqslv(c(0,0), fcircle, xc1=xc1, xc2=xc2, r0=r0, r1=r1)
  temp2 <- nleqslv(c(2,2), fcircle, xc1=xc1, xc2=xc2, r0=r0, r1=r1)

  expect_equal(act$P2, temp1$x)
  expect_equal(act$P1, temp2$x)

  xstart <- matrix(c(0,0,2,2),nrow=2,byrow=TRUE)
  sz <- searchZeros(xstart, fcircle, xc1=xc1, xc2=xc2, r0=r0, r1=r1)
  expect_true(all(abs(act$P1 - sz$x[1,]) < 1E-6) |
                all(abs(act$P1 - sz$x[2,]) < 1E-6))
  expect_true(all(abs(act$P2 - sz$x[1,]) < 1E-6) |
                all(abs(act$P2 - sz$x[2,]) < 1E-6))

})

test_that("cutlip", {
  # paper has wrong order of parameters
  # use the Fortran program to get the correct values

  # parameter set 1
  k1 <-  31.24
  k2 <-  2.062
  k3 <-  303.03
  kr1 <-  0.272
  kr2 <-  0.02

  # initial estimate and solutions page 1464
  xinit1 <- c(0.99, 0.05, 0.05, 0.99, 0.05, 0)
  xinit2 <- c(0.05, 0.99, 0.05, 0.05, 0.99, 0)
  xinit3 <- c(0.05, 0.5, 2, 0.05, 0.99, 0.5)

  # solution Table IV (parameter set; used here)
  xsolA <- c(0.97007,0.98005,0.05985,0.99003,0.0000997,0.009873)
  xsolB <- c(0.035614, 0.35708, 1.9288, 0.035997,0.088409, 0.87559)
  xsolC <- c(1.03329,1.02220,-0.066597,-0.000109,1.00114, -0.00103)

  temp1 <- nleqslv(xinit1, cutlip, k1=k1, k2=k2, k3=k3, kr1=kr1, kr2=kr2)
  expect_equal(temp1$x, xsolA, tolerance = 1E-5)
  temp2 <- nleqslv(xinit2, cutlip, k1=k1, k2=k2, k3=k3, kr1=kr1, kr2=kr2)
  expect_equal(temp2$x, xsolC, tolerance = 1E-5)
  temp3 <- nleqslv(xinit3, cutlip, k1=k1, k2=k2, k3=k3, kr1=kr1, kr2=kr2,
                   method="Broyden", global="dbldog")
  expect_equal(temp3$x, xsolB, tolerance = 1E-4)

  # parameter set 2
  k1 <-  17.721
  k2 <-  3.483
  k3 <-  505.051
  kr1 <- 0.118
  kr2 <- 0.033

  # initial estimate and solutions page 1464
  xinit1 <- c(0.99, 0.05, 0.05, 0.99, 0.05, 0)
  xinit2 <- c(0.05, 0.99, 0.05, 0.05, 0.99, 0)

  # solution Table V (parameter set 2; used here)

  xsolA <- c(0.94994,0.96662,0.10013,0.98999,0.0001001,0.009913)
  xsolB <- c(0.11766,0.41177,1.7647 ,0.003045,0.57362, 0.42334)
  xsolC <- c(1.0698,1.04655,-0.13967,-0.0001377,1.003822, -0.003684)

  temp1 <- nleqslv(xinit1, cutlip, k1=k1, k2=k2, k3=k3, kr1=kr1, kr2=kr2)
  expect_equal(temp1$x, xsolA, tolerance = 1E-5)
  temp2 <- nleqslv(xinit2, cutlip, k1=k1, k2=k2, k3=k3, kr1=kr1, kr2=kr2)
  expect_equal(temp2$x, xsolC, tolerance = 1E-4)

  # parameter set 3
  k1 <-  17.721
  k2 <-  6.996
  k3 <-  505.051
  kr1 <- 0.118
  kr2 <- 333.333

  # initial estimate and solutions page 1464
  xinit1 <- c(0.99, 0.05, 0.05, 0.99, 0.05, 0)

  # solution Table VI (parameter set; used here)
  xsolA <- c(0.94994,0.96662,0.10013,0.98999,0.0001001,0.009913)

  # xinit2 does not converge; iteration limit exceeded
  temp1 <- nleqslv(xinit1, cutlip, k1=k1, k2=k2, k3=k3, kr1=kr1, kr2=kr2)
  expect_equal(temp1$x, xsolA, tolerance = 1E-3)
})

test_that("kuno seader", {
  N <- 100
  xstart <- matrix(runif(2*N, min=-5, max=5), N, 2)

  z <- searchZeros(xstart, kunoseader_f)
  expect_equal(nrow(z$x), 7)

  Nrep <- 90
  Ncol <- 3
  xstart <- matrix(runif(Ncol*Nrep, min=0, max=1), Nrep, Ncol)

  z <- searchZeros(xstart, kunoseader_f34)
  expect_equal(nrow(z$x), 4)
})

test_that("econ with const", {
  const <- rep(0, 20)
  xstart <- rep(1, 20) / 20

  temp <- nleqslv(xstart, econ, const = const)
  expect_true(all(temp$fvec < 1E-8))
  test_temp <- testnslv(xstart, econ, const = const,
                        global = c("cline", "qline", "pwldob", "dbldog"))
  expect_true(all(test_temp$out$Fnorm < 1E-12))
})

test_that("hiebert", {
  xstart <- c(1, 1, 10, 1, 1, 1, 0, 0, 0, 0)

  temp <- nleqslv(xstart, hiebert, R=10)
  expect_true(all(temp$fvec < 1E-8))
  test_temp <- testnslv(xstart, hiebert, R=10, method = "Newton")
  expect_true(all(test_temp$out$Fnorm < 1E-12))
})

test_that("pce", {
  soln <- nleqslv(pcex_xstart, pcex, pcexjac, method="Broyden", global="hook",
                  control=list(trace=0, delta="cauchy", ftol=1e-6, xtol=1e-5))
  expect_equal(soln$x, pcex_xsol, tolerance = 1E-3)
})

test_that("frac", {
  for( k in 1:7 ) {
    a <- k/10
    xstart <- c(a,1-a, max(0.4-0.5*a,0.1))
    z <- nleqslv(xstart, frac2, control=list(stepmax=.1))
    expect_true(all(abs(z$fvec) < 1E-8))
  }
})

#
# Interface to Fortran library for solving a system of nonlinear equations
# with either a Broyden or a full Newton method
# There a six global search methods:
#   cubic, quadratic and geometric linesearch
#   double dogleg trust region a la Dennis Schnabel
#   powell single dogleg a la Minpack
#   so-called hook step (Levenberg-Marquardt)
#



#' Solving systems of nonlinear equations with Broyden or Newton
#'
#' The function solves a system of nonlinear equations with either a Broyden or
#' a full Newton method. It provides line search and trust region global
#' strategies for difficult systems.
#'
#' The algorithms implemented in \code{nleqslv} are based on Dennis and
#' Schnabel (1996).
#'
#' \subsection{Methods}{
#'
#' Method \code{Broyden} starts with a computed Jacobian of the function and
#' then updates this Jacobian after each successful iteration using the
#' so-called Broyden update. This method often shows super linear convergence
#' towards a solution. When \code{nleqslv} determines that it cannot continue
#' with the current Broyden matrix it will compute a new Jacobian.
#'
#' Method \code{Newton} calculates a Jacobian of the function \code{fn} at each
#' iteration. Close to a solution this method will usually show quadratic
#' convergence.
#'
#' Both methods apply a so-called (backtracking) global strategy to find a
#' better (more acceptable) iterate.  The function criterion used by the
#' algorithm is half of the sum of squares of the function values and
#' \dQuote{acceptable} means sufficient decrease of the current function
#' criterion value compared to that of the previous iteration. A comprehensive
#' discussion of these issues can be found in Dennis and Schnabel (1996). Both
#' methods apply an unpivoted QR-decomposition to the Jacobian as implemented
#' in Lapack. The Broyden method applies a rank-1 update to the Jacobian at the
#' end of each iteration and is based on a simplified and modernized version of
#' the algorithm described in Reichel and Gragg (1990). }
#'
#' \subsection{Global strategies}{
#'
#' When applying a full Newton or Broyden step does not yield a sufficiently
#' smaller function criterion value \code{nleqslv} will attempt to decrease the
#' steplength using one of several so-called global strategies.
#'
#' The \code{global} argument indicates which global strategy to use or to use
#' no global strategy \describe{ \item{\code{cline}}{a cubic line search}
#' \item{\code{qline}}{a quadratic line search} \item{\code{gline}}{a
#' geometric line search} \item{\code{dbldog}}{a trust region method using the
#' double dogleg method as described in Dennis and Schnabel (1996)}
#' \item{\code{pwldog}}{a trust region method using the Powell dogleg method
#' as developed by Powell (1970).} \item{\code{hook}}{a trust region method
#' described by Dennis and Schnabel (1996) as \emph{The locally constrained
#' optimal (\dQuote{hook}) step}.  It is equivalent to a Levenberg-Marquardt
#' algorithm as described in \enc{MoréMore}{MoreMore} (1978) and Nocedal and Wright
#' (2006).} \item{\code{none}}{Only a pure local Newton or Broyden iteration
#' is used.  The maximum stepsize (see below) is taken into account.  The
#' default maximum number of iterations (see below) is set to 20.} } The double
#' dogleg method is the default global strategy employed by this package.
#'
#' Which global strategy to use in a particular situation is a matter of trial
#' and error. When one of the trust region methods fails, one of the line
#' search strategies should be tried. Sometimes a trust region will work and
#' sometimes a line search method; neither has a clear advantage but in many
#' cases the double dogleg method works quite well.
#'
#' When the function to be solved returns non-finite function values for a
#' parameter vector \code{x} and the algorithm is \emph{not} evaluating a
#' numerical Jacobian, then any non-finite values will be replaced by a large
#' number forcing the algorithm to backtrack, i.e. decrease the line search
#' factor or decrease the trust region radius. }
#'
#' \subsection{Scaling}{
#'
#' The elements of vector \code{x} may be scaled during the search for a zero
#' of \code{fn}. The \code{xscalm} argument provides two possibilities for
#' scaling \describe{ \item{\code{fixed}}{the scaling factors are set to the
#' values supplied in the \code{control} argument and remain unchanged during
#' the iterations.  The scaling factor of any element of \code{x} should be set
#' to the inverse of the typical value of that element of \code{x}, ensuring
#' that all elements of \code{x} are approximately equal in size.}
#'
#' \item{\code{auto}}{the scaling factors are calculated from the euclidean
#' norms of the columns of the Jacobian matrix.  When a new Jacobian is
#' computed, the scaling values will be set to the euclidean norm of the
#' corresponding column if that is larger than the current scaling value.  Thus
#' the scaling values will not decrease during the iteration.  This is the
#' method described in \enc{MoréMore}{MoreMore} (1978).  Usually manual scaling is
#' preferable.} } }
#'
#' \subsection{Jacobian}{
#'
#' When evaluating a numerical Jacobian, an error message will be issued on
#' detecting non-finite function values. An error message will also be issued
#' when a user supplied jacobian contains non-finite entries.
#'
#' When the \code{jacobian} argument is set to \code{TRUE} the final Jacobian
#' or Broyden matrix will be returned in the return list. The default value is
#' \code{FALSE}; i.e. to not return the final matrix. There is no guarantee
#' that the final Broyden matrix resembles the actual Jacobian.
#'
#' The package can cope with a singular or ill-conditioned Jacobian if needed
#' by setting the \code{allowSingular} component of the \code{control}
#' argument. The method used is described in Dennis and Schnabel (1996); it is
#' equivalent to a Levenberg-Marquardt type adjustment with a small damping
#' factor. \emph{There is no guarantee that this method will be successful.}
#' Warning: \emph{\code{nleqslv} may report spurious convergence in this case.}
#'
#' By default \code{nleqslv} returns an error if a Jacobian becomes singular or
#' very ill-conditioned. A Jacobian is considered to be very ill-conditioned
#' when the estimated inverse condition is less than or equal to a specified
#' tolerance with a default value equal to \eqn{10^{-12}}{1e-12}; this can be
#' changed and made smaller with the \code{cndtol} item of the \code{control}
#' argument. \emph{There is no guarantee that any change will be effective.} }
#'
#' \subsection{Control options}{
#'
#' The \code{control} argument is a named list that can supply any of the
#' following components: \describe{ \item{\code{xtol}}{The relative steplength
#' tolerance.  When the relative steplength of all scaled x values is smaller
#' than this value convergence is declared. The default value is
#' \eqn{10^{-8}}{1e-8}.  }
#'
#' \item{\code{ftol}}{The function value tolerance.  Convergence is declared
#' when the largest absolute function value is smaller than \code{ftol}.  The
#' default value is \eqn{10^{-8}}{1e-8}.  }
#'
#' \item{\code{btol}}{The backtracking tolerance.  When the relative
#' steplength in a backtracking step to find an acceptable point is smaller
#' than the backtracking tolerance, the backtracking is terminated.  In the
#' \code{Broyden} method a new Jacobian will be calculated if the Jacobian is
#' outdated.  The default value is \eqn{10^{-3}}{1e-3}.  }
#'
#' \item{\code{cndtol}}{The tolerance of the test for ill conditioning of the
#' Jacobian or Broyden approximation. If less than the machine precision it
#' will be silently set to the machine precision.  When the estimated inverse
#' condition of the (approximated) Jacobian matrix is less than or equal to the
#' value of \code{cndtol} the matrix is deemed to be ill-conditioned, in which
#' case an error will be reported if the \code{allowSingular} component is set
#' to \code{FALSE}.  The default value is \eqn{10^{-12}}{1e-12}.  }
#'
#' \item{\code{sigma}}{Reduction factor for the geometric line search. The
#' default value is 0.5.}
#'
#' \item{\code{scalex}}{a vector of scaling values for the parameters.  The
#' inverse of a scale value is an indication of the size of a parameter.  The
#' default value is 1.0 for all scale values.}
#'
#' \item{\code{maxit}}{The maximum number of major iterations.  The default
#' value is 150 if a global strategy has been specified.  If no global strategy
#' has been specified the default is 20.}
#'
#' \item{\code{trace}}{Non-negative integer. A value of 1 will give a detailed
#' report of the progress of the iteration. For a description see
#' \code{\link{Iteration-report}}.}
#'
#' \item{\code{chkjac}}{A logical value indicating whether to check a user
#' supplied Jacobian, if supplied. The default value is \code{FALSE}. The first
#' 10 errors are printed.  The code for this check is derived from the code in
#' Bouaricha and Schnabel (1997).}
#'
#' \item{\code{delta}}{Initial (scaled) trust region radius.  A value of
#' \eqn{-1.0} or \code{"cauchy"} is replaced by the length of the Cauchy step
#' in the initial point.  A value of \eqn{-2.0} or \code{"newton"} is replaced
#' by the length of the Newton step in the initial point.  Any numeric value
#' less than or equal to 0 and not equal to \eqn{-2.0}, will be replaced by
#' \eqn{-1.0}; the algorithm will then start with the length of the Cauchy step
#' in the initial point.  If it is numeric and positive it will be set to the
#' smaller of the value supplied or the maximum stepsize.  If it is not numeric
#' and not one of the permitted character strings then an error message will be
#' issued.  The default is \eqn{-2.0}.}
#'
#' \item{\code{stepmax}}{Maximum scaled stepsize.  If this is negative then
#' the maximum stepsize is set to the largest positive representable number.
#' The default is \eqn{-1.0}, so there is no default maximum stepsize.}
#'
#' \item{\code{dsub}}{Number of non zero subdiagonals of a banded Jacobian.
#' The default is to assume that the Jacobian is \emph{not} banded.  Must be
#' specified if \code{dsuper} has been specified and must be larger than zero
#' when \code{dsuper} is zero.}
#'
#' \item{\code{dsuper}}{Number of non zero super diagonals of a banded
#' Jacobian.  The default is to assume that the Jacobian is \emph{not} banded.
#' Must be specified if \code{dsub} has been specified and must be larger than
#' zero when \code{dsub} is zero.}
#'
#' \item{\code{allowSingular}}{A logical value indicating if a small
#' correction to the Jacobian when it is singular or too ill-conditioned is
#' allowed.  If the correction is less than \code{100*.Machine$double.eps} the
#' correction cannot be applied and an unusable Jacobian will be reported.  The
#' method used is similar to a Levenberg-Marquardt correction and is explained
#' in Dennis and Schnabel (1996) on page 151.  It may be necessary to choose a
#' higher value for \code{cndtol} to enforce the correction.  The default value
#' is \code{FALSE}.  } } }
#'
#' @param x A numeric vector with an initial guess of the root of the function.
#' @param fn A function of \code{x} returning a vector of function values with
#' the same length as the vector \code{x}.
#' @param jac A function to return the Jacobian for the \code{fn} function.
#' For a vector valued function \code{fn} the Jacobian must be a numeric matrix
#' of the correct dimensions.  For a scalar valued function \code{fn} the
#' \code{jac} function may return a scalar.  If not supplied numerical
#' derivatives will be used.
#' @param \dots Further arguments to be passed to \code{fn} and \code{jac}.
#' @param method The method to use for finding a solution. See
#' \sQuote{Details}.
#' @param global The global strategy to apply. See \sQuote{Details}.
#' @param xscalm The type of x scaling to use. See \sQuote{Details}.
#' @param jacobian A logical indicating if the estimated (approximate) jacobian
#' in the solution should be returned.  See \sQuote{Details}.
#' @param control A named list of control parameters. See \sQuote{Details}.
#' @return A list containing components \item{x}{final values for x}
#' \item{fvec}{function values} \item{termcd}{termination code as integer.  The
#' values returned are \describe{ \item{\code{1}}{Function criterion is near
#' zero.  Convergence of function values has been achieved.}
#' \item{\code{2}}{x-values within tolerance. This means that the relative
#' distance between two consecutive x-values is smaller than \code{xtol} but
#' that the function value criterion is still larger than \code{ftol}.
#' \emph{Function values may not be near zero; therefore the user must check if
#' function values are acceptably small.}} \item{\code{3}}{No better point
#' found.  This means that the algorithm has stalled and cannot find an
#' acceptable new point.  This may or may not indicate acceptably small
#' function values.} \item{\code{4}}{Iteration limit \code{maxit} exceeded.}
#' \item{\code{5}}{Jacobian is too ill-conditioned.} \item{\code{6}}{Jacobian
#' is singular.} \item{\code{7}}{Jacobian is unusable.}
#' \item{\code{-10}}{User supplied Jacobian is most likely incorrect.} } }
#' \item{message}{a string describing the termination code} \item{scalex}{a
#' vector containing the scaling factors, which will be the final values when
#' automatic scaling was selected} \item{njcnt}{number of Jacobian evaluations}
#' \item{nfcnt}{number of function evaluations, excluding those required for
#' calculating a Jacobian and excluding the initial function evaluation (at
#' iteration 0)} \item{iter}{number of outer iterations used by the algorithm.
#' This excludes the initial iteration.  The number of backtracks can be
#' calculated as the difference between the \code{nfcnt} and \code{iter}
#' components.} \item{jac}{the final Jacobian or the Broyden approximation if
#' \code{jacobian} was set to \code{TRUE}.  If no iterations were executed, as
#' may happen when the initial guess are sufficiently close the solution, there
#' is no Broyden approximation and the returned matrix will always be the
#' actual Jacobian.  If the matrix is singular or too ill-conditioned the
#' returned matrix is of no value.}
#' @section Warning: You cannot use this function recursively. Thus function
#' \code{fn} should not in its turn call \code{nleqslv}.
#' @seealso If this function cannot solve the supplied function then it is a
#' good idea to try the function \link{testnslv} in this package. For detecting
#' multiple solutions see \link{searchZeros}.
#' @references Bouaricha, A. and Schnabel, R.B. (1997), Algorithm 768:
#' TENSOLVE: A Software Package for Solving Systems of Nonlinear Equations and
#' Nonlinear Least-squares Problems Using Tensor Methods, \emph{Transactions on
#' Mathematical Software}, \bold{23}, 2, pp. 174--195.
#'
#' Dennis, J.E. Jr and Schnabel, R.B. (1996), \emph{Numerical Methods for
#' Unconstrained Optimization and Nonlinear Equations}, Siam.
#'
#' \enc{MoréMore}{MoreMore}, J.J. (1978), The Levenberg-Marquardt Algorithm,
#' Implementation and Theory, In \emph{Numerical Analysis}, G.A. Watson (Ed.),
#' Lecture Notes in Mathematics 630, Springer-Verlag, pp. 105--116.
#'
#' Golub, G.H and C.F. Van Loan (1996), Matrix Computations (3rd edition), The
#' John Hopkins University Press.
#'
#' Higham, N.J. (2002), Accuracy and Stability of Numerical Algorithms, 2nd
#' ed., SIAM, pp. 10--11.
#'
#' Nocedal, J. and Wright, S.J. (2006), \emph{Numerical Optimization},
#' Springer.
#'
#' Powell, M.J.D. (1970), A hybrid method for nonlinear algebraic equations, In
#' \emph{Numerical Methods for Nonlinear Algebraic Equations}, P. Rabinowitz
#' (Ed.), Gordon & Breach.
#'
#' Powell, M.J.D. (1970), A Fortran subroutine for solving systems nonlinear
#' equations, In \emph{Numerical Methods for Nonlinear Algebraic Equations}, P.
#' Rabinowitz (Ed.), Gordon & Breach.
#'
#' % QRupdate: a Fortran library for fast updating of QR and Cholesky
#' decompositions, % \url{http://sourceforge.net/projects/qrupdate/}.
#'
#' Reichel, L. and W.B. Gragg (1990), Algorithm 686: FORTRAN subroutines for
#' updating the QR decomposition, \emph{ACM Trans. Math. Softw.}, \bold{16}, 4,
#' pp. 369--377.
#' @keywords nonlinear optimize
#' @useDynLib nleqslv, .registration=TRUE, .fixes="C_"
#' @examples
#'
#' # Dennis Schnabel example 6.5.1 page 149
#' dslnex <- function(x) {
#'     y <- numeric(2)
#'     y[1] <- x[1]^2 + x[2]^2 - 2
#'     y[2] <- exp(x[1]-1) + x[2]^3 - 2
#'     y
#' }
#'
#' jacdsln <- function(x) {
#'     n <- length(x)
#'     Df <- matrix(numeric(n*n),n,n)
#'     Df[1,1] <- 2*x[1]
#'     Df[1,2] <- 2*x[2]
#'     Df[2,1] <- exp(x[1]-1)
#'     Df[2,2] <- 3*x[2]^2
#'
#'     Df
#' }
#'
#' BADjacdsln <- function(x) {
#'     n <- length(x)
#'     Df <- matrix(numeric(n*n),n,n)
#'     Df[1,1] <- 4*x[1]
#'     Df[1,2] <- 2*x[2]
#'     Df[2,1] <- exp(x[1]-1)
#'     Df[2,2] <- 5*x[2]^2
#'
#'     Df
#' }
#'
#' xstart <- c(2,0.5)
#' fstart <- dslnex(xstart)
#' xstart
#' fstart
#'
#' # a solution is c(1,1)
#'
#' nleqslv(xstart, dslnex, control=list(btol=.01))
#'
#' # Cauchy start
#' nleqslv(xstart, dslnex, control=list(trace=1,btol=.01,delta="cauchy"))
#'
#' # Newton start
#' nleqslv(xstart, dslnex, control=list(trace=1,btol=.01,delta="newton"))
#'
#' # final Broyden approximation of Jacobian (quite good)
#' z <- nleqslv(xstart, dslnex, jacobian=TRUE,control=list(btol=.01))
#' z$x
#' z$jac
#' jacdsln(z$x)
#'
#' # different initial start; not a very good final approximation
#' xstart <- c(0.5,2)
#' z <- nleqslv(xstart, dslnex, jacobian=TRUE,control=list(btol=.01))
#' z$x
#' z$jac
#' jacdsln(z$x)
#'
#' \dontrun{
#' # no global strategy but limit stepsize
#' # but look carefully: a different solution is found
#' nleqslv(xstart, dslnex, method="Newton", global="none", control=list(trace=1,stepmax=5))
#'
#' # but if the stepsize is limited even more the c(1,1) solution is found
#' nleqslv(xstart, dslnex, method="Newton", global="none", control=list(trace=1,stepmax=2))
#'
#' # Broyden also finds the c(1,1) solution when the stepsize is limited
#' nleqslv(xstart, dslnex, jacdsln, method="Broyden", global="none", control=list(trace=1,stepmax=2))
#' }
#'
#' # example with a singular jacobian in the initial guess
#' f <- function(x) {
#'     y <- numeric(3)
#'     y[1] <- x[1] + x[2] - x[1]*x[2] - 2
#'     y[2] <- x[1] + x[3] - x[1]*x[3] - 3
#'     y[3] <- x[2] + x[3] - 4
#'     return(y)
#' }
#'
#' Jac <- function(x) {
#'     J <- matrix(0,nrow=3,ncol=3)
#'     J[,1] <- c(1-x[2],1-x[3],0)
#'     J[,2] <- c(1-x[1],0,1)
#'     J[,3] <- c(0,1-x[1],1)
#'     J
#' }
#'
#' # exact solution
#' xsol <- c(-.5, 5/3 , 7/3)
#' xsol
#'
#' xstart <- c(1,2,3)
#' J <- Jac(xstart)
#' J
#' rcond(J)
#'
#' z <- nleqslv(xstart,f,Jac, method="Newton",control=list(trace=1,allowSingular=TRUE))
#' all.equal(z$x,xsol)
#'
#' @export nleqslv
nleqslv <- function(x, fn, jac = NULL, ...,
                    method = c("Broyden", "Newton"),
                    global = c("dbldog", "pwldog", "cline", "qline", "gline", "hook", "none"),
                    xscalm = c("fixed","auto"),
                    jacobian=FALSE,
                    control = list())
{
    fn1  <- function(par) fn(par, ...)

    if( is.null(jac ) ) {
        jacfunc <- NULL
    } else {
        if(!is.function(jac)) stop("argument 'jac' is not a function!")
        jacfunc <- function(par) jac(par, ...)
    }

    method <- match.arg(method)
    global <- match.arg(global)
    xscalm <- match.arg(xscalm)

    ## Defaults
    con <- list(ftol=1e-8, xtol=1e-8,
                btol=1e-3,
                stepmax=-1.0, delta="newton", sigma=0.5,
                scalex = rep(1, length(x)),
                maxit=150,
                trace=0,
                chkjac=FALSE,
                cndtol=1e-12,
                allowSingular=FALSE,
                dsub=-1L,
                dsuper=-1L
               )

    # limit maximum number of iterations for pure local strategy
    if( global == "none" ) con$maxit=20

    # strict validity test of control
    # based on test of control argument in nlminb
    if( length(control) ) {
        namc <- names(control)
        if( !is.list(control) || is.null(namc) )
            stop("'control' argument must be a named list")
        # check names of control argument
        if( !all(namc %in% names(con)) )
            stop("unknown names in control: ", paste(sQuote(namc[!(namc %in% names(con))]), collapse=", "))
        con[namc] <- control
    }

    tmp <- con[["delta"]]
    if( is.character(tmp) ) {
        k <- match(tolower(tmp), c("cauchy","newton"))
        con[["delta"]] <- as.numeric(-k)
    }
    else if( !is.numeric(tmp) ) stop('control["delta"] should be either character or numeric')

    # to reset flag for checking recursive calls (not allowed for now)
    on.exit(.C(C_deactivatenleq))
    out <- .Call(C_nleqslv, x, fn1, jacfunc, method, global, xscalm, jacobian, con, new.env())

    out
}

# Copyright (c) Rob Carnell 2026

# More, Garbow, Hillstrom: Testing Unconstrained Optimization Software
# ACM Trans. Math. Software, 7, March 1981, 17--41
# Function as shown in this paper is for optimizing not for non linear equations
# from the paper it is not clear what was used by the authors for their tests
# of non linear equation solvers
# function 35

# slightly modified from original
# this version taken from Julia's package NLsolve test
# Burkardt (https://people.sc.fsu.edu/~jburkardt/f_src/test_nls/test_nls.f90) problem 15
# http://ftp.mcs.anl.gov/pub/MINPACK-2/tprobs.92/dchqfj.f

chebyquad <- function(x) {
  n <- length(x)
  y <- numeric(n)

  for(j in 1:n) {
    t1 <- 1.0
    t2 <- 2.0*x[j] - 1.0
    temp <- 2.0 * t2

    for(i in 1:n) {
      y[i] <- y[i] + t2

      t3 <- temp * t2 - t1
      t1 <- t2
      t2 <- t3
    }
  }

  y <- y / n

  for(i in 1:n) {
    if ( i%%2 == 0 ) {
      y[i] <- y[i] + 1.0 / (i * i - 1)
    }
  }

  y
}

# from dchqfj.f

chebyjac <- function(x) {
  #         do 90 j = 1, n
  #            temp1 = one
  #            temp2 = two*x(j) - one
  #            temp = two*temp2
  #            temp3 = zero
  #            temp4 = two
  #            do 80 i = 1, m
  #               fjac(i,j) = dx*temp4
  #               ti = four*temp2 + temp*temp4 - temp3
  #               temp3 = temp4
  #               temp4 = ti
  #               ti = temp*temp2 - temp1
  #               temp1 = temp2
  #               temp2 = ti
  #   80       continue
  #   90    continue

  n <- length(x)
  y <- numeric(n)
  dx <- 1/n
  jac <- matrix(0,nrow=n,ncol=n)
  for( j in 1:n) {
    t1 <- 1.0
    t2 <- 2.0*x[j] - 1.0
    temp <- 2.0 * t2
    t3 <- 0.0
    t4 <- 2.0
    for( i in 1:n) {
      jac[i,j] <- dx*t4
      ti <- 4.0 * t2 + temp * t4 - t3
      t3 <- t4
      t4 <- ti
      ti <- temp*t2 - t1
      t1 <- t2
      t2 <- ti
    }
  }
  jac
}

chebyinit <- function(n) (1:n) / (n + 1)

test_that("Chebyquad solutions converge for n = 1:7,9 using default method", {
  for (n in c(1:7, 9)) {
    xstart <- chebyinit(n)

    zz <- nleqslv(
      xstart, chebyquad,
      global = "dbldog",
      control = list(
        ftol = 1e-8,
        xtol = 1e-8,
        trace = 0,
        btol = 0.01,
        delta = -2
      )
    )

    expect_true(all(abs(zz$fvec) <= 1e-8))
  }
})


test_that("Chebyquad solutions converge for n = 1:7,9 using Newton method", {
  for (n in c(1:7, 9)) {
    xstart <- chebyinit(n)

    zz <- nleqslv(
      xstart, chebyquad,
      global = "dbldog",
      method = "Newton",
      control = list(
        ftol = 1e-8,
        xtol = 1e-8,
        trace = 0,
        btol = 0.01,
        delta = -2
      )
    )

    expect_true(all(abs(zz$fvec) <= 1e-8))
  }

  for (n in c(1:7, 9)) {
    xstart <- chebyinit(n)

    zz <- nleqslv(
      xstart, chebyquad,
      chebyjac,
      method = "Newton",
      control = list(
        ftol = 1e-8,
        xtol = 1e-8,
        trace = 0,
        btol = 0.01,
        delta = -2,
        chkjac=TRUE
      )
    )

    expect_true(all(abs(zz$fvec) <= 1e-8))
  }
})

test_that("chebyquad solutions with testnslv", {
  xstart <- chebyinit(5)

  temp <- testnslv(xstart, chebyquad)
  expect_true(inherits(temp, "test.nleqslv"))
  expect_true(is.data.frame(temp$out))
  expect_true(all(temp$out$termcd %in% c(1,2)))
  expect_true(all(temp$out$Iter < 11))

  temp <- testnslv(xstart, chebyquad, chebyjac)
  expect_true(inherits(temp, "test.nleqslv"))
  expect_true(is.data.frame(temp$out))
  expect_true(all(temp$out$termcd %in% c(1,2)))
  expect_true(all(temp$out$Iter < 10))
})

# Copyright (c) Rob Carnell 2026

f <- function(x) {
  y <- numeric(length(x))
  y[1] <- x[1]^2 + x[2]^3
  y[2] <- x[1] + 2 * x[2] + 3
  y
}

test_that("nleqslv preserves names on x-values (all named)", {
  xstart <- c(a = 1.0, b = 0.5)

  z <- nleqslv(xstart, f, control = list(trace = 0))

  expect_identical(names(z$x), names(xstart))
})

test_that("nleqslv preserves names on x-values (partially named)", {
  xstart <- c(u = 1.0, 0.5)

  z <- nleqslv(xstart, f, control = list(trace = 0))

  expect_identical(names(z$x), names(xstart))
})

dslnex <- function(x) {
  y <- numeric(2)
  y[1] <- x[1]^2 + x[2]^2 - 2
  y[2] <- exp(x[1]-1) + x[2]^3 - 2
  y
}

jacdsln <- function(x) {
  n <- length(x)
  Df <- matrix(numeric(n*n),n,n)
  Df[1,1] <- 2*x[1]
  Df[1,2] <- 2*x[2]
  Df[2,1] <- exp(x[1]-1)
  Df[2,2] <- 3*x[2]^2

  Df
}

test_that("nleqslv error conditions work", {
  xstart <- c(1, 2, 3)
  z <- nleqslv(xstart, common_test_f, common_test_jac, method="Newton",
               control=list(trace=0, allowSingular=TRUE))
  expect_equal(z$x, common_test_xsol, tolerance = 1E-6)

  expect_error(z <- nleqslv(xstart, common_test_f, "Jac", method="Newton"))

  expect_error(z <- nleqslv(xstart, common_test_f, common_test_jac, method="Newton",
                            control=list(delta = as.Date("2026-01-01"))))

  xstart <- c(2,0.5)
  expect_output(
    expect_error(z <- nleqslv(xstart, dslnex, jacobian = TRUE, method="Newton",
                            global="none", xscalm="fixed",
                            control=list(trace=1))))
  expect_output(
    expect_error(z <- nleqslv(xstart, dslnex, jacobian = TRUE, method="Newton",
                            global="none", xscalm="fixed",
                            control=list(trace=1))))

  expect_error(nleqslv(xstart, dslnex, control=list(xtol=Inf)))
  expect_error(nleqslv(xstart, dslnex, control=list(ftol=Inf)))
  expect_error(nleqslv(xstart, dslnex, control=list(btol=Inf)))
  expect_error(nleqslv(xstart, dslnex, control=list(sigma=Inf)))
  expect_error(nleqslv(xstart, dslnex, control=list(stepmax=Inf)))
  expect_error(nleqslv(xstart, dslnex, control=list(delta=Inf)))
  expect_error(nleqslv(xstart, dslnex, control=list(cndtol=Inf)))

  expect_error(nleqslv(LETTERS[1:2], dslnex))

  expect_error(nleqslv(c(0, Inf), dslnex))

  expect_error(nleqslv(c(1.0, 2.0), function(x) return(LETTERS[1:2])))

  expect_error(nleqslv(c(1.0, 2.0), function(x) return(c(0, Inf))))

  expect_error(nleqslv(c(1.0, 2.0), function(x) numeric(3)))

  expect_error(nleqslv(c(1.0, 2.0), dslnex, control=list(scalex=c(1,2,3))))

  expect_error(nleqslv(c(1.0, 2.0), dslnex, control=list(scalex=c(1, Inf))))
})

test_that("nleqslv - test all combinations of parameters", {
  xstart <- c(2,0.5)

  for (m in c("Newton", "Broyden")) {
    for (g in c("dbldog", "pwldog",
                "cline", "qline", "gline", "hook", "none")) {
      for (x in c("fixed", "auto")) {
        if (!(m == "Newton" & g == "none")) {
          expect_output(nleqslv(xstart, dslnex, jacobian = TRUE, method=m,
                                  global=g, xscalm=x,
                                  control=list(trace=1)))
        }
      }
    }
  }
})

test_that("testnslv works", {
  xstart <- c(1, 2, 3)
  expect_no_error(testnslv(xstart, common_test_f, common_test_jac,
                           method="Newton", Nrep = 0,
                            control = list(allowSingular=TRUE)))
  expect_no_error(testnslv(xstart, common_test_f, common_test_jac,
                           method="Newton", Nrep = 1,
                           control = list(allowSingular=TRUE)))
  expect_no_error(testnslv(xstart, common_test_f, common_test_jac,
                           method="Newton", Nrep = 10,
                           control = list(allowSingular=TRUE)))

  expect_error(z <- nleqslv(xstart, common_test_f, "Jac", method="Newton"))

  expect_error(z <- nleqslv(xstart, common_test_f, common_test_jac, method="Newton",
                            control=list(delta = as.Date("2026-01-01"))))

})

test_that("print.testnslv", {
  xstart <- c(1, 2, 3)
  z <- testnslv(xstart, common_test_f, common_test_jac,
                           method="Newton", Nrep = 0,
                           control = list(allowSingular=TRUE))
  expect_output(print(z))

  expect_error(print.nleqlsv("A"))

  expect_no_error(testnslv(xstart, common_test_f, common_test_jac,
                          method="Newton", Nrep = 0,
                          control = list(allowSingular=TRUE)))
  z$title <- "Test Title"
  expect_output(print(z))
  z$title <- NULL
  expect_output(print(z))
})

# Copyright (c) Rob Carnell 2026

# Powell cautionary example
# M.J.D. Powell, "A Hybrid Method for Nonlinear Equations",
# in Numerical Methods for Nonlinear Algebraic Equations, ed. P. Rabinowitz, 1970.

f <- function(x) {
  c(
    x[1],
    10 * x[1] / (x[1] + 0.1) + 2 * x[2]^2
  )
}

jac <- function(x) {
  J <- matrix(0, nrow = 2, ncol = 2)
  J[1, 1] <- 1
  J[1, 2] <- 0
  J[2, 1] <- 1 / (x[1] + 0.1)^2
  J[2, 2] <- 4 * x[2]
  J
}

test_that("Newton method converges for Powell example from regular and singular starts", {
  # Regular start
  z1 <- nleqslv(
    c(3, 1), f,
    method = "Newton",
    control = list(trace = 0, allowSingular = TRUE)
  )

  expect_true(all(abs(z1$fvec) <= 1e-8))
  expect_false(z1$termcd %in% c(-1, -2, -10))

  # Singular start (x2 = 0 makes Jacobian singular)
  z2 <- nleqslv(
    c(3, 0), f,
    method = "Newton",
    control = list(trace = 0, allowSingular = TRUE)
  )

  expect_true(all(abs(z2$fvec) <= 1e-8))
  expect_false(z2$termcd %in% c(-1, -2, -10))
})

# Copyright (c) Rob Carnell 2026

test_that("Scalar Newton method matches uniroot solutions", {
  f <- function(x) {
    2.5 * exp(-0.5 * (2 * 0.045 - x)) +
      2.5 * exp(-0.045) +
      2.5 * exp(-1.5 * x) -
      100
  }

  g1 <- function(x) {
    0.5 * 2.5 * exp(-0.5 * (2 * 0.045 - x)) -
      1.5 * 2.5 * exp(-1.5 * x)
  }

  g2 <- function(x) {
    matrix(
      0.5 * 2.5 * exp(-0.5 * (2 * 0.045 - x)) -
        1.5 * 2.5 * exp(-1.5 * x),
      nrow = 1, ncol = 1
    )
  }

  # Reference solutions from uniroot
  xu1 <- uniroot(f, c(-3, 0), tol = 1e-8)$root
  xu2 <- uniroot(f, c(6, 8),  tol = 1e-8)$root

  # nleqslv with scalar derivative
  xg1_1 <- nleqslv(-2, f, g1)$x
  xg1_2 <- nleqslv( 8, f, g1)$x

  # nleqslv with 1x1 Jacobian matrix
  xg2_1 <- nleqslv(-2, f, g2)$x
  xg2_2 <- nleqslv( 8, f, g2)$x

  # Compare to uniroot
  expect_equal(xg1_1, xu1)
  expect_equal(xg1_2, xu2)
  expect_equal(xg2_1, xu1)
  expect_equal(xg2_2, xu2)

  # Cross-check derivative forms
  expect_equal(xg1_2, xg2_2)
})

# Copyright (c) Rob Carnell 2026

test_that("Broyden banded function behaves consistently across solver options", {
  library(nleqslv)

  brdban <- function(x, ml = 5, mu = 1) {
    n <- length(x)
    y <- numeric(n)

    for (k in 1:n) {
      k1 <- max(1, k - ml)
      k2 <- min(n, k + mu)

      temp <- 0.0
      for (j in k1:k2) {
        if (j != k) {
          temp <- temp + x[j] * (1.0 + x[j])
        }
      }

      y[k] <- x[k] * (2.0 + 5.0 * x[k]^2) + 1.0 - temp
    }
    y
  }

  n <- 10
  xstart <- -rep(1, n)
  ztol <- 1000 * .Machine$double.eps

  # --- Newton method, default vs. banded Jacobian ---
  z1 <- nleqslv(xstart, brdban, method = "Newton")
  z2 <- nleqslv(xstart, brdban, method = "Newton",
                control = list(dsub = 5, dsuper = 1))

  expect_equal(z1$termcd, 1)
  expect_equal(z2$termcd, 1)
  expect_equal(z1$message, expectedMessage1)
  expect_equal(z2$message, expectedMessage1)
  expect_equal(z2$x, z1$x)
  expect_equal(z2$x, z1$x, tolerance = ztol)

  # --- Newton with ml = 2, mu = 2 ---
  z1 <- nleqslv(xstart, brdban, ml = 2, mu = 2, method = "Newton")
  z2 <- nleqslv(xstart, brdban, ml = 2, mu = 2, method = "Newton",
                control = list(dsub = 2, dsuper = 2))

  expect_equal(z1$termcd, 1)
  expect_equal(z2$termcd, 1)
  expect_equal(z1$message, expectedMessage1)
  expect_equal(z2$message, expectedMessage1)
  expect_equal(z2$x, z1$x, tolerance = ztol)

  # --- Broyden method with ml = 2, mu = 2 ---
  z3 <- nleqslv(xstart, brdban, ml = 2, mu = 2, method = "Broyden")
  z4 <- nleqslv(xstart, brdban, ml = 2, mu = 2, method = "Broyden",
                control = list(dsub = 2, dsuper = 2))

  expect_equal(z3$termcd, 1)
  expect_equal(z4$termcd, 1)
  expect_equal(z3$message, expectedMessage1)
  expect_equal(z4$message, expectedMessage1)

  expect_equal(z3$x, z1$x)
  expect_equal(z4$x, z1$x)
  expect_equal(z4$x, z3$x, tolerance = ztol)
})

# Copyright (c) Rob Carnell 2026

# Nonlinear system
f <- function(X, a, b, c1, c2, c3) {
  x <- X[1]
  y <- X[2]
  z <- X[3]

  c(
    x + y - x * y - c1,
    x + z - x * z - c2,
    a * y + b * z - c3
  )
}

# Analytic Jacobian
Jac <- function(X, a, b, c1, c2, c3) {
  x <- X[1]
  y <- X[2]
  z <- X[3]

  J <- matrix(0, nrow = 3, ncol = 3)
  J[1, 1] <- 1 - y
  J[2, 1] <- 1 - z
  J[3, 1] <- 0

  J[1, 2] <- 1 - x
  J[2, 2] <- 0
  J[3, 2] <- a

  J[1, 3] <- 0
  J[2, 3] <- 1 - x
  J[3, 3] <- b

  J
}

test_that("Newton and Broyden converge to the closed-form solution", {
  a <- 1
  b <- 1
  c1 <- 2
  c2 <- 3
  c3 <- 4

  # Closed-form solution
  x <- (a * c1 + b * c2 - c3) / (a + b - c3)
  y <- (b * c1 - b * c2 - c1 * c3 + c3) / (-a * c1 + a - b * c2 + b)
  z <- (a * (c1 - c2) + (c2 - 1) * c3) / (a * (c1 - 1) + b * (c2 - 1))
  xsol <- c(x, y, z)

  X.start <- c(1, 2, 3)

  z1 <- nleqslv(
    X.start, f, Jac,
    a = a, b = b, c1 = c1, c2 = c2, c3 = c3,
    method = "Newton",
    control = list(trace = 0, allowSingular = TRUE)
  )

  z2 <- nleqslv(
    X.start, f, Jac,
    a = a, b = b, c1 = c1, c2 = c2, c3 = c3,
    method = "Broyden",
    control = list(trace = 0, allowSingular = TRUE)
  )

  # Both solvers should match the closed-form solution
  expect_equal(z1$x, xsol, tolerance = 1e-8)
  expect_equal(z2$x, xsol, tolerance = 1e-8)

  # Function values should be near zero
  expect_true(all(abs(z1$fvec) <= 1e-8))
  expect_true(all(abs(z2$fvec) <= 1e-8))

  # Ensure no catastrophic solver failure
  expect_false(z1$termcd %in% c(-1, -2, -10))
  expect_false(z2$termcd %in% c(-1, -2, -10))
})

# Copyright (c) Rob Carnell 2026

test_that("scaled analytic Jacobian works for dslnex across methods and globals", {
  skip_if_not_installed("nleqslv")
  library(nleqslv)

  # Dennis–Schnabel example 6.5.1
  dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1] - 1) + x[2]^3 - 2
    y
  }

  jacdsln <- function(x) {
    n <- length(x)
    Df <- matrix(0, n, n)
    Df[1, 1] <- 2 * x[1]
    Df[1, 2] <- 2 * x[2]
    Df[2, 1] <- exp(x[1] - 1)
    Df[2, 2] <- 3 * x[2]^2
    Df
  }

  converged <- function(z) all(abs(z$fvec) <= 1e-8)

  xstart <- c(2, 0.5)
  scalex <- c(2, 3)

  # First: ensure analytic Jacobian check does not fail
  z0 <- nleqslv(
    xstart, dslnex, jacdsln,
    global = "dbldog",
    control = list(btol = 0.01, delta = -1, chkjac = TRUE, scalex = scalex)
  )
  expect_false(z0$termcd == -10)

  # Broyden (default) with analytic Jacobian
  for (g in c("dbldog", "pwldog")) {
    for (delta in c(-1, -2)) {
      z <- nleqslv(
        xstart, dslnex, jacdsln,
        global = g,
        control = list(btol = 0.01, delta = delta, chkjac = TRUE, scalex = scalex)
      )
      expect_true(converged(z))
      expect_false(z$termcd == -10)
    }
  }

  # Newton with analytic Jacobian
  for (g in c("dbldog", "pwldog")) {
    for (delta in c(-1, -2)) {
      z <- nleqslv(
        xstart, dslnex, jacdsln,
        method = "Newton",
        global = g,
        control = list(btol = 0.01, delta = delta, chkjac = TRUE, scalex = scalex)
      )
      expect_true(converged(z))
      expect_false(z$termcd == -10)
    }
  }
})

# Copyright (c) Rob Carnell 2026

# More, Garbow, Hillstrom: Testing Unconstrained Optimization Software
# ACM Trans. Math. Software, 7, March 1981, 17--41
# Function as shown in this paper is for optimizing not for non linear equations
# from the paper it is not clear what was used by the authors for their tests
# of non linear equation solvers
# function 30

# Broyden tridiagonal function
brdtri <- function(x) {
  n <- length(x)
  y <- numeric(n)

  y[1] <- (3 - 2 * x[1]) * x[1] - 2 * x[2] + 1
  y[n] <- (3 - 2 * x[n]) * x[n] - x[n - 1] + 1

  k <- 2:(n - 1)
  y[k] <- (3 - 2 * x[k]) * x[k] - x[k - 1] - 2 * x[k + 1] + 1

  y
}

test_that("Newton method: structured vs unstructured Jacobian give same solution", {
  n <- 100
  xstart <- rep(-1, n)
  ztol <- 1000 * .Machine$double.eps

  z1 <- nleqslv(xstart, brdtri, method = "Newton")
  z2 <- nleqslv(
    xstart, brdtri,
    method = "Newton",
    control = list(dsub = 1, dsuper = 1)
  )

  expect_equal(z1$termcd, 1)
  expect_equal(z2$termcd, 1)

  expect_equal(z1$njcnt, 4)
  expect_equal(z2$njcnt, 4)

  expect_equal(z1$nfcnt, 4)
  expect_equal(z2$nfcnt, 4)

  expect_equal(z1$message, expectedMessage1)
  expect_equal(z2$message, expectedMessage1)

  expect_equal(z2$x, z1$x, tolerance = ztol)
})

test_that("Newton method repeat run: structured vs unstructured Jacobian", {
  n <- 100
  xstart <- rep(-1, n)
  ztol <- 1000 * .Machine$double.eps

  z1 <- nleqslv(xstart, brdtri, method = "Newton")
  z2 <- nleqslv(
    xstart, brdtri,
    method = "Newton",
    control = list(dsub = 1, dsuper = 1)
  )

  expect_equal(z1$termcd, 1)
  expect_equal(z2$termcd, 1)

  expect_equal(z1$njcnt, 4)
  expect_equal(z2$njcnt, 4)

  expect_equal(z1$nfcnt, 4)
  expect_equal(z2$nfcnt, 4)

  expect_equal(z1$message, expectedMessage1)
  expect_equal(z2$message, expectedMessage1)

  expect_equal(z2$x, z1$x, tolerance = ztol)
})

test_that("Broyden method: structured vs unstructured Jacobian give same solution", {
  n <- 100
  xstart <- rep(-1, n)
  ztol <- 1000 * .Machine$double.eps

  z1 <- nleqslv(xstart, brdtri, method = "Newton")  # reference solution
  z3 <- nleqslv(xstart, brdtri, method = "Broyden")
  z4 <- nleqslv(
    xstart, brdtri,
    method = "Broyden",
    control = list(dsub = 1, dsuper = 1)
  )

  expect_equal(z3$termcd, 2)
  expect_equal(z4$termcd, 2)

  expect_equal(z3$njcnt, 1)
  expect_equal(z4$njcnt, 1)

  expect_equal(z3$nfcnt, 10)
  expect_equal(z4$nfcnt, 10)

  expect_equal(z3$message, expectedMessage2)
  expect_equal(z4$message, expectedMessage2)

  # Compare Broyden solutions to Newton reference
  expect_equal(z3$x, z1$x, tolerance = sqrt(.Machine$double.eps))
  expect_equal(z4$x, z1$x, tolerance = sqrt(.Machine$double.eps))

  # Compare structured vs unstructured Broyden
  expect_equal(z4$x, z3$x, tolerance = ztol)
})

# Copyright (c) Rob Carnell 2026

trig <- function(x) {
  n <- length(x)
  y <- cos(x)
  s <- sum(y)
  y <- n - s + seq_len(n) * (1 - y) - sin(x)
  y
}

trigjac <- function(x) {
  n <- length(x)
  J <- matrix(0, n, n)
  for (p in 1:n) {
    J[, p] <- sin(x[p])
    J[p, p] <- (p + 1) * sin(x[p]) - cos(x[p])
  }
  J
}

n <- 10
xstart <- rep(1, n) / n

test_that("Trigonometric system solves correctly with global='dbldog'", {
  znlm <- nleqslv(
    xstart,
    trig,
    global = "dbldog",
    control = list(trace = 0)
  )

  # Convergence checks
  expect_equal(znlm$termcd, 1)
  expect_equal(znlm$message, "Function criterion near zero")

  # Residual check
  expect_true(all(abs(znlm$fvec) <= 1e-8))

  znlm <- nleqslv(
    xstart,
    trig,
    trigjac,
    global = "dbldog",
    control = list(trace = 0)
  )

  # Convergence checks
  expect_equal(znlm$termcd, 1)
  expect_equal(znlm$message, "Function criterion near zero")

  # Residual check
  expect_true(all(abs(znlm$fvec) <= 1e-8))
})

test_that("trig with testnslv", {
  temp <- testnslv(xstart, trig, global = c("cline", "qline", "gline"))
  expect_true(inherits(temp, "test.nleqslv"))
  expect_true(is.data.frame(temp$out))
  expect_true(all(temp$out$termcd %in% c(1,2)))
  expect_true(all(temp$out$Iter < 20))

  temp <- testnslv(xstart, trig, trigjac, global = c("cline", "qline", "gline"))
  expect_true(inherits(temp, "test.nleqslv"))
  expect_true(is.data.frame(temp$out))
  expect_true(all(temp$out$termcd %in% c(1,2)))
  expect_true(all(temp$out$Iter < 20))
})

# Copyright (c) Rob Carnell 2026

# Brown almost linear function
brown <- function(x) {
  n <- length(x)
  y <- numeric(n)

  y[1:(n - 1)] <- x[1:(n - 1)] + sum(x) - (n + 1)
  y[n] <- prod(x) - 1

  y
}

# Analytic Jacobian
brownjac <- function(x) {
  n <- length(x)
  J <- matrix(1, nrow = n, ncol = n)
  diag(J) <- 2
  xprod <- prod(x)
  J[n, ] <- xprod / x
  J
}

test_that("Brown almost linear system converges for n = 50 and n = 100", {
  for (n in c(50, 100)) {
    xstart <- rep(0.5, n)

    z <- nleqslv(
      xstart,
      brown,
      jac = brownjac,
      method = "Newton",
      control = list(
        trace = 0,
        ftol = 1e-10,
        delta = "cauchy",
        allowSingular = TRUE
      )
    )

    # Original output always showed:
    #   "Function criterion near zero"
    #   TRUE
    #
    # So we assert the same condition:
    expect_true(all(abs(z$fvec) <= 1e-8))

    # And ensure solver did not fail catastrophically
    expect_equal(z$termcd, 1)
  }
})

test_that("numeric and character delta specifications give identical output", {
  # Dennis & Schnabel example 6.5.1
  dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1] - 1) + x[2]^3 - 2
    y
  }

  xstart <- c(2, 0.5)

  print_result <- function(z) {
    c(
      paste("x:", paste(format(z$x), collapse = " ")),
      paste("fvec:", paste(format(z$fvec), collapse = " ")),
      paste("message:", z$message),
      paste("ok:", all(abs(z$fvec) <= 1e-8))
    )
  }

  # Collect output for numeric deltas
  temp_numeric <- capture.output({
    for (g in c("dbldog", "pwldog")) {
      for (delta in c(-1.0, -2.0)) {
        z <- nleqslv(
          xstart, dslnex,
          global = g,
          control = list(btol = 0.01, delta = delta, trace = 1)
        )
        print_result(z)
      }
    }
  })

  # Collect output for character deltas
  temp_character <- capture.output({
    for (g in c("dbldog", "pwldog")) {
      for (delta in c("cauchy", "newton")) {
        z <- nleqslv(
          xstart, dslnex,
          global = g,
          control = list(btol = 0.01, delta = delta, trace = 1)
        )
        print_result(z)
      }
    }
  })

  # Compare
  expect_equal(temp_numeric, temp_character)
})

# Copyright (c) Rob Carnell 2026

test_that("Dennis–Schnabel example converges under multiple configurations", {

    # Problem definition
  dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1] - 1) + x[2]^3 - 2
    y
  }

  jacdsln <- function(x) {
    n <- length(x)
    Df <- matrix(0, n, n)
    Df[1, 1] <- 2 * x[1]
    Df[1, 2] <- 2 * x[2]
    Df[2, 1] <- exp(x[1] - 1)
    Df[2, 2] <- 3 * x[2]^2
    Df
  }

  xstart <- c(2, 0.5)

  ## Helper: check convergence
  expect_converged <- function(z) {
    expect_true(
      all(abs(z$fvec) <= 1e-8),
      info = paste("Message:", z$message)
    )
  }

  # ---------------------------
  # Broyden numerical Jacobian
  # ---------------------------
  for (z in c("cline", "qline", "gline")) {
    res <- nleqslv(xstart, dslnex, global = z, control = list(btol = 0.01))
    expect_converged(res)
  }

  # -------------------------------------
  # Broyden numerical Jacobian + doglegs
  # -------------------------------------
  for (z in c("dbldog", "pwldog")) {
    for (delta in c(-1.0, -2.0)) {
      res <- nleqslv(
        xstart, dslnex,
        global = z,
        control = list(btol = 0.01, delta = delta)
      )
      expect_converged(res)
    }
  }

  # -------------------------------------
  # Broyden analytical Jacobian
  # -------------------------------------
  for (z in c("dbldog", "pwldog")) {
    for (delta in c(-1.0, -2.0)) {
      res <- nleqslv(
        xstart, dslnex, jacdsln,
        global = z,
        control = list(btol = 0.01, delta = delta)
      )
      expect_converged(res)
    }
  }

  # -------------------------------------
  # Newton analytical Jacobian
  # -------------------------------------
  for (z in c("dbldog", "pwldog")) {
    for (delta in c(-1.0, -2.0)) {
      res <- nleqslv(
        xstart, dslnex, jacdsln,
        method = "Newton",
        global = z,
        control = list(btol = 0.01, delta = delta)
      )
      expect_converged(res)
    }
  }
})

# Copyright (c) Rob Carnell 2026

# Broyden banded function

# More, Garbow, Hillstrom: Testing Unconstrained Optimization Software
# ACM Trans. Math. Software, 7, March 1981, 17--41
# Function as shown in this paper is for optimizing not for non linear equations
# from the paper it is not clear what was used by the authors for their tests
# of non linear equation solvers
# function 31

brdban <- function(x) {
  ml <- 5
  mu <- 1
  n <- length(x)
  y <- numeric(n)

  for (k in 1:n) {
    k1 <- max(1, k - ml)
    k2 <- min(n, k + mu)

    temp <- 0
    for (j in k1:k2) {
      if (j != k) {
        temp <- temp + x[j] * (1 + x[j])
      }
    }

    y[k] <- x[k] * (2 + 5 * x[k]^2) + 1 - temp
  }
  y
}

xsol <- c(
  -0.42830, -0.47660, -0.51965, -0.55810, -0.59251,
  -0.62450, -0.62324, -0.62139, -0.62045, -0.58647
)

test_that("Known solution produces correct function values", {
  fsol <- brdban(xsol)

  expect_true(all(abs(fsol) < 1e-4))
})

test_that("nleqslv converges from xstart = -1", {
  n <- 10
  xstart <- rep(-1, n)

  znlq <- nleqslv(
    xstart, brdban,
    global = "dbldog", method = "Newton",
    control = list(trace = 0, ftol = 1e-8, xtol = 1e-8, btol = 1e-2, delta = -1)
  )

  expect_equal(znlq$termcd, 1)
  expect_equal(znlq$message, expectedMessage1)
  expect_true(all(abs(znlq$fvec) <= 1e-7))
  expect_equal(znlq$x, xsol, tolerance = 1E-5)
})

test_that("nleqslv converges from xstart = -2 with Newton method", {
  n <- 10
  xstart <- rep(-2, n)

  znlq <- nleqslv(
    xstart, brdban,
    global = "dbldog", method = "Newton",
    control = list(trace = 0, ftol = 1e-8, xtol = 1e-8, btol = 1e-2, delta = -1)
  )

  expect_equal(znlq$termcd, 1)
  expect_equal(znlq$message, expectedMessage1)
  expect_true(all(abs(znlq$fvec) <= 1e-8))
  expect_equal(znlq$x, xsol, tolerance = 1E-5)
})

test_that("nleqslv converges from xstart = -2 without specifying method", {
  n <- 10
  xstart <- rep(-2, n)

  znlq <- nleqslv(
    xstart, brdban,
    global = "dbldog",
    control = list(trace = 0, ftol = 1e-8, xtol = 1e-8, btol = 1e-2, delta = -1)
  )

  expect_equal(znlq$termcd, 1)
  expect_equal(znlq$message, expectedMessage1)
  expect_true(all(abs(znlq$fvec) <= 1e-7))
  expect_equal(znlq$x, xsol, tolerance = 1E-5)
})

test_that("Repeat convergence test for xstart = -2", {
  n <- 10
  xstart <- rep(-2, n)

  znlq <- nleqslv(
    xstart, brdban,
    global = "dbldog",
    control = list(trace = 0, ftol = 1e-8, xtol = 1e-8, btol = 1e-2, delta = -1)
  )

  expect_equal(znlq$termcd, 1)
  expect_equal(znlq$message, expectedMessage1)
  expect_true(all(abs(znlq$fvec) <= 1e-8))
  expect_equal(znlq$x, xsol, tolerance = 1E-5)
})

test_that("Broyden Banded function with testnslv", {
  n <- 10
  xstart <- rep(-1, n)
  temp <- testnslv(xstart, brdban)
  expect_true(inherits(temp, "test.nleqslv"))
  expect_true(is.data.frame(temp$out))
  expect_true(all(temp$out$termcd %in% c(1,2)))
  expect_true(all(temp$out$Iter < 25))
})

test_that("Broyden Banded with function scale", {
  temp_brdban <- function(x, fscale) brdban(x) / fscale

  n <- 10
  xstart <- -rep(1,n)

  Fscale <- rep(1,n)
  temp <- testnslv(xstart, temp_brdban, fscale=Fscale)
  expect_true(all(temp$out$Fnorm < 1E-12))
  temp <- nleqslv(xstart, temp_brdban, fscale=Fscale)

  Fscale <- c(10, 5, rep(1, n-2))
  temp2 <- testnslv(xstart, temp_brdban, fscale=Fscale)
  expect_true(all(temp2$out$Fnorm < 1E-12))
  temp2 <- nleqslv(xstart, temp_brdban, fscale=Fscale)
  expect_equal(temp$x, temp2$x, tolerance = 1E-6)

  Fscale <- c(20, 5, 2, rep(1, n-3))
  temp3 <- testnslv(xstart, temp_brdban, fscale=Fscale)
  expect_true(all(temp3$out$Fnorm < 1E-12))
  temp3 <- nleqslv(xstart, temp_brdban, fscale=Fscale)
  expect_equal(temp$x, temp3$x, tolerance = 1E-6)
})

# Copyright (c) Rob Carnell 2026

test_that("hook and dbldog methods give consistent solutions for dslnex", {
  # Dennis & Schnabel example 6.5.1
  dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1] - 1) + x[2]^3 - 2
    y
  }

  # helper: check convergence
  converged <- function(z) all(abs(z$fvec) <= 1e-8)

  # helper: compare solutions
  x_equal <- function(z1, z2) all(abs(z1$x - z2$x) <= 1e-8)

  run_pair <- function(xstart) {
    # HOOK
    h1 <- nleqslv(xstart, dslnex, global = "hook",
                  control = list(btol = 0.01, delta = "cauchy", trace = 0))
    h2 <- nleqslv(xstart, dslnex, global = "hook",
                  control = list(btol = 0.01, delta = "newton", trace = 0))

    # DBLDOG
    d1 <- nleqslv(xstart, dslnex, global = "dbldog",
                  control = list(btol = 0.01, delta = "cauchy", trace = 0))
    d2 <- nleqslv(xstart, dslnex, global = "dbldog",
                  control = list(btol = 0.01, delta = "newton", trace = 0))

    list(h1 = h1, h2 = h2, d1 = d1, d2 = d2)
  }

  # ---- First starting point ----
  res1 <- run_pair(c(2, 0.5))

  expect_true(converged(res1$h1))
  expect_true(converged(res1$h2))
  expect_true(converged(res1$d1))
  expect_true(converged(res1$d2))

  expect_true(x_equal(res1$h1, res1$h2))  # hook: cauchy vs newton
  expect_true(x_equal(res1$d1, res1$d2))  # dbldog: cauchy vs newton
  expect_true(x_equal(res1$h1, res1$d1))  # hook vs dbldog

  # ---- Second starting point ----
  res2 <- run_pair(c(1.1, 1.1))

  expect_true(converged(res2$h1))
  expect_true(converged(res2$h2))
  expect_true(converged(res2$d1))
  expect_true(converged(res2$d2))

  expect_true(x_equal(res2$h1, res2$h2))  # hook: cauchy vs newton
  expect_true(x_equal(res2$d1, res2$d2))  # dbldog: cauchy vs newton
  expect_true(x_equal(res2$h1, res2$d1))  # hook vs dbldog
})

# Copyright (c) Rob Carnell 2026

brdtri <- function(x) {
  n <- length(x)
  (3 - 2 * x) * x - c(0, x[-n]) - 2 * c(x[-1], 0) + 1
}

brdtrijac <- function(x) {
  n <- length(x)
  J <- diag(3 - 4 * x, n, n)
  J[row(J) == col(J) + 1] <- -1
  J[row(J) == col(J) - 1] <- -2
  J
}

n <- 10
xstart <- rep(-1, n)

# Baseline solution (no Jacobian)
z0 <- nleqslv(
  xstart, brdtri,
  method = "Newton",
  global = "dbldog"
)

# --- Tests -------------------------------------------------------------------

test_that("Baseline Newton/dbldog solve converges", {
  expect_equal(z0$termcd, 1)
  expect_equal(z0$message, expectedMessage1)
  expect_true(all(abs(z0$fvec) < 1e-7))
})

test_that("Analytic Jacobian gives same solution as baseline", {
  z1 <- nleqslv(
    xstart, brdtri, brdtrijac,
    method = "Newton",
    global = "dbldog",
    control = list(trace = 0)
  )

  expect_equal(z1$termcd, 1)
  expect_equal(z0$message, expectedMessage1)
  expect_equal(z1$x, z0$x, tolerance = 1e-12)
})

test_that("Jacobian checking enabled still matches baseline", {
  z2 <- nleqslv(
    xstart, brdtri, brdtrijac,
    method = "Newton",
    global = "dbldog",
    control = list(trace = 0, chkjac = TRUE)
  )

  expect_equal(z2$termcd, 1)
  expect_equal(z0$message, expectedMessage1)
  expect_equal(z2$x, z0$x, tolerance = 1e-12)
})

test_that("Banded Jacobian specification (dsub/dsuper) matches baseline", {
  z3 <- nleqslv(
    xstart, brdtri, brdtrijac,
    method = "Newton",
    global = "dbldog",
    control = list(trace = 0, dsub = 1, dsuper = 1)
  )

  expect_equal(z3$termcd, 1)
  expect_equal(z0$message, expectedMessage1)
  expect_equal(z3$x, z0$x, tolerance = 1e-12)
})

test_that("Banded Jacobian + chkjac matches baseline", {
  z4 <- nleqslv(
    xstart, brdtri, brdtrijac,
    method = "Newton",
    global = "dbldog",
    control = list(trace = 0, dsub = 1, dsuper = 1, chkjac = TRUE)
  )

  expect_equal(z4$termcd, 1)
  expect_equal(z0$message, expectedMessage1)
  expect_equal(z4$x, z0$x, tolerance = 1e-12)
})

# Copyright (c) Rob Carnell 2026

test_that("Dennis–Schnabel example with xscalm='auto' behaves as expected", {
  library(nleqslv)

  # Problem definition
  dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1] - 1) + x[2]^3 - 2
    y
  }

  jacdsln <- function(x) {
    n <- length(x)
    Df <- matrix(0, n, n)
    Df[1, 1] <- 2 * x[1]
    Df[1, 2] <- 2 * x[2]
    Df[2, 1] <- exp(x[1] - 1)
    Df[2, 2] <- 3 * x[2]^2
    Df
  }

  xstart <- c(2, 0.5)

  # Helper: check convergence
  converged <- function(z) {
    all(abs(z$fvec) <= 1e-8)
  }

  # ------------------------------------------------------------------
  # Broyden numerical Jacobian: qline, gline
  # Both converged in your <results>
  # ------------------------------------------------------------------
  for (z in c("qline", "gline")) {
    res <- nleqslv(
      xstart, dslnex,
      global = z,
      xscalm = "auto",
      control = list(btol = 0.01)
    )
    expect_true(
      converged(res),
      info = paste("Expected convergence for global =", z, "but got:", res$message)
    )
  }

  # ------------------------------------------------------------------
  # Broyden numerical Jacobian: dbldog, pwldog
  # Only delta = -1 converged; delta = -2 stalled (per <results>)
  # ------------------------------------------------------------------
  for (z in c("dbldog", "pwldog")) {
    # delta = -1.0 → TRUE
    res1 <- nleqslv(
      xstart, dslnex,
      global = z,
      xscalm = "auto",
      control = list(btol = 0.01, delta = -1)
    )
    expect_true(
      converged(res1),
      info = paste("Expected convergence for", z, "delta=-1 but got:", res1$message)
    )

    # delta = -2.0 → FALSE (algorithm stalled)
    res2 <- nleqslv(
      xstart, dslnex,
      global = z,
      xscalm = "auto",
      control = list(btol = 0.01, delta = -2)
    )
    expect_false(
      converged(res2),
      info = paste("Expected failure (stall) for", z, "delta=-2 but got:", res2$message)
    )
  }

  # ------------------------------------------------------------------
  # Broyden analytical Jacobian
  # Same pattern: delta = -1 converged, delta = -2 stalled
  # ------------------------------------------------------------------
  for (z in c("dbldog", "pwldog")) {
    res1 <- nleqslv(
      xstart, dslnex, jacdsln,
      global = z,
      xscalm = "auto",
      control = list(btol = 0.01, delta = -1)
    )
    expect_true(
      converged(res1),
      info = paste("Expected convergence for analytic", z, "delta=-1 but got:", res1$message)
    )

    res2 <- nleqslv(
      xstart, dslnex, jacdsln,
      global = z,
      xscalm = "auto",
      control = list(btol = 0.01, delta = -2)
    )
    expect_false(
      converged(res2),
      info = paste("Expected failure (stall) for analytic", z, "delta=-2 but got:", res2$message)
    )
  }

  # ------------------------------------------------------------------
  # Newton analytical Jacobian
  # All four combinations stalled (all FALSE in <results>)
  # ------------------------------------------------------------------
  for (z in c("dbldog", "pwldog")) {
    for (delta in c(-1, -2)) {
      res <- nleqslv(
        xstart, dslnex, jacdsln,
        method = "Newton",
        global = z,
        xscalm = "auto",
        control = list(btol = 0.01, delta = delta)
      )
      expect_false(
        converged(res),
        info = paste("Expected stall for Newton analytic", z, "delta=", delta,
                     "but got:", res$message)
      )
    }
  }
})

# Copyright (c) Rob Carnell 2026

# Dennis–Schnabel example 6.5.1 (p.149)
f <- function(x) {
  y <- numeric(2)
  y[1] <- x[1]^2 + x[2]^2 - 2
  y[2] <- exp(x[1] - 1) + x[2]^3 - 2
  y
}

test_that("control argument must be a named list", {
  expect_error(
    nleqslv(f, control = list(1e-3)),
    "named list"
  )
})

test_that("unknown names in control list are rejected", {
  expect_error(
    nleqslv(f, control = list(f = 1e-3)),
    "unknown names"
  )

  expect_error(
    nleqslv(f, control = list(f = 1e-7, b = 1e-3)),
    "unknown names"
  )
})

      subroutine nwtcvg(xplus,fplus,xc,xtol,retcd,ftol,iter,
     *                  maxit,n,ierr,termcd)

      integer n,iter,maxit,ierr,termcd,retcd
      double precision  xtol,ftol
      double precision  xplus(*),fplus(*),xc(*)

c-------------------------------------------------------------------------
c
c     Decide whether to terminate the nonlinear algorithm
c
c     Arguments
c
c     In       xplus   Real(*)         new x values
c     In       fplus   Real(*)         new f values
c     In       xc      Real(*)         current x values
c     In       xtol    Real            stepsize tolerance
c     In       retcd   Integer         return code from global search routines
c     In       ftol    Real            function tolerance
c     In       iter    Integer         iteration number
c     In       maxit   Integer         maximum number of iterations allowed
c     In       n       Integer         size of x and f
c     In       ierr    Integer         return code of cndjac (condition estimation)
c
c     Out      termcd  Integer         termination code
c                                        0 no termination criterion satisfied
c                                          ==> continue iterating
c                                        1 norm of scaled function value is
c                                          less than ftol
c                                        2 scaled distance between last
c                                          two steps less than xtol
c                                        3 unsuccessful global strategy
c                                          ==> cannot find a better point
c                                        4 iteration limit exceeded
c                                        5 Jacobian too ill-conditioned
c                                        6 Jacobian singular
c                                        7 Jacobian not usable (all zero entries)
c
c-------------------------------------------------------------------------

      double precision  fmax,rsx, nuxnrm
      integer idamax

c     check whether function values are within tolerance

      termcd = 0

      if( ierr .ne. 0 ) then
         termcd = 4 + ierr
         return
      endif

      fmax = abs(fplus(idamax(n,fplus,1)))
      if( fmax .le. ftol) then
         termcd = 1
         return
      endif

c     initial check at start so there is no xplus
c     so only a check of function values is useful
      if(iter .eq. 0) return

      if(retcd .eq. 1) then
         termcd = 3
         return
      endif

c     check whether relative step length is within tolerance
c     Dennis Schnabel Algorithm A7.2.3

      rsx = nuxnrm(n, xplus, xc)
      if(rsx .le. xtol) then
        termcd = 2
        return
      endif

c     check iteration limit

      if(iter .ge. maxit) then
         termcd = 4
      endif

      return
      end

c-----------------------------------------------------------------------

      subroutine nweset(n,xc,fc,fcnorm,xp,fp,fpnorm,gcnt,priter,iter)
      double precision xc(*),fc(*),fcnorm,xp(*),fp(*),fpnorm
      integer n, gcnt, priter, iter

c-------------------------------------------------------------------------
c
c     calling routine got an error in decomposition/update of Jacobian/Broyden
c     jacobian an singular or too ill-conditioned
c     prepare return arguments
c
c     Arguments
c
c     In       n       Integer         size of x
c     In       xc      Real(*)         current (starting) x values
c     In       fc      Real(*)         function values f(xc)
c     In       fcnorm  Real            norm fc
c     Out      xp      Real(*)         final x values
c     Out      fp      Real(*)         function values f(xp)
c     Out      fpnorm  Real            final norm fp
c     Out      gcnt    Integer         # of backtracking steps (here set to 0)
c     In       priter  Integer         flag for type of output
c     In       iter    Integer         iteration counter
c
c-------------------------------------------------------------------------

      call dcopy(n,xc,1,xp,1)
      call dcopy(n,fc,1,fp,1)
      fpnorm = fcnorm
      gcnt   = 0
      if( priter .gt. 0 ) then
         call nwjerr(iter)
      endif

      return
      end

c-----------------------------------------------------------------------

      subroutine chkjac1(A,lda,xc,fc,n,epsm,scalex,fz,wa,xw,fvec,termcd)

      integer lda,n,termcd
      double precision  A(lda,*),xc(*),fc(*)
      double precision  epsm,scalex(*)
      double precision  fz(*),wa(*),xw(*)
      external fvec

c-------------------------------------------------------------------------
c
c     Check the user supplied jacobian against its finite difference approximation
c
c     Arguments
c
c     In       A       Real(lda,*)     user supplied jacobian
c     In       lda     Integer         leading dimension of ajanal
c     In       xc      Real(*)         vector of x values
c     In       fc      Real(*)         function values f(xc)
c     In       n       Integer         size of x
c     In       epsm    Real            machine precision
c     In       scalex  Real(*)         scaling vector for x()
c     Wk       fz      Real(*)         workspace
c     Wk       wa      Real(*)         workspace
c     Wk       xw      Real(*)         workspace
c     In       fvec    Name            name of routine to evaluate f(x)
c     Out      termcd  Integer         return code
c                                        0  user supplied jacobian ok
c                                      -10  user supplied jacobian NOT ok
c
c-------------------------------------------------------------------------

      integer i,j,errcnt
      double precision  ndigit,p,h,xcj,dinf
      double precision  tol
      double precision  rnudif
      integer idamax

      integer MAXERR
      parameter(MAXERR=10)

      double precision Rquart, Rten
      parameter(Rquart=0.25d0, Rten=10.0d0)

      termcd = 0

c     compute the finite difference jacobian and check it against
c     the analytic one

      ndigit = -log10(epsm)
      p = sqrt(max(Rten**(-ndigit),epsm))
      tol    = epsm**Rquart

      errcnt = 0
      call dcopy(n,xc,1,xw,1)
      call vunsc(n,xw,scalex)

      do j=1,n
         h = p + p * abs(xw(j))
         xcj   = xw(j)
         xw(j) = xcj + h

c        avoid (small) rounding errors
c        h = xc(j) - xcj but not here to avoid clever optimizers

         h = rnudif(xw(j), xcj)

         call fvec(xw,fz,n,j)
         xw(j) = xcj

         do i=1,n
            wa(i) = (fz(i)-fc(i))/h
         enddo

         dinf = abs(wa(idamax(n,wa,1)))

         do i=1,n
            if(abs(A(i,j)-wa(i)).gt.tol*dinf) then
               errcnt = errcnt + 1
               if( errcnt .gt. MAXERR ) then
                  termcd = -10
                  return
               endif
               call nwckot(i,j,A(i,j),wa(i))
            endif
         enddo
      enddo

c      call vscal(n,xc,scalex)

      if( errcnt .gt. 0 ) then
         termcd = -10
      endif
      return
      end

c-----------------------------------------------------------------------

      subroutine chkjac2(A,lda,xc,fc,n,epsm,scalex,fz,wa,xw,fvec,termcd,
     *                   dsub,dsuper)

      integer lda,n,termcd,dsub,dsuper
      double precision  A(lda,*),xc(*),fc(*)
      double precision  epsm,scalex(*)
      double precision  fz(*),wa(*),xw(*)
      external fvec

c-------------------------------------------------------------------------
c
c     Check the user supplied jacobian against its finite difference approximation
c
c     Arguments
c
c     In       A       Real(lda,*)     user supplied jacobian
c     In       lda     Integer         leading dimension of ajanal
c     In       xc      Real(*)         vector of x values
c     In       fc      Real(*)         function values f(xc)
c     In       n       Integer         size of x
c     In       epsm    Real            machine precision
c     In       scalex  Real(*)         scaling vector for x()
c     Wk       fz      Real(*)         workspace
c     Wk       wa      Real(*)         workspace
c     Wk       xw      Real(*)         workspace
c     In       fvec    Name            name of routine to evaluate f(x)
c     Out      termcd  Integer         return code
c                                        0  user supplied jacobian ok
c                                      -10  user supplied jacobian NOT ok
c
c-------------------------------------------------------------------------

      integer i,j,k,dsum,errcnt
      double precision  ndigit,p,h,dinf
      double precision  tol
      double precision w(n),xstep(n)

      integer MAXERR
      parameter(MAXERR=10)

      double precision Rquart, Rten, Rzero
      parameter(Rquart=0.25d0, Rten=10.0d0, Rzero=0.0d0)

      dsum = dsub + dsuper + 1

      termcd = 0

c     compute the finite difference jacobian and check it against
c     the user supplied one

      ndigit = -log10(epsm)
      p = sqrt(max(Rten**(-ndigit),epsm))
      tol    = epsm**Rquart

      errcnt = 0
      call dcopy(n,xc,1,xw,1)
      call vunsc(n,xw,scalex)

      do j=1,n
          xstep(j) = p + p * abs(xw(j))
          w(j) = xw(j)
      enddo

      do k=1,dsum
         do j=k,n,dsum
            xw(j) = xw(j) + xstep(j)
         enddo

c        for non finite values error message will be wrong
         call fvec(xw,fz,n,n+k)

         do j=k,n,dsum
             h = xstep(j)
             xw(j) = w(j)
             dinf = Rzero
             do i=max(j-dsuper,1),min(j+dsub,n)
                wa(i) = (fz(i)-fc(i)) / h
                if(abs(wa(i)).gt.dinf) dinf = abs(wa(i))
             enddo

             do i=max(j-dsuper,1),min(j+dsub,n)
                if(abs(A(i,j)-wa(i)).gt.tol*dinf) then
                   errcnt = errcnt + 1
                   if( errcnt .gt. MAXERR ) then
                      termcd = -10
                      return
                   endif
                   call nwckot(i,j,A(i,j),wa(i))
                endif
             enddo
         enddo
      enddo

c      call vscal(n,xc,scalex)

      if( errcnt .gt. 0 ) then
         termcd = -10
      endif
      return
      end

c-----------------------------------------------------------------------

      subroutine chkjac(A,lda,xc,fc,n,epsm,jacflg,scalex,fz,wa,xw,fvec,
     *                  termcd)

      integer lda,n,termcd,jacflg(*)
      double precision  A(lda,*),xc(*),fc(*)
      double precision  epsm,scalex(*)
      double precision  fz(*),wa(*),xw(*)
      external fvec

c-------------------------------------------------------------------------
c
c     Check the user supplied jacobian against its finite difference approximation
c
c     Arguments
c
c     In       A       Real(lda,*)     user supplied jacobian
c     In       lda     Integer         leading dimension of ajanal
c     In       xc      Real(*)         vector of x values
c     In       fc      Real(*)         function values f(xc)
c     In       n       Integer         size of x
c     In       epsm    Real            machine precision
c     In       jacflg  Integer(*)      indicates how to compute jacobian
c                                      jacflg[1]:  0 numeric; 1 user supplied; 2 numerical banded
c                                                  3: user supplied banded
c                                      jacflg[2]: number of sub diagonals or -1 if not banded
c                                      jacflg[3]: number of super diagonals or -1 if not banded
c                                      jacflg[4]: 1 if adjusting jacobian allowed when
c                                                   singular or illconditioned
c     In       scalex  Real(*)         scaling vector for x()
c     Wk       fz      Real(*)         workspace
c     Wk       wa      Real(*)         workspace
c     Wk       xw      Real(*)         workspace
c     In       fvec    Name            name of routine to evaluate f(x)
c     Out      termcd  Integer         return code
c                                        0  user supplied jacobian ok
c                                      -10  user supplied jacobian NOT ok
c
c-------------------------------------------------------------------------

      if(jacflg(1) .eq. 3) then
c        user supplied and banded
         call chkjac2(A,lda,xc,fc,n,epsm,scalex,fz,wa,xw,fvec,termcd,
     *                jacflg(2),jacflg(3))
      else
         call chkjac1(A,lda,xc,fc,n,epsm,scalex,fz,wa,xw,fvec,termcd)
      endif

      return
      end

c-----------------------------------------------------------------------

      subroutine fdjac0(xc,fc,n,epsm,fvec,fz,rjac,ldr)

      integer ldr,n
      double precision  epsm
      double precision  rjac(ldr,*),fz(*),xc(*),fc(*)
      external fvec

c-------------------------------------------------------------------------
c
c     Compute the finite difference jacobian at the current point xc
c
c     Arguments
c
c     In       xc      Real(*)         current point
c     In       fc      Real(*)         function values at current point
c     In       n       Integer         size of x and f
c     In       epsm    Real            machine precision
c     In       fvec    Name            name of routine to evaluate f(x)
c     Wk       fz      Real(*)         workspace
c     Out      rjac    Real(ldr,*)     jacobian matrix at x
c                                        entry [i,j] is derivative of
c                                        f(i) wrt to x(j)
c     In       ldr     Integer         leading dimension of rjac
c
c-------------------------------------------------------------------------

      integer i,j
      double precision  ndigit,p,h,xcj
      double precision  rnudif

      double precision Rten
      parameter(Rten=10d0)

      ndigit = -log10(epsm)
      p = sqrt(max(Rten**(-ndigit),epsm))

      do j=1,n
         h = p + p * abs(xc(j))

c        or as alternative h  = p * max(Rone, abs(xc(j)))

         xcj   = xc(j)
         xc(j) = xcj + h

c        avoid (small) rounding errors
c        h = xc(j) - xcj  but not here to avoid clever optimizers

         h = rnudif(xc(j), xcj)
         call fvec(xc,fz,n,j)
         xc(j) = xcj
         do i=1,n
            rjac(i,j) = (fz(i)-fc(i)) / h
         enddo
      enddo

      return
      end

c-----------------------------------------------------------------------

      subroutine fdjac2(xc,fc,n,epsm,fvec,fz,rjac,ldr,dsub,dsuper,
     *                  w,xstep)

      integer ldr,n,dsub,dsuper
      double precision  epsm
      double precision  rjac(ldr,*),fz(*),xc(*),fc(*)
      double precision  w(*), xstep(*)
      external fvec

c-------------------------------------------------------------------------
c
c     Compute a banded finite difference jacobian at the current point xc
c
c     Arguments
c
c     In       xc      Real(*)         current point
c     In       fc      Real(*)         function values at current point
c     In       n       Integer         size of x and f
c     In       epsm    Real            machine precision
c     In       fvec    Name            name of routine to evaluate f(x)
c     Wk       fz      Real(*)         workspace
c     Out      rjac    Real(ldr,*)     jacobian matrix at x
c                                        entry [i,j] is derivative of
c                                        f(i) wrt to x(j)
c     In       ldr     Integer         leading dimension of rjac
c     In       dsub    Integer         number of subdiagonals
c     In       dsuper  Integer         number of superdiagonals
c     Internal w       Real(*)         for temporary saving of xc
c     Internal xstep   Real(*)         stepsizes
c
c-------------------------------------------------------------------------

      integer i,j,k
      double precision  ndigit,p,h
      double precision  rnudif

      double precision Rten
      parameter(Rten=10d0)

      integer dsum

      dsum = dsub + dsuper + 1

      ndigit = -log10(epsm)
      p = sqrt(max(Rten**(-ndigit),epsm))

      do k=1,n
         xstep(k) = p + p * abs(xc(k))
      enddo

      do k=1,dsum
         do j=k,n,dsum
            w(j) = xc(j)
            xc(j) = xc(j) + xstep(j)
         enddo

         call fvec(xc,fz,n,n+k)
         do j=k,n,dsum
             call nuzero(n,rjac(1,j))
c            fdjac0 for why
c            doing this ensures that results for fdjac2 and fdjac0 will be identical
             h = rnudif(xc(j),w(j))
             xc(j) = w(j)
             do i=max(j-dsuper,1),min(j+dsub,n)
                rjac(i,j) = (fz(i)-fc(i)) / h
             enddo
         enddo
      enddo

      return
      end

c-----------------------------------------------------------------------

      function nudnrm(n, d, x)
      integer n
      double precision  d(*), x(*)
      double precision nudnrm

c-------------------------------------------------------------------------
c
c     calculate  max( abs(d[*]) / max(x[*],1) )
c
c     Arguments
c
c     In   n        Integer       number of elements in d() and x()
c     In   d        Real(*)       vector d
c     In   x        Real(*)       vector x
c
c-------------------------------------------------------------------------

      integer i
      double precision  t

      double precision Rzero, Rone
      parameter(Rzero=0.0d0, Rone=1.0d0)

      t = Rzero
      do i=1,n
         t = max(t, abs(d(i)) / max(abs(x(i)),Rone))
      enddo
      nudnrm = t

      return
      end

c-----------------------------------------------------------------------

      function nuxnrm(n, xn, xc)
      integer n
      double precision  xn(*), xc(*)
      double precision nuxnrm

c-------------------------------------------------------------------------
c
c     calculate  max( abs(xn[*]-xc[*]) / max(xn[*],1) )
c
c     Arguments
c
c     In   n        Integer       number of elements in xn() and xc()
c     In   xn       Real(*)       vector xn
c     In   xc       Real(*)       vector xc
c
c-------------------------------------------------------------------------

      integer i
      double precision  t

      double precision Rzero, Rone
      parameter(Rzero=0.0d0, Rone=1.0d0)

      t = Rzero
      do i=1,n
         t = max(t, abs(xn(i)-xc(i)) / max(abs(xn(i)),Rone))
      enddo
      nuxnrm = t

      return
      end

c-----------------------------------------------------------------------

      function rnudif(x, y)
      double precision x, y
      double precision rnudif

c-------------------------------------------------------------------------
c
c     Return difference of x and y (x - y)
c
c     Arguments
c
c     In   x  Real      argument 1
c     In   y  Real      argument 2
c
c-------------------------------------------------------------------------

      rnudif = x - y
      return
      end

c-----------------------------------------------------------------------

      subroutine compmu(r,ldr,n,mu,y,ierr)

      integer ldr,n,ierr
      double precision r(ldr,*),mu,y(*)

c-------------------------------------------------------------------------
c
c     Compute a small perturbation mu for the (almost) singular matrix R.
c     mu is used in the computation of the Levenberg-Marquardt step.
c
c     Arguments
c
c     In       R       Real(ldr,*)     upper triangular matrix from QR
c     In       ldr     Integer         leading dimension of R
c     In       n       Integer         column dimension of R
c     Out      mu      Real            sqrt(l1 norm of R * infinity norm of R
c                                      * n * epsm * 100) designed to make
c                                        trans(R)*R + mu * I not singular
c     Wk       y       Real(*)         workspace for dlange
c     Out      ierr    Integer         0 indicating mu ok
c                                      3 indicating mu much too small
c
c-------------------------------------------------------------------------

      double precision aifnrm,al1nrm,epsm
      double precision dlantr
      double precision epsmch

      double precision Rhund
      parameter(Rhund=100d0)

c     get the infinity norm of R
c     get the l1 norm of R
      ierr = 0
      aifnrm = dlantr('I','U','N',n,n,r,ldr,y)
      al1nrm = dlantr('1','U','N',n,n,r,ldr,y)
      epsm = epsmch()
      mu = sqrt(n*epsm*Rhund)*aifnrm*al1nrm
c     matrix consists of zero's or near zero's
c     LM correction in liqrev will not work
      if( mu .le. Rhund*epsm ) then
         ierr = 3
      endif
      return
      end

c-----------------------------------------------------------------------

      subroutine cndjac(n,r,ldr,cndtol,rcond,rcdwrk,icdwrk,ierr)
      integer n,ldr,icdwrk(*),ierr
      double precision cndtol,rcond,r(ldr,*),rcdwrk(*)

c---------------------------------------------------------------------
c
c     Check r for singularity and/or ill conditioning
c
c     Arguments
c
c     In       n       Integer         dimension of problem
c     In       r       Real(ldr,*)     upper triangular R from QR decomposition
c     In       ldr     Integer         leading dimension of rjac
c     In       cndtol  Real            tolerance of test for ill conditioning
c                                       when rcond <= cndtol then ierr is set to 1
c                                       cndtol should be >= machine precision
c     Out      rcond   Real            inverse condition  of r
c     Wk       rcdwrk  Real(*)         workspace (for dtrcon)
c     Wk       icdwrk  Integer(*)      workspace (fordtrcon)
c     Out      ierr    Integer         0 indicating Jacobian not ill-conditioned or singular
c                                      1 indicating Jacobian too ill-conditioned
c                                      2 indicating Jacobian completely singular
c
c---------------------------------------------------------------------

      integer i,info
      logical rsing
      double precision Rzero
      parameter(Rzero=0.0d0)

      ierr = 0

      rsing = .false.
      do i=1,n
         if( r(i,i) .eq. Rzero ) then
             rsing = .true.
         endif
      enddo

      if( rsing ) then
         ierr = 2
         rcond = Rzero
      else
         call dtrcon('1','U','N',n,r,ldr,rcond,rcdwrk,icdwrk,info)
         if( rcond .eq. Rzero ) then
             ierr = 2
         elseif( rcond .le. cndtol ) then
             ierr = 1
         endif
      endif

      return
      end

c-----------------------------------------------------------------------

      subroutine nwfjac(x,scalex,f,fq,n,epsm,jacflg,fvec,mkjac,rjac,
     *                  ldr,xw,w,xstep)

      integer ldr,n,jacflg(*)
      double precision  epsm
      double precision  x(*),f(*),scalex(*),xw(*),w(*),xstep(*)
      double precision  rjac(ldr,*),fq(*)
      external fvec,mkjac

c-------------------------------------------------------------------------
c
c     Calculate the jacobian  matrix
c
c     Arguments
c
c     In       x       Real(*)         (scaled) current x values
c     In       scalex  Real(*)         scaling factors x
c     In       f       Real(*)         function values f(x)
c     Wk       fq      Real(*)         (internal) workspace
c     In       n       Integer         size of x and f
c     In       epsm    Real            machine precision
c     In       jacflg  Integer(*)      indicates how to compute jacobian
c                                      jacflg[1]:  0 numeric; 1 user supplied; 2 numerical banded
c                                                  3: user supplied banded
c                                      jacflg[2]: number of sub diagonals or -1 if not banded
c                                      jacflg[3]: number of super diagonals or -1 if not banded
c                                      jacflg[4]: 1 if adjusting jacobian allowed when
c                                                   singular or illconditioned
c     In       fvec    Name            name of routine to evaluate f()
c     In       mkjac   Name            name of routine to evaluate jacobian
c     Out      rjac    Real(ldr,*)     jacobian matrix (unscaled)
c     In       ldr     Integer         leading dimension of rjac
c     Internal xw      Real(*)         used for storing unscaled x
c     Internal w       Real(*)         workspace for banded jacobian
c     Internal xstep   Real(*)         workspace for banded jacobian
c
c-------------------------------------------------------------------------

c     compute the finite difference or analytic jacobian at x

      call dcopy(n,x,1,xw,1)
      call vunsc(n,xw,scalex)
      if(jacflg(1) .eq. 0) then
         call fdjac0(xw,f,n,epsm,fvec,fq,rjac,ldr)
      elseif(jacflg(1) .eq. 2) then
         call fdjac2(xw,f,n,epsm,fvec,fq,rjac,ldr,jacflg(2),jacflg(3),
     *               w,xstep)
      else
         call mkjac(rjac,ldr,xw,n)
      endif

      return
      end

c-----------------------------------------------------------------------

      subroutine nwscjac(n,rjac,ldr,scalex)
      integer n, ldr
      double precision rjac(ldr,*), scalex(*)

c-------------------------------------------------------------------------
c
c     Scale jacobian
c
c     Arguments
c
c     In       n       Integer         size of x and f
c     Inout    rjac    Real(ldr,*)     jacobian matrix
c     In       ldr     Integer         leading dimension of rjac
c     In       scalex  Real(*)         scaling factors for x
c
c-------------------------------------------------------------------------

      integer j
      double precision t, Rone
      parameter(Rone=1.0d0)

      do j = 1,n
         t = Rone/scalex(j)
         call dscal(n,t,rjac(1,j),1)
      enddo

      return
      end

c-----------------------------------------------------------------------

      subroutine nwunscjac(n,rjac,ldr,scalex)
      integer n, ldr
      double precision rjac(ldr,*), scalex(*)

c-------------------------------------------------------------------------
c
c     Unscale jacobian
c
c     Arguments
c
c     In       n       Integer         size of x and f
c     Inout    rjac    Real(ldr,*)     jacobian matrix
c     In       ldr     Integer         leading dimension of rjac
c     In       scalex  Real(*)         scaling factors for x
c
c-------------------------------------------------------------------------

      integer j
      double precision t

      do j = 1,n
         t = scalex(j)
         call dscal(n,t,rjac(1,j),1)
      enddo

      return
      end

c-----------------------------------------------------------------------

      subroutine nwcpsx(n,rjac,ldr,scalex,epsm, mode)

      integer ldr,n,mode
      double precision  epsm
      double precision  scalex(*)
      double precision  rjac(ldr,*)

c-------------------------------------------------------------------------
c
c     Calculate scaling factors from the jacobian  matrix
c
c     Arguments
c
c     In       n       Integer         size of x and f
c     In       rjac    Real(ldr,*)     jacobian matrix
c     In       ldr     Integer         leading dimension of rjac
c     Out      scalex  Real(*)         scaling factors for x
c     In       epsm    Real            machine precision
c     In       mode    Integer         1: initialise, >1: adjust
c-------------------------------------------------------------------------

      integer k
      double precision  dnrm2

      if( mode .eq. 1 ) then
         do k=1,n
            scalex(k) = dnrm2(n,rjac(1,k),1)
            if( scalex(k) .le. epsm ) scalex(k) = 1
         enddo
      else if( mode .gt. 1 ) then
         do k=1,n
            scalex(k) = max(scalex(k),dnrm2(n,rjac(1,k),1))
         enddo
      endif
      return
      end

c-----------------------------------------------------------------------

      subroutine nwcpmt(n, x, scalex, factor, wrk, stepsiz)
      double precision x(*), scalex(*), wrk(*)
      double precision factor, stepsiz
      integer n

c-------------------------------------------------------------------------
c
c     Calculate maximum stepsize
c
c     Arguments
c
c     In       n       Integer     size of x
c     In       x       Real(*)     x-values
c     In       scalex  Real(*)     scaling factors for x
c     In       factor  Real        multiplier
c     Inout    wrk     Real(*)     workspace
c     Out      stepsiz Real        stepsize
c
c     Currently not used
c     Minpack uses this to calculate initial trust region size
c     Not (yet) used in this code because it doesn't seem to help
c     Manually setting an initial trust region size works better
c
c-------------------------------------------------------------------------

      double precision Rzero
      parameter(Rzero=0.0d0)

      double precision  dnrm2

      call dcopy(n,x,1,wrk,1)
      call vscal(n,wrk,scalex)
      stepsiz = factor * dnrm2(n,wrk,1)
      if( stepsiz .eq. Rzero ) stepsiz = factor
      return
      end

c-----------------------------------------------------------------------

      subroutine vscal(n,x,sx)

      integer n
      double precision  x(*),sx(*)

c-------------------------------------------------------------------------
c
c     Scale a vector x
c
c     Arguments
c
c     In       n       Integer         size of x
c     Inout    x       Real(*)         vector to scale
c     In       sx      Real(*)         scaling vector
c
c-------------------------------------------------------------------------

      integer i

      do i = 1,n
         x(i) = sx(i) * x(i)
      enddo

      return
      end

c-----------------------------------------------------------------------

      subroutine vunsc(n,x,sx)

      integer n
      double precision  x(*),sx(*)

c-------------------------------------------------------------------------
c
c     Unscale a vector x
c
c     Arguments
c
c     In       n       Integer         size of x
c     Inout    x       Real(*)         vector to unscale
c     In       sx      Real(*)         scaling vector
c
c-------------------------------------------------------------------------

      integer i

      do i = 1,n
         x(i) = x(i) / sx(i)
      enddo

      return
      end

c-----------------------------------------------------------------------

      subroutine nwfvec(x,n,scalex,fvec,f,fnorm,xw)

      integer n
      double precision  x(*),xw(*),scalex(*),f(*),fnorm
      external fvec

c-------------------------------------------------------------------------
c
c     Evaluate the function at current iterate x and scale its value
c
c     Arguments
c
c     In       x       Real(*)         x
c     In       n       Integer         size of x
c     In       scalex  Real(*)         scaling vector for x
c     In       fvec    Name            name of routine to calculate f(x)
c     Out      f       Real(*)         f(x)
c     Out      fnorm   Real            .5*||f(x)||**2
c     Internal xw      Real(*)         used for storing unscaled xc
c
c-------------------------------------------------------------------------

      double precision dnrm2

      double precision Rhalf
      parameter(Rhalf=0.5d0)

      call dcopy(n,x,1,xw,1)
      call vunsc(n,xw,scalex)
      call fvec(xw,f,n,0)

      fnorm = Rhalf * dnrm2(n,f,1)**2

      return
      end

c-----------------------------------------------------------------------

      function epsmch()

c     Return machine precision
c     Use Lapack routine

      double precision epsmch
      double precision dlamch
      external dlamch

c     dlamch('e') returns negeps (1-eps)
c     dlamch('p') returns 1+eps

      epsmch = dlamch('p')

      return
      end

c-----------------------------------------------------------------------

      function dblhuge()

c     Return largest double precision number
c     Use Lapack routine

      double precision dblhuge
      double precision dlamch
      external dlamch

c     dlamch('o') returns max double precision

      dblhuge = dlamch('o')

      return
      end

      subroutine nwnleq(x0,n,scalex,maxit,
     *                  jacflg,xtol,ftol,btol,cndtol,method,global,
     *                  xscalm,stepmx,delta,sigma,rjac,ldr,
     *                  rwork,lrwork,
     *                  rcdwrk,icdwrk,qrwork,qrwsiz,fjac,fvec,outopt,xp,
     *                  fp,gp,njcnt,nfcnt,iter,termcd)

      integer n,jacflg(*),maxit,njcnt,nfcnt,iter,termcd,method
      integer global,xscalm,ldr,lrwork,qrwsiz
      integer outopt(*)
      double precision  xtol,ftol,btol,cndtol,stepmx,delta,sigma
      double precision  xp(*),fp(*),gp(*),x0(*)
      double precision  rjac(ldr,*),rwork(*),rcdwrk(*),qrwork(*)
      double precision  scalex(*)
      integer           icdwrk(*)
      external fjac,fvec

c-------------------------------------------------------------------------
c
c     Solves systems of nonlinear equations using the Newton / Broyden
c     method with a global strategy either linesearch or double dogleg
c
c     In       x0      Real(*)         starting vector for x
c     In       n       Integer         dimension of problem
c     Inout    scalex  Real(*)         scaling factors x()
c     Inout    maxit   Integer         maximum number iterations
c     Inout    jacflg  Integer(*)      jacobian flag array
c                                      jacflg[1]:  0 numeric; 1 user supplied; 2 numerical banded
c                                                  3: user supplied banded
c                                      jacflg[2]: number of sub diagonals or -1 if not banded
c                                      jacflg[3]: number of super diagonals or -1 if not banded
c                                      jacflg[4]: 1 if adjusting step allowed when
c                                                   singular or illconditioned
c     Inout    xtol    Real            x tolerance
c     Inout    ftol    Real            f tolerance
c     Inout    btol    Real            x tolerance for backtracking
c     Inout    cndtol  Real            tolerance of test for ill conditioning
c     Inout    method  Integer         method to use
c                                        0 Newton
c                                        1 Broyden
c     In       global  Integer         global strategy to use
c                                        1 cubic linesearch
c                                        2 quadratic linesearch
c                                        3 geometric linesearch
c                                        4 double dogleg
c                                        5 powell dogleg
c                                        6 hookstep (More-Hebden Levenberg-Marquardt)
c     In       xscalm  Integer         scaling method
c                                        0 scale fixed and supplied by user
c                                        1 for scale from jac. columns a la Minpack
c     Inout    stepmx  Real            maximum stepsize
c     Inout    delta   Real            trust region radius
c                                        > 0.0 or special value for initial value
c                                        -1.0  ==> use min(Cauchy length, stepmx)
c                                        -2.0  ==> use min(Newton length, stepmx)
c     Inout    sigma   Real            reduction factor geometric linesearch
c     Inout    rjac    Real(ldr,*)     workspace jacobian
c                                         2*n*n for Broyden and n*n for Newton
c     In       ldr     Integer         leading dimension rjac
c     Out      rwork   Real(*)         real workspace (9n)
c     In       lrwork  Integer         size real workspace
c     In       rcdwrk  Real(*)         workspace for Dtrcon (3n)
c     In       icdwrk  Integer(*)      workspace for Dtrcon (n)
c     In       qrwork  Real(*)         workspace for Lapack QR routines (call liqsiz)
c     In       qrwsiz  Integer         size of qrwork
c     In       fjac    Name            optional name of routine to calculate
c                                      user supplied jacobian
c     In       fvec    Name            name of routine to calculate f(x)
c     In       outopt  Integer(*)      output options
c                                       outopt(1)
c                                         0 no output
c                                         1 output an iteration report
c                                       outopt(2)
c                                         0 do not check any user supplied jacobian
c                                         1 check user supplied jacobian if supplied
c     Out      xp      Real(*)         final values for x()
c     Out      fp      Real(*)         final values for f(x)
c     Out      gp      Real(*)         gradient of f() at xp()
c     Out      njcnt   Integer         number of jacobian evaluations
c     Out      nfcnt   Integer         number of function evaluations
c     Out      iter    Integer         number of (outer) iterations
c     Out      termcd  Integer         termination code
c                                       > 0 process terminated
c                                             1  function criterion near zero
c                                             2  no better point found
c                                             3  x-values within tolerance
c                                             4  iteration limit exceeded
c                                             5  singular/ill-conditioned jacobian
c                                             6  totally singular jacobian
c                                                (when allowSingular=TRUE)
c
c                                       < 0 invalid input parameters
c                                            -1  n not positive
c                                            -2  insufficient workspace rwork
c                                            -3  cannot check user supplied jacobian (not supplied)
c
c    The subroutine fvec must be declared as
c
c!        subroutine fvec(x,f,n,flag)
c         double precision x(*), f(*)
c         integer  n, flag
c
c         x() are the x values for which to calculate the function values f(*)
c         The dimension of these vectors is n
c         The flag argument is set to
c            0  for calculation of function values
c           >0  indicating that jacobian column <flag> is being computed
c               so that fvec can abort.
c
c    The subroutine fjac must be declared as
c
c!        subroutine mkjac(rjac,ldr,x,n)
c         integer ldr
c         double precision rjac(ldr,*), x(*)
c         integer  n
c
c         The routine calculates the jacobian in point x(*) of the
c         function. If any illegal values are encountered during
c         calculation of the jacobian it is the responsibility of
c         the routine to quit.

c-------------------------------------------------------------------------

      double precision epsm

c     check input parameters

      call nwpchk(n,lrwork,xtol,ftol,btol,cndtol,maxit,
     *            jacflg,method,global,stepmx,delta,sigma,
     *            epsm,outopt,scalex,xscalm,termcd)
      if(termcd .lt. 0) then
         return
      endif

c     first argument of nwsolv/brsolv is leading dimension of rjac in those routines
c     should be at least n

      if( method .eq. 0 ) then

         call nwsolv(ldr,x0,n,scalex,maxit,jacflg,
     *               xtol,ftol,btol,cndtol,global,xscalm,
     *               stepmx,delta,sigma,
     *               rjac,
     *               rwork(1    ),rwork(1+  n),
     *               rwork(1+2*n),rwork(1+3*n),
     *               rwork(1+4*n),rwork(1+5*n),
     *               rwork(1+6*n),rwork(1+7*n),
     *               rwork(1+8*n),rcdwrk,icdwrk,qrwork,qrwsiz,epsm,
     *               fjac,fvec,outopt,xp,fp,gp,njcnt,nfcnt,iter,termcd)

      elseif( method .eq. 1 ) then

         call brsolv(ldr,x0,n,scalex,maxit,jacflg,
     *               xtol,ftol,btol,cndtol,global,xscalm,
     *               stepmx,delta,sigma,
     *               rjac,rjac(1,n+1),
     *               rwork(1    ),rwork(1+  n),
     *               rwork(1+2*n),rwork(1+3*n),
     *               rwork(1+4*n),rwork(1+5*n),
     *               rwork(1+6*n),rwork(1+7*n),
     *               rwork(1+8*n),rcdwrk,icdwrk,
     *               qrwork,qrwsiz,epsm,
     *               fjac,fvec,outopt,xp,fp,gp,njcnt,nfcnt,iter,termcd)

      endif

      return
      end

c-----------------------------------------------------------------------

      subroutine nwpchk(n,lrwk,
     *                  xtol,ftol,btol,cndtol,maxit,jacflg,method,
     *                  global,stepmx,delta,sigma,epsm,outopt,
     *                  scalex,xscalm,termcd)

      integer n,lrwk,jacflg(*)
      integer method,global,maxit,xscalm,termcd
      integer outopt(*)
      double precision  xtol,ftol,btol,cndtol,stepmx,delta,sigma,epsm
      double precision  scalex(*)

c-------------------------------------------------------------------------
c
c     Check input arguments for consistency and modify if needed/harmless
c
c     Arguments
c
c     In       n       Integer         dimension of problem
c     In       lrwk    Integer         size real workspace
c     Inout    xtol    Real            x tolerance
c     Inout    ftol    Real            f tolerance
c     Inout    btol    Real            x tolerance for backtracking
c     Inout    cndtol  Real            tolerance of test for ill conditioning
c     Inout    maxit   Integer         maximum number iterations
c     Inout    jacflg  Integer(*)      jacobian flag
c     Inout    method  Integer         method to use (Newton/Broyden)
c     Inout    global  Integer         global strategy to use
c     Inout    stepmx  Real            maximum stepsize
c     Inout    delta     Real            trust region radius
c     Inout    sigma   Real            reduction factor geometric linesearch
c     Out      epsm                    machine precision
c     Inout    scalex  Real(*)         scaling factors x()
c     Inout    xscalm  integer         0 for fixed scaling, 1 for automatic scaling
c     Out      termcd  Integer         termination code (<0 on errors)
c
c-------------------------------------------------------------------------

      integer i,len
      double precision epsmch, dblhuge, Rhuge

      double precision Rzero, Rone, Rtwo, Rthree
      parameter(Rzero=0.0d0, Rone=1.0d0, Rtwo=2.0d0, Rthree=3.0d0)

      double precision Rhalf
      parameter(Rhalf = 0.5d0)

c     check that parameters only take on acceptable values
c     if not, set them to default values

c     initialize termcd to all ok

      termcd = 0

c     compute machine precision

      epsm = epsmch()

c     get largest double precision number
      Rhuge = dblhuge()

c     check dimensions of the problem

      if(n .le. 0) then
         termcd = -1
         return
      endif

c     check dimensions of workspace arrays

      len = 9*n
c      +2*n*n
      if(lrwk .lt. len) then
         termcd = -2
         return
      endif

c     check jacflg, method, and global

      if(jacflg(1) .gt. 3 .or. jacflg(1) .lt. 0) jacflg(1) = 0

      if(method .lt. 0 .or. method .gt. 1) method = 0

      if(global .lt. 0 .or. global .gt. 6) global = 4

c     set outopt to correct values

      if(outopt(1) .ne. 0 ) then
         outopt(1) = 1
      endif

      if(outopt(2) .ne. 0 ) then
         outopt(2) = 1
      endif

c     check scaling scale matrices

      if(xscalm .eq. 0) then
         do i = 1,n
            if(scalex(i) .lt. Rzero) scalex(i) = -scalex(i)
            if(scalex(i) .eq. Rzero) scalex(i) = Rone
         enddo
      else
         xscalm = 1
         do i = 1,n
            scalex(i) = Rone
         enddo
      endif
c     check step and function tolerances

      if(xtol .lt. Rzero) then
         xtol = epsm**(Rtwo/Rthree)
      endif

      if(ftol .lt. Rzero) then
         ftol = epsm**(Rtwo/Rthree)
      endif

      if( btol .lt. xtol ) btol = xtol

      cndtol = max(cndtol, epsm)

c     check reduction in geometric linesearch

      if( sigma .le. Rzero .or. sigma .ge. Rone ) then
         sigma = Rhalf
      endif

c     check iteration limit

      if(maxit .le. 0) then
         maxit = 150
      endif

c     set stepmx

      if(stepmx .le. Rzero) stepmx = Rhuge

c     check delta
      if(delta .le. Rzero) then
         if( delta .ne. -Rtwo ) then
            delta = -Rone
         endif
      elseif(delta .gt. stepmx) then
         delta = stepmx
      endif

      return
      end

      subroutine limhpar(R, ldr, n, sdiag, qtf, dn, dnlen,
     *                   glen, delta, mu, d, work)
      integer ldr, n
      double precision R(ldr,*), sdiag(*)
      double precision qtf(*),dn(*), dnlen, glen, d(*),work(*)
      double precision delta, mu

c-----------------------------------------------------------------------------
c
c     Arguments
c
c       Inout  R      Real(ldr,*)     upper triangular matrix R from QR (unaltered)
c                                     strict lower triangle contains
c                                        transposed strict upper triangle of the upper
c                                        triangular matrix S.
c
c       In     n      Integer         order of R.
c
c       In     ldr    Integer         leading dimension of the array R.
c
c       Out    sdiag  Real(*)         vector of size n, containing the
c                                     diagonal elements of the upper
c                                     triangular matrix S.
c
c       In     qtr    Real(*)         trans(Q)*f vector of size n
c       In     dn     Real(*)         Newton step
c       In     dnlen  Real            length Newton step
c       In     glen   Real            length gradient vector
c
c       Inout  mu     Real            Levenberg-Marquardt parameter
c       In     delta  Real            size of trust region (euclidian norm)
c
c       Out    d      Real(*)         vector with step with norm very close to delta
c       Out    work   Real(*)         workspace of size n.
c
c     Description
c
c     determine Levenberg-Marquardt parameter mu such that
c     norm[(R**T R + mu*I)**(-1) * qtf] - delta approximately 0
c     See description in liqrev.f for further details
c
c     Algorithm comes from More: The Levenberg-Marquardt algorithm, Implementation and Theory
c     Lecture Notes in Mathematics, 1978, no. 630.
c     uses liqrev (in file liqrev.f) which is based on Nocedal's method (see comments in file)
c-----------------------------------------------------------------------------

      double precision phi, pnorm, qnorm, mulo, muhi,dmu, sqmu
      integer iter
      logical done
      double precision dnrm2

      double precision Rone
      parameter(Rone=1.0D0)

      phi = dnlen - delta
      muhi = glen/delta

      call dcopy(n,dn,1,d,1)
      call dscal(n, Rone/dnlen, d, 1)

c     solve R**T * x = dn
      call dtrsv("U","T","N",n,R,ldr,d,1)
      qnorm = dnrm2(n,d,1)
      mulo = (phi/dnlen)/qnorm**2
      mu = mulo

      iter = 0
      done = .false.
      do while( .not. done )
          iter = iter + 1
          sqmu = sqrt(mu)
          call liqrev(n, R, ldr, sqmu, qtf, d, sdiag, work)
          pnorm = dnrm2(n,d,1)
          call dcopy(n,d,1,work,1)
          call dtrstt(R, ldr, n, sdiag, work)
          done = abs(pnorm-delta) .le. .1d0*delta .or. iter .gt. 5
          if( .not. done ) then
              qnorm = dnrm2(n,work,1)
              if( pnorm .gt. delta ) then
                  mulo = max(mulo,mu)
              else if( pnorm .lt. delta ) then
                  muhi = min(muhi,mu)
              endif
              dmu = (pnorm-delta)/delta * (pnorm/qnorm)**2
              mu = max(mulo, mu + dmu)
          endif
      enddo
      return
      end

# Dennis Schnabel example

library("nleqslv")

dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1]-1) + x[2]^3 - 2
    y
}

jacdsln <- function(x) {
    n <- length(x)
    Df <- matrix(numeric(n*n),n,n)
    Df[1,1] <- 2*x[1]
    Df[1,2] <- 2*x[2]
    Df[2,1] <- exp(x[1]-1)
    Df[2,2] <- 3*x[2]^2

    Df
}

xstart <- c(2,0.5)
fstart <- dslnex(xstart)
xstart
fstart

# a solution is c(1,1)

do.print.xf <- FALSE

print.result <- function(z) {
    if( do.print.xf ) {
        print(z$x)
        print(z$fvec)
    }
    print(z$message)
    print(all(abs(z$fvec)<=1e-8))
}

# Use our fixed scaling

znlq <- nleqslv(xstart, dslnex, jacdsln, global="dbldog", control=list(btol=.01,delta=-1.0,chkjac=TRUE,scalex=c(2,3)))
if(znlq$termcd == -10) stop("Internal error in check analytical jacobian")

# Broyden analytical jacobian
for( z in c("dbldog","pwldog") ) {  # double dogleg, Powell (single) dogleg
    for( delta in c(-1.0, -2.0) ) { # Cauchy step , Newton step
        znlq <- nleqslv(xstart, dslnex, jacdsln, global=z, control=list(btol=.01,delta=delta,chkjac=TRUE,scalex=c(2,3)))
        print.result(znlq)
    }
}

# Newton analytical jacobian
for( z in c("dbldog","pwldog") ) {  # double dogleg, Powell (single) dogleg
    for( delta in c(-1.0, -2.0) ) { # Cauchy step , Newton step
        znlq <- nleqslv(xstart, dslnex, jacdsln, method="Newton", global=z, control=list(btol=.01,delta=delta,chkjac=TRUE,scalex=c(2,3)))
        print.result(znlq)
    }
}

#' Solve a nonlinear equation system with multiple roots from multiple initial
#' estimates
#'
#' This function solves a system of nonlinear equations with \code{nleqlsv} for
#' multiple initial estimates of the roots.
#'
#' Each row of \code{x} is a vector of initial estimates for the argument
#' \code{x} of \code{nleqslv}. The function runs \code{nleqslv} for each row of
#' the matrix \code{x}. The first initial value is treated separately and
#' slightly differently from the other initial estimates. It is used to check
#' if all arguments in \code{...} are valid arguments for \code{nleqslv} and
#' the function to be solved. This is done by running \code{nleqslv} with no
#' condition handling. If an error is then detected an error message is issued
#' and the function stops. For the remaining initial estimates \code{nleqslv}
#' is executed silently. Only solutions for which the \code{nleqslv}
#' termination code \code{tcode} equals \code{1} are regarded as valid
#' solutions. The rounded solutions (after removal of duplicates) are used to
#' order the solutions in increasing order. These rounded solutions are not
#' included in the return value of the function.
#'
#' @param x A matrix with each row containing an initial guess of the roots.
#' @param fn A function of \code{x} returning a vector of function values with
#' the same length as the vector \code{x}.
#' @param digits integer passed to \code{\link{round}} for locating and
#' removing duplicate rounded solutions.
#' @param \dots Further arguments to be passed to \code{\link{nleqslv}},
#' \code{fn} and \code{jac}.
#' @return If no solutions are found \code{NULL} is returned. Otherwise a list
#' containing the following components is returned \describe{
#' \item{\code{x}}{a matrix with each row containing a unique solution
#' (unrounded)} \item{\code{xfnorm}}{a vector of the function criterion
#' associated with each row of the solution matrix \code{x}.}
#' \item{\code{fnorm}}{a vector containing the function criterion for every
#' converged result} \item{\code{idxcvg}}{a vector containing the row indices
#' of the matrix of initial estimates for which function value convergence was
#' achieved} \item{\code{idxxtol}}{a vector containing the row indices of the
#' matrix of initial estimates for which x-value convergence was achieved}
#' \item{\code{idxnocvg}}{a vector containing the row indices of the matrix of
#' initial estimates which lead to an \code{nleqslv} termination code > 2}
#' \item{\code{idxfatal}}{a vector containing the row indices of the matrix of
#' initial estimates for which a fatal error occurred that made \code{nleqslv}
#' stop} \item{\code{xstart}}{a matrix of the initial estimates corresponding
#' to the solution matrix} \item{\code{cvgstart}}{a matrix of all initial
#' estimates for which convergence was achieved} }
#' @keywords nonlinear optimize
#' @examples
#'
#' # Dennis Schnabel example 6.5.1 page 149 (two solutions)
#' set.seed(123)
#' dslnex <- function(x) {
#'     y <- numeric(2)
#'     y[1] <- x[1]^2 + x[2]^2 - 2
#'     y[2] <- exp(x[1]-1) + x[2]^3 - 2
#'     y
#' }
#' xstart <- matrix(runif(50, min=-2, max=2),ncol=2)
#' ans <- searchZeros(xstart,dslnex, method="Broyden",global="dbldog")
#' ans
#'
#' # more complicated example
#' # R. Baker Kearfott, Some tests of Generalized Bisection,
#' # ACM Transactions on Methematical Software, Vol. 13, No. 3, 1987, pp 197-220
#'
#' # A high-degree polynomial system (section 4.3 Problem 12)
#' # There are 12 real roots (and 126 complex roots to this system!)
#'
#' hdp <- function(x) {
#'     f <- numeric(length(x))
#'     f[1] <- 5 * x[1]^9 - 6 * x[1]^5 * x[2]^2 + x[1] * x[2]^4 + 2 * x[1] * x[3]
#'     f[2] <- -2 * x[1]^6 * x[2] + 2 * x[1]^2 * x[2]^3 + 2 * x[2] * x[3]
#'     f[3] <- x[1]^2 + x[2]^2 - 0.265625
#'     f
#' }
#'
#'
#' N <- 40 # at least to find all 12 roots
#' set.seed(123)
#' xstart <- matrix(runif(3*N,min=-1,max=1), N, 3)  # N initial guesses, each of length 3
#' ans <- searchZeros(xstart,hdp, method="Broyden",global="dbldog")
#' ans$x
#'
#' @export searchZeros
searchZeros <- function(x, fn, digits=4L, ... )
{
    if( !is.numeric(x) ) stop('argument x should be numeric')
    if( !is.matrix(x)  ) stop('argument x must be a matrix')
    if( any(is.na(x))  ) stop("argument x may not contain NA")
    if( !is.numeric(digits) ) stop('argument digits should be numeric')
    if( is.na(digits)  ) digits <- 4L

    N <- nrow(x)
    if( N < 1 ) stop("Matrix 'x' must have at least 1 row")

    tcode <- numeric(N)
    fnorm <- numeric(N)
    xmat  <- matrix(NA, nrow=N, ncol=ncol(x))

    kerr <- numeric(N)
    kptr <- 0

    # for k==1 check that all arguments are correct --> no try

    for ( k in seq_len(N) ){
        if( k == 1 ) {
            z <- nleqslv(x[k, ], fn=fn, ...)
        } else {
            z <- try(nleqslv(x[k, ], fn=fn, ...), silent=TRUE)
            if( inherits(z, "try-error") ) {
                kptr <- kptr+1
                kerr[kptr] <- k
                next
            }
        }
        tcode[k]  <- z$termcd
        fnorm[k]  <- norm(z$fvec,"2")^2/2 # criterion for global methods
        xmat[k, ] <- z$x
    }

    # locate index of converged trials and store corresponding starting values
    # return NULL if no full convergence obtained
    if(!any(tcode==1)) return(NULL)
    idxcvg <- which(tcode==1)
    xstartcvg <- x[idxcvg,,drop=FALSE]
    # rounded solutions for locating duplicates and remove duplicates
    xsol <- round(xmat[idxcvg,,drop=FALSE], digits)
    notdups <- !duplicated(xsol)
    xsol <- xsol[notdups,,drop=FALSE]
    solstart <- xstartcvg[notdups,,drop=FALSE]
    if( !is.null(colnames(x)) ) {
        colnames(xmat) <- colnames(x)
        colnames(xsol) <- colnames(x)
        colnames(solstart) <- colnames(x)
    }

    # order the rounded solution
    if( nrow(xsol) > 1 ) {
        zidxo <- do.call(order,split(xsol,col(xsol)))
    } else {
        zidxo <- 1
    }

    idxfatal <- if(kptr) kerr[1:kptr] else integer(0)
    idxxtol   <- which(tcode==2)
    idxnocvg <- which(tcode>2)
    # original unrounded solutions with duplicates (above) removed
    xsol <- xmat[idxcvg,,drop=FALSE][notdups,,drop=FALSE]

    # return full precision solutions ordered with rounded ordering
    res <- list(x=xsol[zidxo,,drop=FALSE], xfnorm=fnorm[idxcvg][notdups][zidxo],
                fnorm=fnorm[idxcvg], idxcvg=idxcvg, idxxtol=idxxtol,
                idxnocvg=idxnocvg, idxfatal=idxfatal,
                xstart=solstart[zidxo,,drop=FALSE],cvgstart=xstartcvg)
    res
}

# Copyright (c) Rob Carnell 2026

# High-degree polynomial system from Kearfott (1987)
hdp <- function(x) {
  f <- numeric(3)
  f[1] <- 5 * x[1]^9 - 6 * x[1]^5 * x[2]^2 + x[1] * x[2]^4 + 2 * x[1] * x[3]
  f[2] <- -2 * x[1]^6 * x[2] + 2 * x[1]^2 * x[2]^3 + 2 * x[2] * x[3]
  f[3] <- x[1]^2 + x[2]^2 - 0.265625
  f
}

test_that("searchZeros finds 12 real roots for Kearfott high-degree polynomial system", {
  set.seed(123)

  N <- 40
  xstart <- matrix(runif(3 * N, min = -1, max = 1), nrow = N, ncol = 3)

  ans <- searchZeros(
    xstart, hdp,
    method = "Broyden",
    global = "dbldog"
  )

  # Expect exactly 12 distinct real roots
  expect_equal(nrow(ans$x), 12)

  # All solutions must satisfy ||f(x)|| <= 1e-10
  expect_true(all(ans$xfnorm <= 1e-10))

  # Re-run from the discovered roots
  zans <- searchZeros(
    ans$xstart, hdp,
    method = "Broyden",
    global = "dbldog"
  )

  expect_equal(length(zans$idxcvg), 12)
})

# Copyright (c) Rob Carnell 2026

test_that("Cutlip reaction-rate system converges to 4 steady-state solutions", {
  # Problem 2 from Shacham (1986)
  cutlip <- function(x) {
    k1  <- 17.721
    k2  <-  3.483
    k3  <- 505.051
    kr1 <-  0.118
    kr2 <-  0.033

    r <- numeric(6)
    r[1] <- 1 - x[1] - k1 * x[1] * x[6] + kr1 * x[4]
    r[2] <- 1 - x[2] - k2 * x[2] * x[6] + kr2 * x[5]
    r[3] <- -x[3] + 2 * k3 * x[4] * x[5]
    r[4] <- k1 * x[1] * x[6] - kr1 * x[4] - k3 * x[4] * x[5]
    r[5] <- 1.5 * (k2 * x[2] * x[6] - kr2 * x[5]) - k3 * x[4] * x[5]
    r[6] <- 1 - x[4] - x[5] - x[6]
    r
  }

  # Reproducible random starts
  RNGkind(kind = "Wichmann-Hill")
  set.seed(123)

  Nrep <- 50
  xstart <- matrix(0, nrow = Nrep, ncol = 6)
  xstart[, 1] <- runif(Nrep, 0, 2)
  xstart[, 2] <- runif(Nrep, 0, 1)
  xstart[, 3] <- runif(Nrep, 0, 2)
  xstart[, 4] <- runif(Nrep, 0, 1)
  xstart[, 5] <- runif(Nrep, 0, 1)
  xstart[, 6] <- runif(Nrep, 0, 1)

  # First search
  ans <- searchZeros(
    xstart,
    cutlip,
    method = "Broyden",
    global = "dbldog"
  )

  # Expect exactly 4 distinct solutions
  expect_equal(nrow(ans$x), 4)

  # All solutions must satisfy the tolerance
  expect_true(all(ans$xfnorm <= 1e-10))

  # Restart from converged points
  zans <- searchZeros(
    ans$xstart,
    cutlip,
    method = "Broyden",
    global = "dbldog"
  )

  # Should again converge to 4 solutions
  expect_equal(length(zans$idxcvg), 4)

  # Solutions should match exactly
  expect_equal(ans$xfnorm, zans$xfnorm)
})

test_that("seachZeros works", {
  xstart <- matrix(c(1,2,3,
                     4,5,6), nrow = 2, ncol = 3, byrow = TRUE)
  z <- searchZeros(xstart, common_test_f)

  expect_error(searchZeros("A", common_test_f))
  expect_error(searchZeros(1:3, common_test_f))
  expect_no_error(searchZeros(xstart, common_test_f, digits = as.numeric(NA)))
  expect_error(searchZeros(xstart, common_test_f, digits = "A"))
  colnames(xstart) <- LETTERS[1:3]
  expect_no_error(searchZeros(xstart, common_test_f))

  xstart[2,2] <- NA
  expect_error(searchZeros(xstart, common_test_f))

  expect_error(searchZeros(1:3, common_test_f))

  expect_error(searchZeros(matrix(nrow = 0, ncol = 5), common_test_f))
})

      subroutine nwpure(n,xc,d,stepmx,scalex,fvec,
     *                  xp,fp,fpnorm,xw,retcd,gcnt,priter,iter)

      integer n,retcd,gcnt
      double precision  stepmx,fpnorm
      double precision  xc(*)
      double precision  d(*),xp(*),fp(*),xw(*)
      double precision  scalex(*)
      external fvec

      integer priter,iter

c-------------------------------------------------------------------------
c
c     Find a next iterate using geometric line search
c     along the newton direction
c
c     Arguments
c
c     In       n       Integer          dimension of problem
c     In       xc      Real(*)          current iterate
c     In       d       Real(*)          newton direction
c     In       stepmx  Real             maximum stepsize
c     In       scalex  Real(*)          diagonal scaling matrix for x()
c     In       fvec    Name             name of routine to calculate f()
c     In       xp      Real(*)          new x()
c     In       fp      Real(*)          new f(x)
c     In       fpnorm  Real             .5*||fp||**2
c     Out      xw      Real(*)          workspace for unscaling x
c
c     Out      retcd   Integer          return code
c                                         0 new satisfactory x() found (!always)
c
c     Out      gcnt    Integer          number of steps taken
c     In       priter  Integer           >0 if intermediate steps to be printed
c                                        -1 if no printing
c
c-------------------------------------------------------------------------

      integer i
      double precision  oarg(3)
      double precision  lambda
      double precision  dnrm2
      double precision  dlen

      integer idamax

      double precision Rone
      parameter(Rone=1.0d0)

c     safeguard initial step size

      dlen = dnrm2(n,d,1)
      if( dlen .gt. stepmx ) then
          lambda = stepmx / dlen
      else
          lambda = Rone
      endif

      retcd  = 0
      gcnt   = 1

c     compute the next iterate xp

      do i=1,n
         xp(i) = xc(i) + lambda*d(i)
      enddo

c     evaluate functions and the objective function at xp

      call nwfvec(xp,n,scalex,fvec,fp,fpnorm,xw)

      if( priter .gt. 0) then
         oarg(1) = lambda
         oarg(2) = fpnorm
         oarg(3) = abs(fp(idamax(n,fp,1)))
         call nwprot(iter,1,oarg)
      endif

      return
      end

      subroutine nwnjac(rjac,ldr,n,xc,fc,fq,fvec,fjac,epsm,jacflg,
     *                  wrk1,wrk2,wrk3,
     *                  xscalm,scalex,gp,cndtol,rcdwrk,icdwrk,dn,
     *                  qtf,rcond,qrwork,qrwsiz,njcnt,iter,fstjac,ierr)

c-----------------------------------------------------------------------
c
c     Compute Jacobian matrix in xc, fc
c     scale it, compute gradient in xc and generate QR decomposition
c     calculate Newton step
c
c     Arguments
c
c     Out      rjac    Real(ldr,*)     jacobian (n columns)
c     In       ldr     Integer         leading dimension of rjac
c     In       n       Integer         dimensions of problem
c     In       xc      Real(*)         initial estimate of solution
c     Inout    fc      Real(*)         function values f(xc)
c     Wk       fq      Real(*)         workspace
c     In       fjac    Name            name of routine to calculate jacobian
c                                      (optional)
c     In       fvec    Name            name of routine to calculate f()
c     In       epsm    Real            machine precision
c     In       jacflg  Integer(*)      jacobian flag array
c                                      jacflg[1]:  0 numeric; 1 user supplied; 2 numerical banded
c                                                  3: user supplied banded
c                                      jacflg[2]: number of sub diagonals or -1 if not banded
c                                      jacflg[3]: number of super diagonals or -1 if not banded
c                                      jacflg[4]: 1 if adjusting step allowed when
c                                                   singular or illconditioned
c     Wk       wrk1    Real(*)         workspace
c     Wk       wrk2    Real(*)         workspace
c     Wk       wrk3    Real(*)         workspace
c     In       xscalm  Integer         x scaling method
c                                        1 from column norms of first jacobian
c                                          increased if needed after first iteration
c                                        0 scaling user supplied
c     Inout    scalex  Real(*)         scaling factors x(*)
c     Out      gp      Real(*)         gradient at xp()
c     In       cndtol  Real            tolerance of test for ill conditioning
c     Wk       rcdwrk  Real(*)         workspace
c     Wk       icdwrk  Integer(*)      workspace
c     Out      dn      Real(*)         Newton step
c     Out      qtf     Real(*)         workspace for nwnstp
c     Out      rcond   Real            estimated inverse condition of R from QR
c     In       qrwork  Real(*)         workspace for Lapack QR routines (call liqsiz)
c     In       qrwsiz  Integer         size of qrwork
c     Out      njcnt   Integer         number of jacobian evaluations
c     In       iter    Integer         iteration counter (used in scaling)
c     Inout    fstjac  logical         .true. if initial jacobian is available
c                                      on exit set to .false.
c     Out      ierr    Integer         error code
c                                        0 no error
c                                       >0 error in nwnstp (singular ...)
c
c-----------------------------------------------------------------------

      integer ldr,n,iter, njcnt, ierr
      integer jacflg(*),xscalm,qrwsiz
      logical fstjac
      double precision  epsm, cndtol, rcond
      double precision  rjac(ldr,*)
      double precision  xc(*),fc(*),dn(*)
      double precision  wrk1(*),wrk2(*),wrk3(*)
      double precision  qtf(*),gp(*),fq(*)
      double precision  scalex(*)
      double precision  rcdwrk(*),qrwork(*)
      integer           icdwrk(*)
      external fjac,fvec

      logical stepadj
      double precision Rzero, Rone
      parameter(Rzero=0.0d0, Rone=1.0d0)

c     evaluate the jacobian at the current iterate xc

      if( .not. fstjac ) then
         call nwfjac(xc,scalex,fc,fq,n,epsm,jacflg,fvec,fjac,rjac,
     *               ldr,wrk1,wrk2,wrk3)
         njcnt = njcnt + 1
      else
         fstjac = .false.
      endif

c     if requested calculate x scale from jacobian column norms a la Minpack

      if( xscalm .eq. 1 ) then
         call vunsc(n,xc,scalex)
         call nwcpsx(n,rjac,ldr,scalex,epsm,iter)
         call vscal(n,xc,scalex)
      endif

      call nwscjac(n,rjac,ldr,scalex)

c     evaluate the gradient at the current iterate xc
c     gp = trans(Rjac) * fc
      call dgemv('T',n,n,Rone,rjac,ldr,fc,1,Rzero,gp,1)

c     get newton step
      stepadj = jacflg(4) .eq. 1
      call dcopy(n,fc,1,fq,1)
      call nwnstp(rjac,ldr,fq,n,cndtol, stepadj,
     *            wrk1,dn,qtf,ierr,rcond,
     *            rcdwrk,icdwrk,qrwork,qrwsiz)

c     save some data about jacobian for later output
      call nwsnot(0,ierr,rcond)

      return
      end

c-----------------------------------------------------------------------

      subroutine nwnstp(rjac,ldr,fn,n,cndtol, stepadj,
     *                  qraux,dn,qtf,ierr,rcond,
     *                  rcdwrk,icdwrk,qrwork,qrwsiz)

      integer ldr,n,ierr,qrwsiz
      double precision  cndtol,rjac(ldr,*),qraux(*),fn(*)
      double precision  dn(*),qtf(*)
      double precision  rcdwrk(*),qrwork(*)
      integer           icdwrk(*)
      double precision  rcond
      logical           stepadj

c-----------------------------------------------------------------------
c
c     Calculate the newton step
c
c     Arguments
c
c     Inout    rjac    Real(ldr,*)     jacobian matrix at current iterate
c                                      overwritten with QR decomposition
c     In       ldr     Integer         leading dimension of rjac
c     In       fn      Real(*)         function values at current iterate
c     In       n       Integer         dimension of problem
c     In       cndtol  Real            tolerance of test for ill conditioning
c     In       stepadj Logical         allow adjusting step for singular/illconditioned jacobian
c     Inout    qraux   Real(*)         QR info from liqrfa (calling Lapack dgeqrf)
c     Out      dn      Real(*)         Newton direction
c     Out      qtf     Real(*)         trans(Q)*f()
c     Out      ierr    Integer         0 indicating Jacobian not ill-conditioned or singular
c                                      1 indicating Jacobian ill-conditioned
c                                      2 indicating Jacobian completely singular
c                                      3 indicating almost zero LM correction
c     Out      rcond   Real            inverse condition of upper triangular R of QR
c     Wk       rcdwrk  Real(*)         workspace
c     Wk       icdwrk  Integer(*)      workspace
c     In       qrwork  Real(*)         workspace for Lapack QR routines (call liqsiz)
c     In       qrwsiz  Integer         size of qrwork
c
c-----------------------------------------------------------------------

      integer info

      double precision Rone
      parameter(Rone=1.0d0)

c     perform a QR factorization of rjac (simple Lapack routine)
c     check for singularity or ill conditioning
c     form qtf = trans(Q) * fn

      call liqrfa(Rjac,ldr,n,qraux,qrwork,qrwsiz,ierr)

c     compute qtf = trans(Q)*fn

      call dcopy(n,fn,1,qtf,1)
      call liqrqt(Rjac, ldr, n, qraux, qtf, qrwork, qrwsiz, info)

      call lirslv(Rjac,ldr,n,cndtol, stepadj,
     *                  qtf,dn,ierr,rcond, rcdwrk,icdwrk)

      return
      end

      subroutine brsolv(ldr,xc,n,scalex,maxit,
     *                  jacflg,xtol,ftol,btol,cndtol,global,xscalm,
     *                  stepmx,delta,sigma,
     *                  rjac,r,wrk1,wrk2,wrk3,wrk4,fc,fq,dn,d,qtf,
     *                  rcdwrk,icdwrk,qrwork,qrwsiz,epsm,
     *                  fjac,fvec,outopt,xp,fp,gp,njcnt,nfcnt,iter,
     *                  termcd)

      integer ldr,n,termcd,njcnt,nfcnt,iter
      integer maxit,jacflg(*),global,xscalm,qrwsiz
      integer outopt(*)
      double precision  xtol,ftol,btol,cndtol
      double precision  stepmx,delta,sigma,fpnorm,epsm
      double precision  rjac(ldr,*),r(ldr,*)
      double precision  xc(*),fc(*),xp(*),fp(*),dn(*),d(*)
      double precision  wrk1(*),wrk2(*),wrk3(*),wrk4(*)
      double precision  qtf(*),gp(*),fq(*)
      double precision  scalex(*)
      double precision  rcdwrk(*),qrwork(*)
      integer           icdwrk(*)
      external fjac,fvec

c-----------------------------------------------------------------------
c
c     Solve system of nonlinear equations with Broyden and global strategy
c
c
c     Arguments
c
c     In       ldr     Integer         leading dimension of rjac
c     In       xc      Real(*)         initial estimate of solution
c     In       n       Integer         dimensions of problem
c     Inout    scalex  Real(*)         scaling factors x(*)
c     In       maxit   Integer         maximum number of allowable iterations
c     In       jacflg  Integer(*)      jacobian flag array
c                                      jacflg[1]:  0 numeric; 1 user supplied; 2 numerical banded
c                                                  3: user supplied banded
c                                      jacflg[2]: number of sub diagonals or -1 if not banded
c                                      jacflg[3]: number of super diagonals or -1 if not banded
c                                      jacflg[4]: 1 if adjusting step allowed when
c                                                   singular or illconditioned
c     In       xtol    Real            tolerance at which successive iterates x()
c                                      are considered close enough to
c                                      terminate algorithm
c     In       ftol    Real            tolerance at which function values f()
c                                      are considered close enough to zero
c     Inout    btol    Real            x tolerance for backtracking
c     Inout    cndtol  Real            tolerance of test for ill conditioning
c     In       global  Integer         global strategy to use
c                                        1 cubic linesearch
c                                        2 quadratic linesearch
c                                        3 geometric linesearch
c                                        4 double dogleg
c                                        5 powell dogleg
c                                        6 hookstep (More-Hebden Levenberg-Marquardt)
c     In       xscalm  Integer         x scaling method
c                                        1 from column norms of first jacobian
c                                          increased if needed after first iteration
c                                        0 scaling user supplied
c     In       stepmx  Real            maximum allowable step size
c     In       delta   Real            trust region radius
c     In       sigma   Real            reduction factor geometric linesearch
c     Inout    rjac    Real(ldr,*)     jacobian (n columns)(compact QR decomposition/Q matrix)
c     Inout    r       Real(ldr,*)     stored R from QR decomposition
c     Wk       wrk1    Real(*)         workspace
c     Wk       wrk2    Real(*)         workspace
c     Wk       wrk3    Real(*)         workspace
c     Wk       wrk4    Real(*)         workspace
c     Inout    fc      Real(*)         function values f(xc)
c     Wk       fq      Real(*)         workspace
c     Wk       dn      Real(*)         workspace
c     Wk       d       Real(*)         workspace
c     Wk       qtf     Real(*)         workspace
c     Wk       rcdwrk  Real(*)         workspace
c     Wk       icdwrk  Integer(*)      workspace
c     In       qrwork  Real(*)         workspace for Lapack QR routines (call liqsiz)
c     In       qrwsiz  Integer         size of qrwork
c     In       epsm    Real            machine precision
c     In       fjac    Name            name of routine to calculate jacobian
c                                      (optional)
c     In       fvec    Name            name of routine to calculate f()
c     In       outopt  Integer(*)      output options
c     Out      xp      Real(*)         final x()
c     Out      fp      Real(*)         final f(xp)
c     Out      gp      Real(*)         gradient at xp()
c     Out      njcnt   Integer         number of jacobian evaluations
c     Out      nfcnt   Integer         number of function evaluations
c     Out      iter    Integer         number of (outer) iterations
c     Out      termcd  Integer         termination code
c
c-----------------------------------------------------------------------

      integer gcnt,retcd,ierr
      double precision  dum(2),dlt0,fcnorm,rcond
      logical fstjac
      logical jacevl,jacupd
      logical stepadj
      integer priter

      integer idamax

      double precision Rone
      parameter(Rone=1.0d0)

c     initialization

      retcd = 0
      iter  = 0
      njcnt = 0
      nfcnt = 0
      ierr  = 0

      dum(1) = 0
      dlt0 = delta

      if( outopt(1) .eq. 1 ) then
         priter = 1
      else
         priter = -1
      endif

c     evaluate function

      call vscal(n,xc,scalex)
      call nwfvec(xc,n,scalex,fvec,fc,fcnorm,wrk1)

c     evaluate user supplied or finite difference jacobian and check user supplied
c     jacobian, if requested

      fstjac = .false.
      if(mod(jacflg(1),2) .eq. 1) then

        if( outopt(2) .eq. 1 ) then
           fstjac = .true.
           njcnt = njcnt + 1
           call nwfjac(xc,scalex,fc,fq,n,epsm,jacflg,fvec,fjac,rjac,
     *                 ldr,wrk1,wrk2,wrk3)
           call chkjac(rjac,ldr,xc,fc,n,epsm,jacflg,scalex,
     *                 fq,wrk1,wrk2,fvec,termcd)
           if(termcd .lt. 0) then
c              copy initial values
               call dcopy(n,xc,1,xp,1)
               call dcopy(n,fc,1,fp,1)
               call vunsc(n,xp,scalex)
               fpnorm = fcnorm
               return
           endif
        endif

      endif

c     check stopping criteria for input xc

      call nwtcvg(xc,fc,xc,xtol,retcd,ftol,iter,maxit,n,ierr,termcd)

      if(termcd .gt. 0) then
          call dcopy(n,xc,1,xp,1)
          call dcopy(n,fc,1,fp,1)
          fpnorm = fcnorm
          if( outopt(3) .eq. 1 .and. .not. fstjac ) then
             njcnt = njcnt + 1
             call nwfjac(xp,scalex,fp,fq,n,epsm,jacflg,fvec,fjac,rjac,
     *                   ldr,wrk1,wrk2,wrk3)
          endif
          return
      endif

      if( priter .gt. 0 ) then

         dum(1) = fcnorm
         dum(2) = abs(fc(idamax(n,fc,1)))

         if( global .eq. 0 ) then
            call nwprot(iter, -1, dum)
         elseif( global .le. 3 ) then
            call nwlsot(iter,-1,dum)
         elseif( global .eq. 4 ) then
            call nwdgot(iter,-1,0,dum)
         elseif( global .eq. 5 ) then
            call nwpwot(iter,-1,0,dum)
         elseif( global .eq. 6 ) then
            call nwmhot(iter,-1,0,dum)
         endif

      endif

      jacevl  = .true.
      stepadj = jacflg(4) .eq. 1

      do while( termcd .eq. 0 )
         iter = iter+1

         if( jacevl ) then

            call nwbjac(rjac,r,ldr,n,xc,fc,fq,fvec,fjac,epsm,jacflg,
     *                  wrk1,wrk2,wrk3,
     *                  xscalm,scalex,gp,cndtol,rcdwrk,icdwrk,dn,
     *                  qtf,rcond,qrwork,qrwsiz,njcnt,iter,fstjac,ierr)

         else

c          - get broyden step
c          - calculate approximate gradient

            call dcopy(n,fc,1,fq,1)
            call brodir(rjac,ldr,r,fq,n,cndtol, stepadj,
     *                  dn,qtf,ierr,rcond,rcdwrk,icdwrk)

            if( ierr .eq. 0 ) then
               call dcopy(n,qtf,1,gp,1)
               call dtrmv('U','T','N',n,r,ldr,gp,1)
            endif
         endif
c      - choose the next iterate xp by a global strategy

         if( ierr .gt. 0 ) then
c           jacobian singular or too ill-conditioned
            call nweset(n,xc,fc,fcnorm,xp,fp,fpnorm,gcnt,priter,iter)
         elseif(global .eq. 0) then
            call nwpure(n,xc,dn,stepmx,scalex,
     *                  fvec,xp,fp,fpnorm,wrk1,retcd,gcnt,
     *                  priter,iter)
         elseif(global .eq. 1) then
            call nwclsh(n,xc,fcnorm,dn,gp,stepmx,btol,scalex,
     *                  fvec,xp,fp,fpnorm,wrk1,retcd,gcnt,
     *                  priter,iter)
         elseif(global .eq. 2) then
            call nwqlsh(n,xc,fcnorm,dn,gp,stepmx,btol,scalex,
     *                  fvec,xp,fp,fpnorm,wrk1,retcd,gcnt,
     *                  priter,iter)
         elseif(global .eq. 3) then
            call nwglsh(n,xc,fcnorm,dn,gp,sigma,stepmx,btol,scalex,
     *                  fvec,xp,fp,fpnorm,wrk1,retcd,gcnt,
     *                  priter,iter)
         elseif(global .eq. 4) then
            call nwddlg(n,r,ldr,dn,gp,xc,fcnorm,stepmx,
     *                  btol,delta,qtf,scalex,
     *                  fvec,d,fq,wrk1,wrk2,wrk3,wrk4,
     *                  xp,fp,fpnorm,retcd,gcnt,priter,iter)
         elseif(global .eq. 5) then
            call nwpdlg(n,r,ldr,dn,gp,xc,fcnorm,stepmx,
     *                  btol,delta,qtf,scalex,
     *                  fvec,d,fq,wrk1,wrk2,wrk3,wrk4,
     *                  xp,fp,fpnorm,retcd,gcnt,priter,iter)
         elseif(global .eq. 6) then
            call nwmhlm(n,r,ldr,dn,gp,xc,fcnorm,stepmx,
     *                  btol,delta,qtf,scalex,
     *                  fvec,d,fq,wrk1,wrk2,wrk3,wrk4,
     *                  xp,fp,fpnorm,retcd,gcnt,priter,iter)
         endif

         nfcnt = nfcnt + gcnt

c      - check stopping criteria for the new iterate xp

         call nwtcvg(xp,fp,xc,xtol,retcd,ftol,iter,maxit,n,ierr,termcd)

         if( termcd .eq. 3 .and. .not. jacevl ) then
c           global strategy failed but jacobian is out of date
c           try again with proper jacobian
c           reset trust region radius

            jacevl = .true.
            jacupd = .false.
            delta = dlt0
            termcd = 0

         elseif(termcd .gt. 0) then
            jacupd = .false.
         else
            jacupd = .true.
            jacevl = .false.
         endif

         if( jacupd ) then
c           perform Broyden update of current jacobian
c           update xc, fc, and fcnorm
            call brupdt(n,rjac,r,ldr,xc,xp,fc,fp,epsm,
     *                  wrk1,wrk2,wrk3)
            call dcopy(n,xp,1,xc,1)
            call dcopy(n,fp,1,fc,1)
            fcnorm = fpnorm
         endif

      enddo

      if( outopt(3) .eq. 1 ) then
c        final update of jacobian
         call brupdt(n,rjac,r,ldr,xc,xp,fc,fp,epsm,
     *               wrk1,wrk2,wrk3)
c        reconstruct Broyden matrix
c        calculate Q * R where Q is overwritten by result
c        Q is in rjac and R is in r
         call dtrmm('R','U','N','N',n,n,Rone,r,n,rjac,n)
c        unscale
         call nwunscjac(n,rjac,ldr,scalex)
      endif

      call vunsc(n,xp,scalex)

      return
      end

c-----------------------------------------------------------------------

      subroutine brupdt(n,q,r,ldr,xc,xp,fc,fp,epsm,dx,df,wa)
      integer n,ldr
      double precision  q(ldr,*),r(ldr,*)
      double precision  xc(*),xp(*),fc(*),fp(*),dx(*),df(*),wa(*)
      double precision  epsm

c-----------------------------------------------------------------------
c
c     Calculate new Q and R from rank-1 update with xp-xc and fp-fc
c     using Broyden method
c
c     Arguments
c
c     In       n       Integer         size of xc() etc.
c     Inout    Q       Real(ldr,n)     orthogonal matrix Q from QR
c                                       On output updated Q
c     Inout    R       Real(ldr,n)     upper triangular R from QR
c                                       On output updated R
c     In       ldr     Integer         leading dimension of Q and R
c     In       xc      Real(*)         current x() values
c     In       xp      Real(*)         new     x() values
c     In       fc      Real(*)         current f(xc)
c     In       fp      Real(*)         new     f(xp)
c     In       epsm    Real            machine precision
c     Wk       dx      Real(*)         workspace
c     Wk       df      Real(*)         workspace
c     Wk       wa      Real(*)         workspace
c
c-----------------------------------------------------------------------

      integer i
      double precision  eta,sts
      double precision  dnrm2
      logical doupdt

      double precision Rzero, Rone, Rtwo, Rhund
      parameter(Rzero=0.0d0, Rone=1.0d0, Rtwo=2.0d0, Rhund=100d0)

      eta    = Rhund * Rtwo * epsm
      doupdt = .false.

      do i=1,n
         dx(i) = xp(i) - xc(i)
         df(i) = fp(i) - fc(i)
      enddo

c     clear lower triangle

      do i=1,n-1
         call nuzero(n-i,r(i+1,i))
      enddo

c     calculate df - B*dx = df - Q*R*dx
c     wa = R*dx
c     df = df - Q*(R*dx) (!not really needed if qrupdt were to be changed)
c     do not update with noise

      call dcopy(n,dx,1,wa,1)
      call dtrmv('U','N','N',n,r,ldr,wa,1)
      call dgemv('N',n,n,-Rone,q,ldr,wa,1,Rone,df,1)

      do i=1,n
         if( abs(df(i)) .gt. eta*( abs(fp(i)) + abs(fc(i)) ) ) then
            doupdt = .true.
         else
            df(i)  = Rzero
         endif
      enddo

      if( doupdt ) then
c        equation 8.3.1 from Dennis and Schnabel (page 187)(Siam edition)
         sts = dnrm2(n,dx,1)
         call dscal(n,Rone/sts,dx,1)
         call dscal(n,Rone/sts,df,1)
         call liqrup(q,ldr,n,r,ldr,df,dx,wa)
      endif

      return
      end

c-----------------------------------------------------------------------

      subroutine brodir(q,ldr,r,fn,n,cndtol,stepadj,dn,qtf,
     *                  ierr,rcond,rcdwrk,icdwrk)

      integer ldr,n,ierr
      double precision  cndtol,q(ldr,*),r(ldr,*),fn(*)
      double precision  dn(*),qtf(*)
      double precision  rcdwrk(*)
      integer           icdwrk(*)
      double precision  rcond
      logical           stepadj

c-----------------------------------------------------------------------
c
c     Calculate the approximate newton direction
c
c     Arguments
c
c     Inout    Q       Real(ldr,*)     Q part from QR at current iterate
c     In       ldr     Integer         leading dimension of Q and R
c     In       R       Real(ldr,*)     upper triangular R from QR decomposition
c     In       fn      Real(*)         function values at current iterate
c     In       n       Integer         dimension of problem
c     In       cndtol  Real            tolerance of test for ill conditioning
c     In       stepadj Logical         allow adjusting step for singular/illconditioned jacobian
c     Out      dn      Real(*)         Newton direction
c     Out      qtf     Real(*)         trans(Q)*f()
c     Out      ierr    Integer         0 indicating Jacobian not ill-conditioned or singular
c                                      1 indicating Jacobian ill-conditioned
c                                      2 indicating Jacobian completely singular
c                                      3 indicating almost zero LM correction
c     Out      rcond   Real            inverse condition of matrix
c     Wk       rcdwrk  Real(*)         workspace
c     Wk       icdwrk  Integer(*)      workspace
c
c     QR decomposition with no pivoting.
c
c-----------------------------------------------------------------------

      double precision Rzero, Rone
      parameter(Rzero=0.0d0, Rone=1.0d0)

c     form qtf = trans(Q) * fn
      call dgemv('T',n,n,Rone,q,ldr,fn,1,Rzero,qtf,1)

      call lirslv(R,ldr,n,cndtol, stepadj,
     *                  qtf,dn,ierr,rcond, rcdwrk,icdwrk)
      call nwsnot(1,ierr,rcond)

      return
      end

#' Test different methods for solving with \code{nleqslv}
#'
#' The function tests different methods and global strategies for solving a
#' system of nonlinear equations with \code{nleqslv}
#'
#' The function solves the function \code{fn} with \code{\link{nleqslv}} for
#' the specified methods and global strategies. When argument \code{Nrep} has
#' been set to a number greater than or equal to 1, repetitions of the solving
#' process are performed and the used CPU time in seconds is recorded.
#'
#' If checking a user supplied jacobian is enabled, then \code{testnslv} will
#' stop immediately when a possibly incorrect jacobian is detected.
#'
#' @param x A numeric vector with an initial guess of the root.
#' @param fn A function of \code{x} returning the function values.
#' @param jac A function to return the Jacobian for the \code{fn} function.
#' For a vector valued function \code{fn} the Jacobian must be a numeric matrix
#' of the correct dimensions.  For a scalar valued function \code{fn} the
#' \code{jac} function may return a scalar.  If not supplied numerical
#' derivatives will be used.
#' @param \dots Further arguments to be passed to \code{fn} and \code{jac} and
#' \code{\link{nleqslv}}.
#' @param method The methods to use for finding a solution.
#' @param global The global strategies to test. The argument may consist of
#' several possibly abbreviated items.
#' @param Nrep Number of repetitions to apply. Default is no repetitions.
#' @param title a description of this experiment.
#' @return \code{testnslv} returns an object of class \code{"test.nleqslv"}
#' which is a list containing the following elements \describe{
#' \item{\code{call}}{the matched call} \item{\code{out}}{ a dataframe
#' containing the results with the following columns \describe{
#' \item{\code{Method}}{method used.} \item{\code{Global}}{global strategy
#' used.} \item{\code{termcd}}{termination code of \code{nleqslv}.}
#' \item{\code{Fcnt}}{number of function evaluations used by the method and
#' global strategy.  This excludes function evaluations made when computing a
#' numerical Jacobian.} \item{\code{Jcnt}}{number of Jacobian evaluations.}
#' \item{\code{Iter}}{number of outer iterations used by the algorithm.}
#' \item{\code{Message}}{a string describing the termination code in an
#' abbreviated form.} \item{\code{Fnorm}}{square of the euclidean norm of the
#' vector of function results divided by 2.} \item{\code{cpusecs}}{CPU seconds
#' used by the requested number of repetitions (only present when argument
#' \code{Nrep} is not 0).} } } \item{\code{title}}{the description if
#' specified} } The abbreviated strings are \describe{
#' \item{\code{Fcrit}}{Convergence of function values has been achieved.}
#' \item{\code{Xcrit}}{This means that the relative distance between two
#' consecutive x-values is smaller than \code{xtol}.}
#' \item{\code{Stalled}}{The algorithm cannot find an acceptable new point.}
#' \item{\code{Maxiter}}{Iteration limit \code{maxit} exceeded.}
#' \item{\code{Illcond}}{Jacobian is too ill-conditioned.}
#' \item{\code{Singular}}{Jacobian is singular.}
#' \item{\code{BadJac}}{Jacobian is unusable.}
#' \item{\code{ERROR}}{\code{nleqslv} stopped because of a fatal error.} }
#' @section Warning: Any \code{nleqslv} error message will be displayed
#' immediately and an error for the particular combination of method and global
#' strategy will be recorded in the final dataframe.
#' @keywords nonlinear optimize
#' @examples
#'
#' dslnex <- function(x) {
#'     y <- numeric(2)
#'     y[1] <- x[1]^2 + x[2]^2 - 2
#'     y[2] <- exp(x[1]-1) + x[2]^3 - 2
#'     y
#' }
#' xstart <- c(0.5,0.5)
#' fstart <- dslnex(xstart)
#' testnslv(xstart,dslnex)
#' # this will encounter an error
#' xstart <- c(2.0,0.5)
#' fstart <- dslnex(xstart)
#' testnslv(xstart,dslnex)
#'
#' @export testnslv
testnslv <- function(x, fn, jac=NULL, ...,
                            method=c("Newton", "Broyden"),
                            global=c("cline", "qline", "gline", "pwldog", "dbldog", "hook", "none"),
                            Nrep=0L, title=NULL
                          )
{
    # utility functions
    catmsg <- function(m,g,res) {
        cat(sprintf("Error (method=%s global=%s): %s\n",m,g,attr(res,"condition")$message))
    }

    makeerrlist <- function(m,g,cpusecs=NULL) {
        if(is.null(cpusecs)) {
            z <- list(Method=m, Global=g, termcd=NA, Fcnt=NA, Jcnt=NA, Iter=NA, Message="ERROR",Fnorm=NA)
        } else {
            z <- list(Method=m, Global=g, termcd=NA, Fcnt=NA, Jcnt=NA, Iter=NA, Message="ERROR",Fnorm=NA,
                             cpusecs=cpusecs)
        }
        z
    }

    makereslist <- function(m,g,res,cpusecs=NULL) {
        fnorm <- sum(res$fvec^2)/2
        # necessary to test for termcd<0 and >6 otherwise R errors later in output
        # see R-help about switch
        if(res$termcd < 0 ) stop("User supplied jacobian most likely incorrect: cannot continue") else
        if(res$termcd > 7 ) message <- "BADCD" else
            message <- switch(res$termcd, "Fcrit", "Xcrit", "Stalled", "Maxiter", "Illcond", "Singular", "BadJac")

        if(is.null(cpusecs)) {
           z <- list(Method=m, Global=g, termcd=res$termcd, Fcnt=res$nfcnt, Jcnt=res$njcnt,
                            Iter=res$iter, Message=message, Fnorm=fnorm)
        } else {
           z <- list(Method=m, Global=g, termcd=res$termcd, Fcnt=res$nfcnt, Jcnt=res$njcnt,
                            Iter=res$iter, Message=message, Fnorm=fnorm, cpusecs=cpusecs)
        }
        z
    }

    methods <- match.arg(method, c("Newton", "Broyden"), several.ok=TRUE)
    globals <- match.arg(global, c("cline", "qline", "gline", "pwldog", "dbldog", "hook", "none"), several.ok=TRUE)

    my.call <- match.call()
    reslist <- vector("list", length(methods)*length(globals))

    # use try to avoid process stopping for Jacobian with non-finite values
    # if that happens, go to next method/global
    # avoidable fatal user errors will also lead to useless next method/global
    idx <- 1
    for(m in methods)
        for(g in globals) {
            if( Nrep >= 1) {
                mytime <- system.time( for(k in seq_len(Nrep)) {
                                res <- try(nleqslv(x, fn, jac, ..., method=m, global=g), silent=TRUE)
                                if(inherits(res,"try-error")) break
                            }, gcFirst = FALSE)
                cpus <- mytime[3]
            } else {
                res <- try(nleqslv(x, fn, jac, ..., method=m, global=g),silent=TRUE)
                cpus <- NULL
            }
            if(inherits(res,"try-error")) {
                catmsg(m,g,res)
                z <- makeerrlist(m,g,cpus)
            } else {
                z <- makereslist(m,g,res,cpus)
            }
            reslist[[idx]] <- z
            idx <- idx+1
        }

# from http://stackoverflow.com/questions/4512465/what-is-the-most-efficient-way-to-cast-a-list-as-a-data-frame?rq=1

    ## @Martin Morgan's Map() sapply() solution:
    f <- function(x) function(i) sapply(x, `[[`, i)
    z <- as.data.frame(Map(f(reslist), names(reslist[[1]])), stringsAsFactors=FALSE)

    res <- list()
    res$out <- z
    res$call <- my.call
    res$title <- title
    class(res) <- "test.nleqslv"
    res
}



#' Printing the result of \code{testnslv}
#'
#' Print method for \code{test.nleqslv} objects.
#'
#' This is the \code{print} method for objects inheriting from class
#' \code{test.nleqslv}. It prints the call to \code{testnslv} followed by the
#' description of the experiment (if the \code{title} argument was specified in
#' the call to \code{testnslv}) and the dataframe containing the results of
#' \code{testnslv}.
#'
#' @aliases print print.test.nleqslv
#' @param x a \code{test.nleqslv} object
#' @param digits specifies the minimum number of significant digits to be
#' printed in values.
#' @param width.cutoff integer passed to \code{\link{deparse}} which sets the
#' cutoff at which line-breaking is tried.
#' @param \dots additional arguments to \code{print}.
#' @return It returns the object \code{x} invisibly.
#' @keywords print
#' @export
#' @examples
#'
#' dslnex <- function(x) {
#'     y <- numeric(2)
#'     y[1] <- x[1]^2 + x[2]^2 - 2
#'     y[2] <- exp(x[1]-1) + x[2]^3 - 2
#'     y
#' }
#' xstart <- c(1.5,0.5)
#' fstart <- dslnex(xstart)
#' z <- testnslv(xstart,dslnex)
#' print(z)
#'
print.test.nleqslv <- function(x, digits=4, width.cutoff=45L, ...) {
    if(!inherits(x, "test.nleqslv"))
        stop("method is only for test.nleqslv objects")

    # calculate total number of function evaluations if numeric jacobian used

    cat("Call:\n",paste0(deparse(x$call, width.cutoff=width.cutoff), collapse = "\n"), "\n\n", sep = "")
    if(is.null(x$title)) cat("Results:\n") else cat("Results: ",x$title,"\n", sep="")
    print(x$out, digits=digits,...)
    invisible(x)
}

# Copyright (c) Rob Carnell 2026

fixsmall <- function(x) {
  z <- ifelse(x < .Machine$double.eps^(2/3), "OK", "NZ")
  z <- ifelse(is.na(z), "NA", z)
  z
}

dslnex <- function(x) {
  y <- numeric(2)
  y[1] <- x[1]^2 + x[2]^2 - 2
  y[2] <- exp(x[1] - 1) + x[2]^3 - 2
  y
}

# --- Tests -------------------------------------------------------------------

test_that("testnslv works and normalizes Fnorm for a well-behaved start", {

  xstart <- c(0.5, 0.5)

  z <- testnslv(xstart, dslnex)

  # Ensure structure is present
  expect_true(is.list(z))
  expect_true(is.data.frame(z$out))
  expect_true("Fnorm" %in% colnames(z$out))

  # Normalize Fnorm and ensure only OK/NZ/NA appear
  zfn <- z$out[, "Fnorm"]
  z$out[, "Fnorm"] <- fixsmall(zfn)

  expect_true(all(z$out[, "Fnorm"] %in% c("OK", "NZ", "NA")))
  expect_true(any(z$out[, "Fnorm"] == "OK"))

  # All methods should have converged (termcd == 1)
  expect_true(all(z$out[, "termcd"] == 1))
})

test_that("testnslv handles a problematic start and records the Newton/none error", {

  xstart <- c(2.0, 0.5)

  expect_output(z <- testnslv(xstart, dslnex),
                regexp = "Error")

  # Ensure structure is present
  expect_true(is.data.frame(z$out))
  expect_true("Fnorm" %in% colnames(z$out))

  # Normalize Fnorm
  zfn <- z$out[, "Fnorm"]
  z$out[, "Fnorm"] <- fixsmall(zfn)

  # Check that the Newton/none row contains NA and ERROR as in the example
  idx <- which(z$out[, "Method"] == "Newton" & z$out[, "Global"] == "none")
  expect_length(idx, 1)

  expect_true(is.na(z$out[idx, "termcd"]))
  expect_identical(z$out[idx, "Message"], "ERROR")
  expect_identical(z$out[idx, "Fnorm"], "NA")

  # Other methods should still have valid termcd values
  ok_rows <- setdiff(seq_len(nrow(z$out)), idx)
  expect_true(all(z$out[ok_rows, "termcd"] %in% c(1, 4)))
})

# DO NOT EDIT - use etc/nleqslv-iterationreport-creator.R

# Copyright (c) 2026 Rob Carnell

#' Detailed iteration report of nleqslv
#' 
#' The format of the iteration report provided by nleqslv when the \code{trace}
#' component of the \code{control} argument has been set to 1.
#' 
#' All iteration reports consist of a series of columns with a header
#' summarising the contents. Common column headers are \describe{
#' \item{\code{Iter}}{Iteration counter} \item{\code{Jac}}{Jacobian type. The
#' Jacobian type is indicated by \code{N} for a Newton Jacobian or \code{B} for
#' a Broyden updated matrix; optionally followed by the letter \code{s}
#' indicating a totally singular matrix or the letter \code{i} indicating an
#' ill-conditioned matrix. Unless the Jacobian is singular, the Jacobian type
#' is followed by an estimate of the inverse condition number of the Jacobian
#' in parentheses as computed by Lapack. This column will be blank when
#' backtracking is active.} \item{\code{Fnorm}}{square of the euclidean norm
#' of function values / 2} \item{\code{Largest |f|}}{infinity norm of
#' \eqn{f(x)}{f(x)} at the current point} }
#' 
#' @aliases Iteration-report
#' 
#' @section Report for linesearch methods: A sample iteration report for the
#' linesearch global methods (\code{cline}, \code{qline} and \code{gline}) is
#' (some intercolumn space has been removed to make the table fit)
#' 
#' \preformatted{
#'   Iter         Jac   Lambda          Ftarg         Fnorm   Largest |f|
#'      0                                      2.886812e+00  2.250000e+00
#'      1  N(9.6e-03)   1.0000   2.886235e+00  5.787362e+05  1.070841e+03
#'      1               0.1000   2.886754e+00  9.857947e+00  3.214799e+00
#'      1               0.0100   2.886806e+00  2.866321e+00  2.237878e+00
#'      2  B(2.2e-02)   1.0000   2.865748e+00  4.541965e+03  9.341610e+01
#'      2               0.1000   2.866264e+00  3.253536e+00  2.242344e+00
#'      2               0.0298   2.866304e+00  2.805872e+00  2.200544e+00
#'      3  B(5.5e-02)   1.0000   2.805311e+00  2.919089e+01  7.073082e+00
#'      3               0.1000   2.805816e+00  2.437606e+00  2.027297e+00
#'      4  B(1.0e-01)   1.0000   2.437118e+00  9.839802e-01  1.142529e+00
#'      5  B(1.9e-01)   1.0000   9.837834e-01  7.263320e-02  3.785249e-01
#'      6  B(2.2e-01)   1.0000   7.261868e-02  1.581364e-02  1.774419e-01
#'      7  B(1.5e-01)   1.0000   1.581047e-02  9.328284e-03  1.213052e-01
#'      8  B(1.7e-01)   1.0000   9.326419e-03  1.003283e-04  1.400491e-02
#'      9  B(1.9e-01)   1.0000   1.003082e-04  3.072159e-06  2.206943e-03
#'     10  B(1.5e-01)   1.0000   3.071544e-06  1.143217e-07  4.757203e-04
#'     11  B(1.3e-01)   1.0000   1.142989e-07  1.144686e-09  4.783197e-05
#'     12  B(1.2e-01)   1.0000   1.144457e-09  4.515245e-13  9.502884e-07
#'     13  B(1.2e-01)   1.0000   4.514342e-13  1.404463e-17  5.299876e-09
#' }
#' 
#' The column headed
#' by \code{Lambda} shows the value of the line search parameter. The column
#' headed by \code{Ftarg} follows from a sufficient decrease requirement and is
#' the value below which \code{Fnorm} must drop if the current step is to be
#' accepted.
#' 
#' The value of \code{Lambda} may not be lower than a threshold determined by
#' the setting of control parameter \code{xtol} to avoid reporting false
#' convergence. When no acceptable \code{Lambda} is possible and the Broyden
#' method is being used, a new Jacobian will be computed.
#' @section Report for the pure method: The iteration report for the global
#' method \code{none} is almost the same as the above report, except that the
#' column labelled \code{Ftarg} is omitted. The column \code{Lambda} gives the
#' ratio of the maximum stepsize and the length of the full Newton step. It is
#' either exactly 1.0, indicating that the Newton step is smaller than the
#' maximum stepsize and therefore used unmodified, or smaller than 1.0,
#' indicating that the Newton step is larger than the maximum stepsize and
#' therefore truncated.
#' 
#' @section Report for the double dogleg global method: A sample iteration
#' report for the global method \code{dbldog} is (some intercolumn space has
#' been removed to make the table fit)
#' 
#' \preformatted{
#'   Iter         Jac     Lambda      Eta     Dlt0     Dltn         Fnorm   Largest |f|
#'      0                                                    2.886812e+00  2.250000e+00
#'      1  N(9.6e-03) C            0.9544   0.4671   0.9343* 1.699715e-01  5.421673e-01
#'      1             W   0.0833   0.9544   0.9343   0.4671  1.699715e-01  5.421673e-01
#'      2  B(1.1e-02) W   0.1154   0.4851   0.4671   0.4671  1.277667e-01  5.043571e-01
#'      3  B(7.3e-02) W   0.7879   0.7289   0.4671   0.0759  5.067893e-01  7.973542e-01
#'      3             C            0.7289   0.0759   0.1519  5.440250e-02  2.726084e-01
#'      4  B(8.3e-02) W   0.5307   0.3271   0.1519   0.3037  3.576547e-02  2.657553e-01
#'      5  B(1.8e-01) N            0.6674   0.2191   0.4383  6.566182e-03  8.555110e-02
#'      6  B(1.8e-01) N            0.9801   0.0376   0.0752  4.921645e-04  3.094104e-02
#'      7  B(1.9e-01) N            0.7981   0.0157   0.0313  4.960629e-06  2.826064e-03
#'      8  B(1.6e-01) N            0.3942   0.0029   0.0058  1.545503e-08  1.757498e-04
#'      9  B(1.5e-01) N            0.6536   0.0001   0.0003  2.968676e-11  5.983765e-06
#'     10  B(1.5e-01) N            0.4730   0.0000   0.0000  4.741792e-14  2.198380e-07
#'     11  B(1.5e-01) N            0.9787   0.0000   0.0000  6.451792e-19  8.118586e-10
#' }
#' 
#' After the column for the Jacobian the letters indicate the following
#' \describe{ \item{\code{C}}{a fraction (\eqn{\le1.0}{<=1.0}) of the Cauchy
#' or steepest descent step is taken where the fraction is the ratio of the
#' trust region radius and the Cauchy steplength.} \item{\code{W}}{a convex
#' combination of the Cauchy and \code{eta}*(Newton step) is taken. The number
#' in the column headed by \code{Lambda} is the weight of the partial Newton
#' step.} \item{\code{P}}{a fraction (\eqn{\ge1.0}{>=1.0}) of the partial
#' Newton step, equal to \code{eta}*(Newton step), is taken where the fraction
#' is the ratio of the trust region radius and the partial Newton steplength.}
#' \item{\code{N}}{a normal full Newton step is taken.} } The number in the
#' column headed by \code{Eta} is calculated from an upper limit on the ratio
#' of the length of the steepest descent direction and the length of the Newton
#' step. See Dennis and Schnabel (1996) pp.139ff for the details. The column
#' headed by \code{Dlt0} gives the trust region size at the start of the
#' current iteration. The column headed by \code{Dltn} gives the trust region
#' size when the current step has been accepted by the dogleg algorithm.
#' 
#' The trust region size is decreased when the actual reduction of the function
#' value norm does not agree well with the predicted reduction from the linear
#' approximation of the function or does not exhibit sufficient decrease. And
#' increased when the actual and predicted reduction are sufficiently close.
#' The trust region size is not allowed to decrease beyond a threshold
#' determined by the setting of control parameter \code{xtol}; when that
#' happens the backtracking is regarded as a failure and is terminated. In that
#' case a new Jacobian will be calculated if the Broyden method is being used.
#' 
#' The current trust region step is continued with a doubled trust region size
#' when the actual and predicted reduction agree extremely well. This is
#' indicated by \code{*} immediately following the value in the column headed
#' by \code{Dltn}. This could save gradient calculations. However, a trial step
#' is never taken if the current step is a Newton step. If the trial step does
#' not succeed then the previous trust region size is restored by halving the
#' trial size. The exception is when a trial step takes a Newton step. In that
#' case the trust region size is immediately set to the size of the Newton step
#' which implies that a halving of the new size leads to a smaller size for the
#' trust region than before.
#' 
#' Normally the initial trust region radius is the same as the final trust
#' region radius of the previous iteration but the trust region size is
#' restricted by the size of the current Newton step. So when full Newton steps
#' are being taken, the trust region radius at the start of an iteration may be
#' less than the final value of the previous iteration. The double dogleg
#' method and the trust region updating procedure are fully explained in
#' sections 6.4.2 and 6.4.3 of Dennis and Schnabel (1996).
#' 
#' @section Report for the single (Powell) dogleg global method: A sample
#' iteration report for the global method \code{pwldog} is (some intercolumn
#' space has been removed to make the table fit)
#' 
#' \preformatted{
#'   Iter         Jac     Lambda     Dlt0     Dltn         Fnorm   Largest |f|
#'      0                                           2.886812e+00  2.250000e+00
#'      1  N(9.6e-03) C            0.4671   0.9343* 1.699715e-01  5.421673e-01
#'      1             W   0.0794   0.9343   0.4671  1.699715e-01  5.421673e-01
#'      2  B(1.1e-02) W   0.0559   0.4671   0.4671  1.205661e-01  4.890487e-01
#'      3  B(7.3e-02) W   0.5662   0.4671   0.0960  4.119560e-01  7.254441e-01
#'      3             W   0.0237   0.0960   0.1921  4.426507e-02  2.139252e-01
#'      4  B(8.8e-02) W   0.2306   0.1921   0.3842* 2.303135e-02  2.143943e-01
#'      4             W   0.4769   0.3842   0.1921  2.303135e-02  2.143943e-01
#'      5  B(1.9e-01) N            0.1375   0.2750  8.014508e-04  3.681498e-02
#'      6  B(1.7e-01) N            0.0162   0.0325  1.355741e-05  5.084627e-03
#'      7  B(1.3e-01) N            0.0070   0.0035  1.282776e-05  4.920962e-03
#'      8  B(1.8e-01) N            0.0028   0.0056  3.678140e-08  2.643592e-04
#'      9  B(1.9e-01) N            0.0001   0.0003  1.689182e-12  1.747622e-06
#'     10  B(1.9e-01) N            0.0000   0.0000  9.568768e-16  4.288618e-08
#'     11  B(1.9e-01) N            0.0000   0.0000  1.051356e-18  1.422035e-09
#' }
#' 
#' This is much simpler
#' than the double dogleg report, since the single dogleg takes either a
#' steepest descent step, a convex combination of the steepest descent and
#' Newton steps or a full Newton step. The number in the column \code{Lambda}
#' is the weight of the Newton step. The single dogleg method is a special case
#' of the double dogleg method with \code{eta} equal to 1. It uses the same
#' method of updating the trust region size as the double dogleg method.
#' 
#' @section Report for the hook step global method: A sample iteration report
#' for the global method \code{hook} is (some intercolumn space has been
#' removed to make the table fit)
#' 
#' \preformatted{
#'   Iter         Jac         mu    dnorm     Dlt0     Dltn         Fnorm   Largest |f|
#'      0                                                    2.886812e+00  2.250000e+00
#'      1  N(9.6e-03) H   0.1968   0.4909   0.4671   0.9343* 1.806293e-01  5.749418e-01
#'      1             H   0.0366   0.9381   0.9343   0.4671  1.806293e-01  5.749418e-01
#'      2  B(2.5e-02) H   0.1101   0.4745   0.4671   0.2336  1.797759e-01  5.635028e-01
#'      3  B(1.4e-01) H   0.0264   0.2341   0.2336   0.4671  3.768809e-02  2.063234e-01
#'      4  B(1.6e-01) N            0.0819   0.0819   0.1637  3.002274e-03  7.736213e-02
#'      5  B(1.8e-01) N            0.0513   0.0513   0.1025  5.355533e-05  1.018879e-02
#'      6  B(1.5e-01) N            0.0090   0.0090   0.0179  1.357039e-06  1.224357e-03
#'      7  B(1.5e-01) N            0.0004   0.0004   0.0008  1.846111e-09  6.070166e-05
#'      8  B(1.4e-01) N            0.0000   0.0000   0.0001  3.292896e-12  2.555851e-06
#'      9  B(1.5e-01) N            0.0000   0.0000   0.0000  7.281583e-18  3.800552e-09
#' }
#' 
#' The column headed by \code{mu} shows the
#' Levenberg-Marquardt parameter when the Newton step is larger than the trust
#' region radius. The column headed by \code{dnorm} gives the Euclidean norm of
#' the step (adjustment of the current \code{x}) taken by the algorithm. The
#' absolute value of the difference with \code{Dlt0} is less than 0.1 times the
#' trust region radius.
#' 
#' After the column for the Jacobian the letters indicate the following
#' \describe{ \item{\code{H}}{a Levenberg-Marquardt restricted step is taken.}
#' \item{\code{N}}{a normal full Newton step is taken.} } The meaning of the
#' columns headed by \code{Dlt0} and \code{Dltn} is identical to that of the
#' same columns for the double dogleg method. The method of updating the trust
#' region size is the same as in the double dogleg method.
#' 
#' @seealso \code{\link{nleqslv}}
#' @name nleqslv-iterationreport
#' 
NULL

      subroutine nwtrup(n,fcnorm,g,sc,nwtstep,stepmx,xtol,delta,
     *                  fpred,retcd,xprev,fpnsav,fprev,xp,fp,
     *                  fpnorm)

      integer n,retcd
      double precision  fcnorm,stepmx,xtol,delta,fpred,fpnsav,fpnorm
      double precision  xp(*),g(*)
      double precision  sc(*),xprev(*),fprev(*),fp(*)
      logical nwtstep

c-------------------------------------------------------------------------
c
c     Decide whether to accept xp=xc+sc as the next iterate
c     and updates the trust region delta
c
c     Arguments
c
c     In       n       Integer         size of xc()
c     In       fcnorm  Real            .5*||f(xc)||**2
c     In       g       Real(*)         gradient at xc()
c     In       sc      Real(*)         current step
c     In       nwtstep Logical         true if sc is newton direction
c     In       stepmx  Real            maximum step size
c     In       xtol    Real            minimum step tolerance
c     Inout    delta   Real            trust region radius
c     In       fpred   Real            predicted value of .5*||f()||**2
c
c     Inout    retcd   Integer         return code
c                                       0 xp accepted as next iterate;
c                                         delta trust region for next iteration.
c
c                                       1 xp unsatisfactory but
c                                         accepted as next iterate because
c                                         xp-xc .lt. smallest allowable
c                                         step length.
c
c                                       2 f(xp) too large.
c                                         continue current iteration with
c                                         new reduced delta.
c
c                                       3 f(xp) sufficiently small, but
c                                         quadratic model predicts f(xp)
c                                         sufficiently well to continue current
c                                         iteration with new doubled delta.
c
c                                      On first entry, retcd must be 4
c
c     Wk       xprev   Real(*)         (internal) work
c     Wk       fpnsav  Real            (internal) work
c     Wk       fprev   Real(*)         (internal) work
c     Inout    xp      Real(*)         new iterate x()
c     Inout    fp      Real(*)         new f(xp)
c     Inout    fpnorm  Real            new .5*||f(xp)||**2
c
c-------------------------------------------------------------------------

      double precision  ared,pred,slope,sclen,rln,dltmp
      double precision  dnrm2,ddot,nudnrm
      logical ret3ok

      double precision Rone, Rtwo, Rthree, Rfour, Rten
      double precision Rhalf, Rpten
      parameter(Rpten = 0.1d0)
      parameter(Rhalf=0.5d0)
      parameter(Rone=1.0d0, Rtwo=2.0d0, Rthree=3.0d0, Rfour=4.0d0)
      parameter(Rten=10.0d0)

      double precision Rp99,Rp4, Rp75
      parameter(Rp99=Rone-Rten**(-2), Rp4=Rten**(-4), Rp75=Rthree/Rfour)

      double precision alpha
      parameter(alpha = Rp4)

c     pred measures the predicted reduction in the function value

      ared  = fpnorm - fcnorm
      pred  = fpred  - fcnorm
      slope = ddot(n,g,1,sc,1)

      if(retcd .ne. 3) then
         ret3ok = .false.
      else
         ret3ok = fpnorm .ge. fpnsav .or. ared .gt. alpha * slope
      endif

      if(retcd .eq. 3 .and. ret3ok) then

c        reset xp,fp,fpnorm to saved values and terminate global step

         retcd = 0
         call dcopy(n,xprev,1,xp,1)
         call dcopy(n,fprev,1,fp,1)
         fpnorm = fpnsav
c        reset delta to initial value
c        but beware
c           if the trial step was a Newton step then delta is reset to
c           .5 * length(Newton step) which will be smaller
c           because delta is set to length(Newton step) elsewhere
c           see nwddlg.f and nwpdlg.f
         delta  = Rhalf*delta

      elseif(ared .gt. alpha * slope) then

c        fpnorm too large (decrease not sufficient)

         rln = nudnrm(n,sc,xp)
         if(rln .lt. xtol) then

c           cannot find satisfactory xp sufficiently distinct from xc

            retcd = 1

         else

c           reduce trust region and continue current global step

            retcd = 2
            sclen = dnrm2(n,sc,1)
            dltmp = -slope*sclen/(Rtwo*(ared-slope))

            if(dltmp .lt. Rpten*delta) then
               delta = Rpten*delta
            else
               delta = min(Rhalf*delta, dltmp)
            endif

         endif

      elseif(retcd .ne. 2 .and. (abs(pred-ared) .le. Rpten*abs(ared))
     *      .and. (.not. nwtstep) .and. (delta .le. Rp99*stepmx)) then

c        pred predicts ared very well
c        attempt a doubling of the trust region and continue global step
c        when not taking a newton step and trust region not at maximum

         call dcopy(n,xp,1,xprev,1)
         call dcopy(n,fp,1,fprev,1)
         fpnsav = fpnorm
         delta  = min(Rtwo*delta,stepmx)
         retcd  = 3

      else

c        fpnorm sufficiently small to accept xp as next iterate.
c        Choose new trust region.

         retcd = 0
         if(ared .ge. Rpten*pred) then

c           Not good enough. Decrease trust region for next iteration

            delta = Rhalf*delta
         elseif( ared .le. Rp75*pred ) then

c           Wonderful. Increase trust region for next iteration

            delta = min(Rtwo*delta,stepmx)
         endif

      endif

      return
      end

expectedMessage1 <- "Function criterion near zero"
expectedMessage2 <- "x-values within tolerance 'xtol'"

common_test_f <- function(x) {
  y <- numeric(3)
  y[1] <- x[1] + x[2] - x[1]*x[2] - 2
  y[2] <- x[1] + x[3] - x[1]*x[3] - 3
  y[3] <- x[2] + x[3] - 4
  return(y)
}

common_test_jac <- function(x) {
  J <- matrix(0,nrow=3,ncol=3)
  J[,1] <- c(1-x[2], 1-x[3], 0)
  J[,2] <- c(1-x[1], 0, 1)
  J[,3] <- c(0, 1-x[1], 1)
  J
}

common_test_xsol <- c(-.5, 5/3 , 7/3)

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nleqslv-package.R
\docType{package}
\name{nleqslv-package}
\alias{nleqslv-package}
\alias{nleqslv.Intro}
\title{The \pkg{nleqslv} package provides two algorithms for solving (dense)
nonlinear systems of equations.}
\description{
The methods provided are \itemize{ \item a
Broyden Secant method where the matrix of derivatives is updated after each
major iteration using the Broyden rank 1 update.  \item a full Newton method
where the Jacobian matrix of derivatives is recalculated at each iteration }
Both methods utilize global strategies such as line search or trust region
methods whenever the standard Newton/Broyden step does not lead to a point
closer to a root of the equation system. Both methods can also be used
without a norm reducing global strategy. Line search may be either cubic,
quadratic or geometric. The trust region methods are either the double
dogleg method, the Powell single dogleg method or a Levenberg-Marquardt type
method.
}
\details{
There is a facility for specifying that the Jacobian is banded; this can
significantly speedup the calculation of a numerical Jacobian when the
number of sub- and super diagonals is small compared to the size of the
system of equations. For example the Jacobian of a tridiagonal system can be
calculated with only three evaluations of the function.

The package provides an option to attempt to solve the system of equations
when the Jacobian is singular or ill-conditioned using an approximation to
the Moore-Penrose pseudoinverse of the Jacobian.

The algorithms provided in this package are derived from Dennis and Schnabel
(1996). The code is written in Fortran 77 and Fortran 95 and uses Lapack and
BLAS routines as provided by the R system.
}
\references{
Dennis, J.E. Jr and Schnabel, R.B. (1996), \emph{Numerical
Methods for Unconstrained Optimization and Nonlinear Equations}, Siam.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://bertcarnell.github.io/nleqslv/}
  \item \url{https://github.com/bertcarnell/nleqslv/}
  \item Report bugs at \url{https://github.com/bertcarnell/nleqslv/issues/}
}

}
\author{
\strong{Maintainer}: Rob Carnell \email{bertcarnell@gmail.com} (\href{https://orcid.org/0009-0009-0465-7564}{ORCID})

Authors:
\itemize{
  \item Berend Hasselman \email{bhh@xs4all.nl} (Original Author)
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/testnslv.R
\name{print.test.nleqslv}
\alias{print.test.nleqslv}
\alias{print}
\title{Printing the result of \code{testnslv}}
\usage{
\method{print}{test.nleqslv}(x, digits = 4, width.cutoff = 45L, ...)
}
\arguments{
\item{x}{a \code{test.nleqslv} object}

\item{digits}{specifies the minimum number of significant digits to be
printed in values.}

\item{width.cutoff}{integer passed to \code{\link{deparse}} which sets the
cutoff at which line-breaking is tried.}

\item{\dots}{additional arguments to \code{print}.}
}
\value{
It returns the object \code{x} invisibly.
}
\description{
Print method for \code{test.nleqslv} objects.
}
\details{
This is the \code{print} method for objects inheriting from class
\code{test.nleqslv}. It prints the call to \code{testnslv} followed by the
description of the experiment (if the \code{title} argument was specified in
the call to \code{testnslv}) and the dataframe containing the results of
\code{testnslv}.
}
\examples{

dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1]-1) + x[2]^3 - 2
    y
}
xstart <- c(1.5,0.5)
fstart <- dslnex(xstart)
z <- testnslv(xstart,dslnex)
print(z)

}
\keyword{print}

\name{print.test.nleqslv}
\title{Printing the result of \code{testnslv}}
\alias{print}
\alias{print.test.nleqslv}
\description{
  Print method for \code{test.nleqslv} objects.
}
\usage{
\method{print}{test.nleqslv}(x, digits=4, width.cutoff=45L, \dots)
}
\arguments{
  \item{x}{a \code{test.nleqslv} object}
  \item{digits}{specifies the minimum number of significant digits to be printed in values.}
  \item{width.cutoff}{integer passed to \code{\link{deparse}} which sets the cutoff at which line-breaking is tried.}
  \item{\dots}{additional arguments to \code{print}.}
}
\details{
This is the \code{print} method for objects inheriting from
class \code{test.nleqslv}. It prints the call to \code{testnslv} followed by the description of the experiment
(if the \code{title} argument was specified in the call to \code{testnslv})
and the dataframe containing the results of \code{testnslv}.
}
\value{
It returns the object \code{x} invisibly.
}
\examples{
dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1]-1) + x[2]^3 - 2
    y
}
xstart <- c(1.5,0.5)
fstart <- dslnex(xstart)
z <- testnslv(xstart,dslnex)
print(z)
}
\keyword{print}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nleqslv.R
\name{nleqslv}
\alias{nleqslv}
\title{Solving systems of nonlinear equations with Broyden or Newton}
\usage{
nleqslv(
  x,
  fn,
  jac = NULL,
  ...,
  method = c("Broyden", "Newton"),
  global = c("dbldog", "pwldog", "cline", "qline", "gline", "hook", "none"),
  xscalm = c("fixed", "auto"),
  jacobian = FALSE,
  control = list()
)
}
\arguments{
\item{x}{A numeric vector with an initial guess of the root of the function.}

\item{fn}{A function of \code{x} returning a vector of function values with
the same length as the vector \code{x}.}

\item{jac}{A function to return the Jacobian for the \code{fn} function.
For a vector valued function \code{fn} the Jacobian must be a numeric matrix
of the correct dimensions.  For a scalar valued function \code{fn} the
\code{jac} function may return a scalar.  If not supplied numerical
derivatives will be used.}

\item{\dots}{Further arguments to be passed to \code{fn} and \code{jac}.}

\item{method}{The method to use for finding a solution. See
\sQuote{Details}.}

\item{global}{The global strategy to apply. See \sQuote{Details}.}

\item{xscalm}{The type of x scaling to use. See \sQuote{Details}.}

\item{jacobian}{A logical indicating if the estimated (approximate) jacobian
in the solution should be returned.  See \sQuote{Details}.}

\item{control}{A named list of control parameters. See \sQuote{Details}.}
}
\value{
A list containing components \item{x}{final values for x}
\item{fvec}{function values} \item{termcd}{termination code as integer.  The
values returned are \describe{ \item{\code{1}}{Function criterion is near
zero.  Convergence of function values has been achieved.}
\item{\code{2}}{x-values within tolerance. This means that the relative
distance between two consecutive x-values is smaller than \code{xtol} but
that the function value criterion is still larger than \code{ftol}.
\emph{Function values may not be near zero; therefore the user must check if
function values are acceptably small.}} \item{\code{3}}{No better point
found.  This means that the algorithm has stalled and cannot find an
acceptable new point.  This may or may not indicate acceptably small
function values.} \item{\code{4}}{Iteration limit \code{maxit} exceeded.}
\item{\code{5}}{Jacobian is too ill-conditioned.} \item{\code{6}}{Jacobian
is singular.} \item{\code{7}}{Jacobian is unusable.}
\item{\code{-10}}{User supplied Jacobian is most likely incorrect.} } }
\item{message}{a string describing the termination code} \item{scalex}{a
vector containing the scaling factors, which will be the final values when
automatic scaling was selected} \item{njcnt}{number of Jacobian evaluations}
\item{nfcnt}{number of function evaluations, excluding those required for
calculating a Jacobian and excluding the initial function evaluation (at
iteration 0)} \item{iter}{number of outer iterations used by the algorithm.
This excludes the initial iteration.  The number of backtracks can be
calculated as the difference between the \code{nfcnt} and \code{iter}
components.} \item{jac}{the final Jacobian or the Broyden approximation if
\code{jacobian} was set to \code{TRUE}.  If no iterations were executed, as
may happen when the initial guess are sufficiently close the solution, there
is no Broyden approximation and the returned matrix will always be the
actual Jacobian.  If the matrix is singular or too ill-conditioned the
returned matrix is of no value.}
}
\description{
The function solves a system of nonlinear equations with either a Broyden or
a full Newton method. It provides line search and trust region global
strategies for difficult systems.
}
\details{
The algorithms implemented in \code{nleqslv} are based on Dennis and
Schnabel (1996).

\subsection{Methods}{

Method \code{Broyden} starts with a computed Jacobian of the function and
then updates this Jacobian after each successful iteration using the
so-called Broyden update. This method often shows super linear convergence
towards a solution. When \code{nleqslv} determines that it cannot continue
with the current Broyden matrix it will compute a new Jacobian.

Method \code{Newton} calculates a Jacobian of the function \code{fn} at each
iteration. Close to a solution this method will usually show quadratic
convergence.

Both methods apply a so-called (backtracking) global strategy to find a
better (more acceptable) iterate.  The function criterion used by the
algorithm is half of the sum of squares of the function values and
\dQuote{acceptable} means sufficient decrease of the current function
criterion value compared to that of the previous iteration. A comprehensive
discussion of these issues can be found in Dennis and Schnabel (1996). Both
methods apply an unpivoted QR-decomposition to the Jacobian as implemented
in Lapack. The Broyden method applies a rank-1 update to the Jacobian at the
end of each iteration and is based on a simplified and modernized version of
the algorithm described in Reichel and Gragg (1990). }

\subsection{Global strategies}{

When applying a full Newton or Broyden step does not yield a sufficiently
smaller function criterion value \code{nleqslv} will attempt to decrease the
steplength using one of several so-called global strategies.

The \code{global} argument indicates which global strategy to use or to use
no global strategy \describe{ \item{\code{cline}}{a cubic line search}
\item{\code{qline}}{a quadratic line search} \item{\code{gline}}{a
geometric line search} \item{\code{dbldog}}{a trust region method using the
double dogleg method as described in Dennis and Schnabel (1996)}
\item{\code{pwldog}}{a trust region method using the Powell dogleg method
as developed by Powell (1970).} \item{\code{hook}}{a trust region method
described by Dennis and Schnabel (1996) as \emph{The locally constrained
optimal (\dQuote{hook}) step}.  It is equivalent to a Levenberg-Marquardt
algorithm as described in \enc{MoréMore}{MoreMore} (1978) and Nocedal and Wright
(2006).} \item{\code{none}}{Only a pure local Newton or Broyden iteration
is used.  The maximum stepsize (see below) is taken into account.  The
default maximum number of iterations (see below) is set to 20.} } The double
dogleg method is the default global strategy employed by this package.

Which global strategy to use in a particular situation is a matter of trial
and error. When one of the trust region methods fails, one of the line
search strategies should be tried. Sometimes a trust region will work and
sometimes a line search method; neither has a clear advantage but in many
cases the double dogleg method works quite well.

When the function to be solved returns non-finite function values for a
parameter vector \code{x} and the algorithm is \emph{not} evaluating a
numerical Jacobian, then any non-finite values will be replaced by a large
number forcing the algorithm to backtrack, i.e. decrease the line search
factor or decrease the trust region radius. }

\subsection{Scaling}{

The elements of vector \code{x} may be scaled during the search for a zero
of \code{fn}. The \code{xscalm} argument provides two possibilities for
scaling \describe{ \item{\code{fixed}}{the scaling factors are set to the
values supplied in the \code{control} argument and remain unchanged during
the iterations.  The scaling factor of any element of \code{x} should be set
to the inverse of the typical value of that element of \code{x}, ensuring
that all elements of \code{x} are approximately equal in size.}

\item{\code{auto}}{the scaling factors are calculated from the euclidean
norms of the columns of the Jacobian matrix.  When a new Jacobian is
computed, the scaling values will be set to the euclidean norm of the
corresponding column if that is larger than the current scaling value.  Thus
the scaling values will not decrease during the iteration.  This is the
method described in \enc{MoréMore}{MoreMore} (1978).  Usually manual scaling is
preferable.} } }

\subsection{Jacobian}{

When evaluating a numerical Jacobian, an error message will be issued on
detecting non-finite function values. An error message will also be issued
when a user supplied jacobian contains non-finite entries.

When the \code{jacobian} argument is set to \code{TRUE} the final Jacobian
or Broyden matrix will be returned in the return list. The default value is
\code{FALSE}; i.e. to not return the final matrix. There is no guarantee
that the final Broyden matrix resembles the actual Jacobian.

The package can cope with a singular or ill-conditioned Jacobian if needed
by setting the \code{allowSingular} component of the \code{control}
argument. The method used is described in Dennis and Schnabel (1996); it is
equivalent to a Levenberg-Marquardt type adjustment with a small damping
factor. \emph{There is no guarantee that this method will be successful.}
Warning: \emph{\code{nleqslv} may report spurious convergence in this case.}

By default \code{nleqslv} returns an error if a Jacobian becomes singular or
very ill-conditioned. A Jacobian is considered to be very ill-conditioned
when the estimated inverse condition is less than or equal to a specified
tolerance with a default value equal to \eqn{10^{-12}}{1e-12}; this can be
changed and made smaller with the \code{cndtol} item of the \code{control}
argument. \emph{There is no guarantee that any change will be effective.} }

\subsection{Control options}{

The \code{control} argument is a named list that can supply any of the
following components: \describe{ \item{\code{xtol}}{The relative steplength
tolerance.  When the relative steplength of all scaled x values is smaller
than this value convergence is declared. The default value is
\eqn{10^{-8}}{1e-8}.  }

\item{\code{ftol}}{The function value tolerance.  Convergence is declared
when the largest absolute function value is smaller than \code{ftol}.  The
default value is \eqn{10^{-8}}{1e-8}.  }

\item{\code{btol}}{The backtracking tolerance.  When the relative
steplength in a backtracking step to find an acceptable point is smaller
than the backtracking tolerance, the backtracking is terminated.  In the
\code{Broyden} method a new Jacobian will be calculated if the Jacobian is
outdated.  The default value is \eqn{10^{-3}}{1e-3}.  }

\item{\code{cndtol}}{The tolerance of the test for ill conditioning of the
Jacobian or Broyden approximation. If less than the machine precision it
will be silently set to the machine precision.  When the estimated inverse
condition of the (approximated) Jacobian matrix is less than or equal to the
value of \code{cndtol} the matrix is deemed to be ill-conditioned, in which
case an error will be reported if the \code{allowSingular} component is set
to \code{FALSE}.  The default value is \eqn{10^{-12}}{1e-12}.  }

\item{\code{sigma}}{Reduction factor for the geometric line search. The
default value is 0.5.}

\item{\code{scalex}}{a vector of scaling values for the parameters.  The
inverse of a scale value is an indication of the size of a parameter.  The
default value is 1.0 for all scale values.}

\item{\code{maxit}}{The maximum number of major iterations.  The default
value is 150 if a global strategy has been specified.  If no global strategy
has been specified the default is 20.}

\item{\code{trace}}{Non-negative integer. A value of 1 will give a detailed
report of the progress of the iteration. For a description see
\code{\link{Iteration-report}}.}

\item{\code{chkjac}}{A logical value indicating whether to check a user
supplied Jacobian, if supplied. The default value is \code{FALSE}. The first
10 errors are printed.  The code for this check is derived from the code in
Bouaricha and Schnabel (1997).}

\item{\code{delta}}{Initial (scaled) trust region radius.  A value of
\eqn{-1.0} or \code{"cauchy"} is replaced by the length of the Cauchy step
in the initial point.  A value of \eqn{-2.0} or \code{"newton"} is replaced
by the length of the Newton step in the initial point.  Any numeric value
less than or equal to 0 and not equal to \eqn{-2.0}, will be replaced by
\eqn{-1.0}; the algorithm will then start with the length of the Cauchy step
in the initial point.  If it is numeric and positive it will be set to the
smaller of the value supplied or the maximum stepsize.  If it is not numeric
and not one of the permitted character strings then an error message will be
issued.  The default is \eqn{-2.0}.}

\item{\code{stepmax}}{Maximum scaled stepsize.  If this is negative then
the maximum stepsize is set to the largest positive representable number.
The default is \eqn{-1.0}, so there is no default maximum stepsize.}

\item{\code{dsub}}{Number of non zero subdiagonals of a banded Jacobian.
The default is to assume that the Jacobian is \emph{not} banded.  Must be
specified if \code{dsuper} has been specified and must be larger than zero
when \code{dsuper} is zero.}

\item{\code{dsuper}}{Number of non zero super diagonals of a banded
Jacobian.  The default is to assume that the Jacobian is \emph{not} banded.
Must be specified if \code{dsub} has been specified and must be larger than
zero when \code{dsub} is zero.}

\item{\code{allowSingular}}{A logical value indicating if a small
correction to the Jacobian when it is singular or too ill-conditioned is
allowed.  If the correction is less than \code{100*.Machine$double.eps} the
correction cannot be applied and an unusable Jacobian will be reported.  The
method used is similar to a Levenberg-Marquardt correction and is explained
in Dennis and Schnabel (1996) on page 151.  It may be necessary to choose a
higher value for \code{cndtol} to enforce the correction.  The default value
is \code{FALSE}.  } } }
}
\section{Warning}{
 You cannot use this function recursively. Thus function
\code{fn} should not in its turn call \code{nleqslv}.
}

\examples{

# Dennis Schnabel example 6.5.1 page 149
dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1]-1) + x[2]^3 - 2
    y
}

jacdsln <- function(x) {
    n <- length(x)
    Df <- matrix(numeric(n*n),n,n)
    Df[1,1] <- 2*x[1]
    Df[1,2] <- 2*x[2]
    Df[2,1] <- exp(x[1]-1)
    Df[2,2] <- 3*x[2]^2

    Df
}

BADjacdsln <- function(x) {
    n <- length(x)
    Df <- matrix(numeric(n*n),n,n)
    Df[1,1] <- 4*x[1]
    Df[1,2] <- 2*x[2]
    Df[2,1] <- exp(x[1]-1)
    Df[2,2] <- 5*x[2]^2

    Df
}

xstart <- c(2,0.5)
fstart <- dslnex(xstart)
xstart
fstart

# a solution is c(1,1)

nleqslv(xstart, dslnex, control=list(btol=.01))

# Cauchy start
nleqslv(xstart, dslnex, control=list(trace=1,btol=.01,delta="cauchy"))

# Newton start
nleqslv(xstart, dslnex, control=list(trace=1,btol=.01,delta="newton"))

# final Broyden approximation of Jacobian (quite good)
z <- nleqslv(xstart, dslnex, jacobian=TRUE,control=list(btol=.01))
z$x
z$jac
jacdsln(z$x)

# different initial start; not a very good final approximation
xstart <- c(0.5,2)
z <- nleqslv(xstart, dslnex, jacobian=TRUE,control=list(btol=.01))
z$x
z$jac
jacdsln(z$x)

\dontrun{
# no global strategy but limit stepsize
# but look carefully: a different solution is found
nleqslv(xstart, dslnex, method="Newton", global="none", control=list(trace=1,stepmax=5))

# but if the stepsize is limited even more the c(1,1) solution is found
nleqslv(xstart, dslnex, method="Newton", global="none", control=list(trace=1,stepmax=2))

# Broyden also finds the c(1,1) solution when the stepsize is limited
nleqslv(xstart, dslnex, jacdsln, method="Broyden", global="none", control=list(trace=1,stepmax=2))
}

# example with a singular jacobian in the initial guess
f <- function(x) {
    y <- numeric(3)
    y[1] <- x[1] + x[2] - x[1]*x[2] - 2
    y[2] <- x[1] + x[3] - x[1]*x[3] - 3
    y[3] <- x[2] + x[3] - 4
    return(y)
}

Jac <- function(x) {
    J <- matrix(0,nrow=3,ncol=3)
    J[,1] <- c(1-x[2],1-x[3],0)
    J[,2] <- c(1-x[1],0,1)
    J[,3] <- c(0,1-x[1],1)
    J
}

# exact solution
xsol <- c(-.5, 5/3 , 7/3)
xsol

xstart <- c(1,2,3)
J <- Jac(xstart)
J
rcond(J)

z <- nleqslv(xstart,f,Jac, method="Newton",control=list(trace=1,allowSingular=TRUE))
all.equal(z$x,xsol)

}
\references{
Bouaricha, A. and Schnabel, R.B. (1997), Algorithm 768:
TENSOLVE: A Software Package for Solving Systems of Nonlinear Equations and
Nonlinear Least-squares Problems Using Tensor Methods, \emph{Transactions on
Mathematical Software}, \bold{23}, 2, pp. 174--195.

Dennis, J.E. Jr and Schnabel, R.B. (1996), \emph{Numerical Methods for
Unconstrained Optimization and Nonlinear Equations}, Siam.

\enc{MoréMore}{MoreMore}, J.J. (1978), The Levenberg-Marquardt Algorithm,
Implementation and Theory, In \emph{Numerical Analysis}, G.A. Watson (Ed.),
Lecture Notes in Mathematics 630, Springer-Verlag, pp. 105--116.

Golub, G.H and C.F. Van Loan (1996), Matrix Computations (3rd edition), The
John Hopkins University Press.

Higham, N.J. (2002), Accuracy and Stability of Numerical Algorithms, 2nd
ed., SIAM, pp. 10--11.

Nocedal, J. and Wright, S.J. (2006), \emph{Numerical Optimization},
Springer.

Powell, M.J.D. (1970), A hybrid method for nonlinear algebraic equations, In
\emph{Numerical Methods for Nonlinear Algebraic Equations}, P. Rabinowitz
(Ed.), Gordon & Breach.

Powell, M.J.D. (1970), A Fortran subroutine for solving systems nonlinear
equations, In \emph{Numerical Methods for Nonlinear Algebraic Equations}, P.
Rabinowitz (Ed.), Gordon & Breach.

% QRupdate: a Fortran library for fast updating of QR and Cholesky
decompositions, % \url{http://sourceforge.net/projects/qrupdate/}.

Reichel, L. and W.B. Gragg (1990), Algorithm 686: FORTRAN subroutines for
updating the QR decomposition, \emph{ACM Trans. Math. Softw.}, \bold{16}, 4,
pp. 369--377.
}
\seealso{
If this function cannot solve the supplied function then it is a
good idea to try the function \link{testnslv} in this package. For detecting
multiple solutions see \link{searchZeros}.
}
\keyword{nonlinear}
\keyword{optimize}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/searchzeros.R
\name{searchZeros}
\alias{searchZeros}
\title{Solve a nonlinear equation system with multiple roots from multiple initial
estimates}
\usage{
searchZeros(x, fn, digits = 4L, ...)
}
\arguments{
\item{x}{A matrix with each row containing an initial guess of the roots.}

\item{fn}{A function of \code{x} returning a vector of function values with
the same length as the vector \code{x}.}

\item{digits}{integer passed to \code{\link{round}} for locating and
removing duplicate rounded solutions.}

\item{\dots}{Further arguments to be passed to \code{\link{nleqslv}},
\code{fn} and \code{jac}.}
}
\value{
If no solutions are found \code{NULL} is returned. Otherwise a list
containing the following components is returned \describe{
\item{\code{x}}{a matrix with each row containing a unique solution
(unrounded)} \item{\code{xfnorm}}{a vector of the function criterion
associated with each row of the solution matrix \code{x}.}
\item{\code{fnorm}}{a vector containing the function criterion for every
converged result} \item{\code{idxcvg}}{a vector containing the row indices
of the matrix of initial estimates for which function value convergence was
achieved} \item{\code{idxxtol}}{a vector containing the row indices of the
matrix of initial estimates for which x-value convergence was achieved}
\item{\code{idxnocvg}}{a vector containing the row indices of the matrix of
initial estimates which lead to an \code{nleqslv} termination code > 2}
\item{\code{idxfatal}}{a vector containing the row indices of the matrix of
initial estimates for which a fatal error occurred that made \code{nleqslv}
stop} \item{\code{xstart}}{a matrix of the initial estimates corresponding
to the solution matrix} \item{\code{cvgstart}}{a matrix of all initial
estimates for which convergence was achieved} }
}
\description{
This function solves a system of nonlinear equations with \code{nleqlsv} for
multiple initial estimates of the roots.
}
\details{
Each row of \code{x} is a vector of initial estimates for the argument
\code{x} of \code{nleqslv}. The function runs \code{nleqslv} for each row of
the matrix \code{x}. The first initial value is treated separately and
slightly differently from the other initial estimates. It is used to check
if all arguments in \code{...} are valid arguments for \code{nleqslv} and
the function to be solved. This is done by running \code{nleqslv} with no
condition handling. If an error is then detected an error message is issued
and the function stops. For the remaining initial estimates \code{nleqslv}
is executed silently. Only solutions for which the \code{nleqslv}
termination code \code{tcode} equals \code{1} are regarded as valid
solutions. The rounded solutions (after removal of duplicates) are used to
order the solutions in increasing order. These rounded solutions are not
included in the return value of the function.
}
\examples{

# Dennis Schnabel example 6.5.1 page 149 (two solutions)
set.seed(123)
dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1]-1) + x[2]^3 - 2
    y
}
xstart <- matrix(runif(50, min=-2, max=2),ncol=2)
ans <- searchZeros(xstart,dslnex, method="Broyden",global="dbldog")
ans

# more complicated example
# R. Baker Kearfott, Some tests of Generalized Bisection,
# ACM Transactions on Methematical Software, Vol. 13, No. 3, 1987, pp 197-220

# A high-degree polynomial system (section 4.3 Problem 12)
# There are 12 real roots (and 126 complex roots to this system!)

hdp <- function(x) {
    f <- numeric(length(x))
    f[1] <- 5 * x[1]^9 - 6 * x[1]^5 * x[2]^2 + x[1] * x[2]^4 + 2 * x[1] * x[3]
    f[2] <- -2 * x[1]^6 * x[2] + 2 * x[1]^2 * x[2]^3 + 2 * x[2] * x[3]
    f[3] <- x[1]^2 + x[2]^2 - 0.265625
    f
}


N <- 40 # at least to find all 12 roots
set.seed(123)
xstart <- matrix(runif(3*N,min=-1,max=1), N, 3)  # N initial guesses, each of length 3
ans <- searchZeros(xstart,hdp, method="Broyden",global="dbldog")
ans$x

}
\keyword{nonlinear}
\keyword{optimize}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/testnslv.R
\name{testnslv}
\alias{testnslv}
\title{Test different methods for solving with \code{nleqslv}}
\usage{
testnslv(
  x,
  fn,
  jac = NULL,
  ...,
  method = c("Newton", "Broyden"),
  global = c("cline", "qline", "gline", "pwldog", "dbldog", "hook", "none"),
  Nrep = 0L,
  title = NULL
)
}
\arguments{
\item{x}{A numeric vector with an initial guess of the root.}

\item{fn}{A function of \code{x} returning the function values.}

\item{jac}{A function to return the Jacobian for the \code{fn} function.
For a vector valued function \code{fn} the Jacobian must be a numeric matrix
of the correct dimensions.  For a scalar valued function \code{fn} the
\code{jac} function may return a scalar.  If not supplied numerical
derivatives will be used.}

\item{\dots}{Further arguments to be passed to \code{fn} and \code{jac} and
\code{\link{nleqslv}}.}

\item{method}{The methods to use for finding a solution.}

\item{global}{The global strategies to test. The argument may consist of
several possibly abbreviated items.}

\item{Nrep}{Number of repetitions to apply. Default is no repetitions.}

\item{title}{a description of this experiment.}
}
\value{
\code{testnslv} returns an object of class \code{"test.nleqslv"}
which is a list containing the following elements \describe{
\item{\code{call}}{the matched call} \item{\code{out}}{ a dataframe
containing the results with the following columns \describe{
\item{\code{Method}}{method used.} \item{\code{Global}}{global strategy
used.} \item{\code{termcd}}{termination code of \code{nleqslv}.}
\item{\code{Fcnt}}{number of function evaluations used by the method and
global strategy.  This excludes function evaluations made when computing a
numerical Jacobian.} \item{\code{Jcnt}}{number of Jacobian evaluations.}
\item{\code{Iter}}{number of outer iterations used by the algorithm.}
\item{\code{Message}}{a string describing the termination code in an
abbreviated form.} \item{\code{Fnorm}}{square of the euclidean norm of the
vector of function results divided by 2.} \item{\code{cpusecs}}{CPU seconds
used by the requested number of repetitions (only present when argument
\code{Nrep} is not 0).} } } \item{\code{title}}{the description if
specified} } The abbreviated strings are \describe{
\item{\code{Fcrit}}{Convergence of function values has been achieved.}
\item{\code{Xcrit}}{This means that the relative distance between two
consecutive x-values is smaller than \code{xtol}.}
\item{\code{Stalled}}{The algorithm cannot find an acceptable new point.}
\item{\code{Maxiter}}{Iteration limit \code{maxit} exceeded.}
\item{\code{Illcond}}{Jacobian is too ill-conditioned.}
\item{\code{Singular}}{Jacobian is singular.}
\item{\code{BadJac}}{Jacobian is unusable.}
\item{\code{ERROR}}{\code{nleqslv} stopped because of a fatal error.} }
}
\description{
The function tests different methods and global strategies for solving a
system of nonlinear equations with \code{nleqslv}
}
\details{
The function solves the function \code{fn} with \code{\link{nleqslv}} for
the specified methods and global strategies. When argument \code{Nrep} has
been set to a number greater than or equal to 1, repetitions of the solving
process are performed and the used CPU time in seconds is recorded.

If checking a user supplied jacobian is enabled, then \code{testnslv} will
stop immediately when a possibly incorrect jacobian is detected.
}
\section{Warning}{
 Any \code{nleqslv} error message will be displayed
immediately and an error for the particular combination of method and global
strategy will be recorded in the final dataframe.
}

\examples{

dslnex <- function(x) {
    y <- numeric(2)
    y[1] <- x[1]^2 + x[2]^2 - 2
    y[2] <- exp(x[1]-1) + x[2]^3 - 2
    y
}
xstart <- c(0.5,0.5)
fstart <- dslnex(xstart)
testnslv(xstart,dslnex)
# this will encounter an error
xstart <- c(2.0,0.5)
fstart <- dslnex(xstart)
testnslv(xstart,dslnex)

}
\keyword{nonlinear}
\keyword{optimize}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nleqslv-iterationreport.R
\name{nleqslv-iterationreport}
\alias{nleqslv-iterationreport}
\alias{Iteration-report}
\title{Detailed iteration report of nleqslv}
\description{
The format of the iteration report provided by nleqslv when the \code{trace}
component of the \code{control} argument has been set to 1.
}
\details{
All iteration reports consist of a series of columns with a header
summarising the contents. Common column headers are \describe{
\item{\code{Iter}}{Iteration counter} \item{\code{Jac}}{Jacobian type. The
Jacobian type is indicated by \code{N} for a Newton Jacobian or \code{B} for
a Broyden updated matrix; optionally followed by the letter \code{s}
indicating a totally singular matrix or the letter \code{i} indicating an
ill-conditioned matrix. Unless the Jacobian is singular, the Jacobian type
is followed by an estimate of the inverse condition number of the Jacobian
in parentheses as computed by Lapack. This column will be blank when
backtracking is active.} \item{\code{Fnorm}}{square of the euclidean norm
of function values / 2} \item{\code{Largest |f|}}{infinity norm of
\eqn{f(x)}{f(x)} at the current point} }
}
\section{Report for linesearch methods}{
 A sample iteration report for the
linesearch global methods (\code{cline}, \code{qline} and \code{gline}) is
(some intercolumn space has been removed to make the table fit)

\preformatted{
  Iter         Jac   Lambda          Ftarg         Fnorm   Largest |f|
     0                                      2.886812e+00  2.250000e+00
     1  N(9.6e-03)   1.0000   2.886235e+00  5.787362e+05  1.070841e+03
     1               0.1000   2.886754e+00  9.857947e+00  3.214799e+00
     1               0.0100   2.886806e+00  2.866321e+00  2.237878e+00
     2  B(2.2e-02)   1.0000   2.865748e+00  4.541965e+03  9.341610e+01
     2               0.1000   2.866264e+00  3.253536e+00  2.242344e+00
     2               0.0298   2.866304e+00  2.805872e+00  2.200544e+00
     3  B(5.5e-02)   1.0000   2.805311e+00  2.919089e+01  7.073082e+00
     3               0.1000   2.805816e+00  2.437606e+00  2.027297e+00
     4  B(1.0e-01)   1.0000   2.437118e+00  9.839802e-01  1.142529e+00
     5  B(1.9e-01)   1.0000   9.837834e-01  7.263320e-02  3.785249e-01
     6  B(2.2e-01)   1.0000   7.261868e-02  1.581364e-02  1.774419e-01
     7  B(1.5e-01)   1.0000   1.581047e-02  9.328284e-03  1.213052e-01
     8  B(1.7e-01)   1.0000   9.326419e-03  1.003283e-04  1.400491e-02
     9  B(1.9e-01)   1.0000   1.003082e-04  3.072159e-06  2.206943e-03
    10  B(1.5e-01)   1.0000   3.071544e-06  1.143217e-07  4.757203e-04
    11  B(1.3e-01)   1.0000   1.142989e-07  1.144686e-09  4.783197e-05
    12  B(1.2e-01)   1.0000   1.144457e-09  4.515245e-13  9.502884e-07
    13  B(1.2e-01)   1.0000   4.514342e-13  1.404463e-17  5.299876e-09
}

The column headed
by \code{Lambda} shows the value of the line search parameter. The column
headed by \code{Ftarg} follows from a sufficient decrease requirement and is
the value below which \code{Fnorm} must drop if the current step is to be
accepted.

The value of \code{Lambda} may not be lower than a threshold determined by
the setting of control parameter \code{xtol} to avoid reporting false
convergence. When no acceptable \code{Lambda} is possible and the Broyden
method is being used, a new Jacobian will be computed.
}

\section{Report for the pure method}{
 The iteration report for the global
method \code{none} is almost the same as the above report, except that the
column labelled \code{Ftarg} is omitted. The column \code{Lambda} gives the
ratio of the maximum stepsize and the length of the full Newton step. It is
either exactly 1.0, indicating that the Newton step is smaller than the
maximum stepsize and therefore used unmodified, or smaller than 1.0,
indicating that the Newton step is larger than the maximum stepsize and
therefore truncated.
}

\section{Report for the double dogleg global method}{
 A sample iteration
report for the global method \code{dbldog} is (some intercolumn space has
been removed to make the table fit)

\preformatted{
  Iter         Jac     Lambda      Eta     Dlt0     Dltn         Fnorm   Largest |f|
     0                                                    2.886812e+00  2.250000e+00
     1  N(9.6e-03) C            0.9544   0.4671   0.9343* 1.699715e-01  5.421673e-01
     1             W   0.0833   0.9544   0.9343   0.4671  1.699715e-01  5.421673e-01
     2  B(1.1e-02) W   0.1154   0.4851   0.4671   0.4671  1.277667e-01  5.043571e-01
     3  B(7.3e-02) W   0.7879   0.7289   0.4671   0.0759  5.067893e-01  7.973542e-01
     3             C            0.7289   0.0759   0.1519  5.440250e-02  2.726084e-01
     4  B(8.3e-02) W   0.5307   0.3271   0.1519   0.3037  3.576547e-02  2.657553e-01
     5  B(1.8e-01) N            0.6674   0.2191   0.4383  6.566182e-03  8.555110e-02
     6  B(1.8e-01) N            0.9801   0.0376   0.0752  4.921645e-04  3.094104e-02
     7  B(1.9e-01) N            0.7981   0.0157   0.0313  4.960629e-06  2.826064e-03
     8  B(1.6e-01) N            0.3942   0.0029   0.0058  1.545503e-08  1.757498e-04
     9  B(1.5e-01) N            0.6536   0.0001   0.0003  2.968676e-11  5.983765e-06
    10  B(1.5e-01) N            0.4730   0.0000   0.0000  4.741792e-14  2.198380e-07
    11  B(1.5e-01) N            0.9787   0.0000   0.0000  6.451792e-19  8.118586e-10
}

After the column for the Jacobian the letters indicate the following
\describe{ \item{\code{C}}{a fraction (\eqn{\le1.0}{<=1.0}) of the Cauchy
or steepest descent step is taken where the fraction is the ratio of the
trust region radius and the Cauchy steplength.} \item{\code{W}}{a convex
combination of the Cauchy and \code{eta}*(Newton step) is taken. The number
in the column headed by \code{Lambda} is the weight of the partial Newton
step.} \item{\code{P}}{a fraction (\eqn{\ge1.0}{>=1.0}) of the partial
Newton step, equal to \code{eta}*(Newton step), is taken where the fraction
is the ratio of the trust region radius and the partial Newton steplength.}
\item{\code{N}}{a normal full Newton step is taken.} } The number in the
column headed by \code{Eta} is calculated from an upper limit on the ratio
of the length of the steepest descent direction and the length of the Newton
step. See Dennis and Schnabel (1996) pp.139ff for the details. The column
headed by \code{Dlt0} gives the trust region size at the start of the
current iteration. The column headed by \code{Dltn} gives the trust region
size when the current step has been accepted by the dogleg algorithm.

The trust region size is decreased when the actual reduction of the function
value norm does not agree well with the predicted reduction from the linear
approximation of the function or does not exhibit sufficient decrease. And
increased when the actual and predicted reduction are sufficiently close.
The trust region size is not allowed to decrease beyond a threshold
determined by the setting of control parameter \code{xtol}; when that
happens the backtracking is regarded as a failure and is terminated. In that
case a new Jacobian will be calculated if the Broyden method is being used.

The current trust region step is continued with a doubled trust region size
when the actual and predicted reduction agree extremely well. This is
indicated by \code{*} immediately following the value in the column headed
by \code{Dltn}. This could save gradient calculations. However, a trial step
is never taken if the current step is a Newton step. If the trial step does
not succeed then the previous trust region size is restored by halving the
trial size. The exception is when a trial step takes a Newton step. In that
case the trust region size is immediately set to the size of the Newton step
which implies that a halving of the new size leads to a smaller size for the
trust region than before.

Normally the initial trust region radius is the same as the final trust
region radius of the previous iteration but the trust region size is
restricted by the size of the current Newton step. So when full Newton steps
are being taken, the trust region radius at the start of an iteration may be
less than the final value of the previous iteration. The double dogleg
method and the trust region updating procedure are fully explained in
sections 6.4.2 and 6.4.3 of Dennis and Schnabel (1996).
}

\section{Report for the single (Powell) dogleg global method}{
 A sample
iteration report for the global method \code{pwldog} is (some intercolumn
space has been removed to make the table fit)

\preformatted{
  Iter         Jac     Lambda     Dlt0     Dltn         Fnorm   Largest |f|
     0                                           2.886812e+00  2.250000e+00
     1  N(9.6e-03) C            0.4671   0.9343* 1.699715e-01  5.421673e-01
     1             W   0.0794   0.9343   0.4671  1.699715e-01  5.421673e-01
     2  B(1.1e-02) W   0.0559   0.4671   0.4671  1.205661e-01  4.890487e-01
     3  B(7.3e-02) W   0.5662   0.4671   0.0960  4.119560e-01  7.254441e-01
     3             W   0.0237   0.0960   0.1921  4.426507e-02  2.139252e-01
     4  B(8.8e-02) W   0.2306   0.1921   0.3842* 2.303135e-02  2.143943e-01
     4             W   0.4769   0.3842   0.1921  2.303135e-02  2.143943e-01
     5  B(1.9e-01) N            0.1375   0.2750  8.014508e-04  3.681498e-02
     6  B(1.7e-01) N            0.0162   0.0325  1.355741e-05  5.084627e-03
     7  B(1.3e-01) N            0.0070   0.0035  1.282776e-05  4.920962e-03
     8  B(1.8e-01) N            0.0028   0.0056  3.678140e-08  2.643592e-04
     9  B(1.9e-01) N            0.0001   0.0003  1.689182e-12  1.747622e-06
    10  B(1.9e-01) N            0.0000   0.0000  9.568768e-16  4.288618e-08
    11  B(1.9e-01) N            0.0000   0.0000  1.051356e-18  1.422035e-09
}

This is much simpler
than the double dogleg report, since the single dogleg takes either a
steepest descent step, a convex combination of the steepest descent and
Newton steps or a full Newton step. The number in the column \code{Lambda}
is the weight of the Newton step. The single dogleg method is a special case
of the double dogleg method with \code{eta} equal to 1. It uses the same
method of updating the trust region size as the double dogleg method.
}

\section{Report for the hook step global method}{
 A sample iteration report
for the global method \code{hook} is (some intercolumn space has been
removed to make the table fit)

\preformatted{
  Iter         Jac         mu    dnorm     Dlt0     Dltn         Fnorm   Largest |f|
     0                                                    2.886812e+00  2.250000e+00
     1  N(9.6e-03) H   0.1968   0.4909   0.4671   0.9343* 1.806293e-01  5.749418e-01
     1             H   0.0366   0.9381   0.9343   0.4671  1.806293e-01  5.749418e-01
     2  B(2.5e-02) H   0.1101   0.4745   0.4671   0.2336  1.797759e-01  5.635028e-01
     3  B(1.4e-01) H   0.0264   0.2341   0.2336   0.4671  3.768809e-02  2.063234e-01
     4  B(1.6e-01) N            0.0819   0.0819   0.1637  3.002274e-03  7.736213e-02
     5  B(1.8e-01) N            0.0513   0.0513   0.1025  5.355533e-05  1.018879e-02
     6  B(1.5e-01) N            0.0090   0.0090   0.0179  1.357039e-06  1.224357e-03
     7  B(1.5e-01) N            0.0004   0.0004   0.0008  1.846111e-09  6.070166e-05
     8  B(1.4e-01) N            0.0000   0.0000   0.0001  3.292896e-12  2.555851e-06
     9  B(1.5e-01) N            0.0000   0.0000   0.0000  7.281583e-18  3.800552e-09
}

The column headed by \code{mu} shows the
Levenberg-Marquardt parameter when the Newton step is larger than the trust
region radius. The column headed by \code{dnorm} gives the Euclidean norm of
the step (adjustment of the current \code{x}) taken by the algorithm. The
absolute value of the difference with \code{Dlt0} is less than 0.1 times the
trust region radius.

After the column for the Jacobian the letters indicate the following
\describe{ \item{\code{H}}{a Levenberg-Marquardt restricted step is taken.}
\item{\code{N}}{a normal full Newton step is taken.} } The meaning of the
columns headed by \code{Dlt0} and \code{Dltn} is identical to that of the
same columns for the double dogleg method. The method of updating the trust
region size is the same as in the double dogleg method.
}

\seealso{
\code{\link{nleqslv}}
}
